/*
 * GraphPlot.java
 *
 * Created on June 29, 2004, 12:22 AM
 */

package acquireOOP;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

/**
 *
 * @author  Rekha
 * To represent the score in the form of a graph
 */
public class GraphPlot extends CustomItem 
{
    int mu,fu,tu;
    int scale;
    Image im1=null;
    Image im2 = null;
    Image im3 = null;
    int[] surShortage;
    GraphPlot(int mineUnits,int farmUnits,int energyUnits,int[] surplusShortage)
    {
        super("Graph Plot");
        mu= mineUnits;
        fu = farmUnits;
        tu = energyUnits;
        
        surShortage = new int[surplusShortage.length];
        for(int i=0;i<surShortage.length;i++)
            surShortage[i] = surplusShortage[i];
        
        int l = calculateLargest();
        scale = l/150;
        System.out.println("scale"+scale);
        try
        {
            im1 = Image.createImage("/mining.png");
            im2 = Image.createImage("/farming.png");
            im3 = Image.createImage("/energy.png");
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }
    
    int calculateLargest()
    {
        int largest = mu;
        if(fu>largest)
        {
            largest = fu;
            if(tu > largest)
                largest = tu;
        }
        return largest;
    }
    protected int getMinContentHeight() 
    {
        return 191;
    }
    
    protected int getMinContentWidth() 
    {
        return 161;
    }
    
    protected int getPrefContentHeight(int param) 
    {
        return 191;
    }
    
    protected int getPrefContentWidth(int param) 
    {
        return 161;
    }
    
    protected void paint(Graphics g, int w, int h) 
    {
        g.setStrokeStyle(Graphics.SOLID);
        g.setColor(0,0,0);
        g.drawLine(w,h-50,0,h-50);
        
        g.drawImage(im1, (3*w)/14, h-20, Graphics.HCENTER|Graphics.VCENTER);
        g.drawImage(im2, w/2, h-20, Graphics.HCENTER|Graphics.VCENTER);
        g.drawImage(im3, (11*w)/14, h-20, Graphics.HCENTER|Graphics.VCENTER);


        int ht1 = calculateHeight(mu);
        g.drawRect(w/7,(h-50)-ht1,(w/7)-1,ht1-1);
        g.fillRect(w/7,(h-50)-ht1,(w/7)-1,ht1-1);
        int surht1 = calculateHeight(surShortage[0]);
        if(surht1 > 0)
        {
            g.setColor(0,0,255);
            g.drawRect(w/7,(h-50)-ht1,(w/7)-1,surht1-1);
            g.fillRect(w/7,(h-50)-ht1,(w/7)-1,surht1-1);
            
        }
        else if(surht1 < 0)
        {
            g.setColor(255,0,0);
            g.drawRect(w/7,(h-50)-ht1-Math.abs(surht1),(w/7)-1,Math.abs(surht1)-1);
            g.fillRect(w/7,(h-50)-ht1-Math.abs(surht1),(w/7)-1,Math.abs(surht1)-1);
        }
        
        
        g.setColor(0,0,0);
        int ht2 = calculateHeight(fu);
        g.drawRect(3*(w/7),(h-50)-ht2,(w/7)-1,ht2-1);
        g.fillRect(3*(w/7),(h-50)-ht2,(w/7)-1,ht2-1);
        int surht2 = calculateHeight(surShortage[1]);
        if(surht2 > 0)
        {
            g.setColor(0,0,255);
            g.drawRect(3*(w/7),(h-50)-ht2,(w/7)-1,surht2-1);
            g.fillRect(3*(w/7),(h-50)-ht2,(w/7)-1,surht2-1);
            
        }
        else if(surht1 < 0)
        {
            g.setColor(255,0,0);
            g.drawRect(3*(w/7),(h-50)-ht2-Math.abs(surht2),(w/7)-1,Math.abs(surht2)-1);
            g.fillRect(3*(w/7),(h-50)-ht2-Math.abs(surht2),(w/7)-1,Math.abs(surht2)-1);
        }
        

        g.setColor(0,0,0);
        int ht3 = calculateHeight(tu);
        g.drawRect(5*(w/7),(h-50)-ht3,(w/7)-1,ht3-1);
        g.fillRect(5*(w/7),(h-50)-ht3,(w/7)-1,ht3-1);
        int surht3 = calculateHeight(surShortage[2]);
        if(surht3 > 0)
        {
            g.setColor(0,0,255);
            g.drawRect(5*(w/7),(h-50)-ht3,(w/7)-1,surht3-1);
            g.fillRect(5*(w/7),(h-50)-ht3,(w/7)-1,surht3-1);
            
        }
        else if(surht1 < 0)
        {
            g.setColor(255,0,0);
            g.drawRect(5*(w/7),(h-50)-ht3-Math.abs(surht3),(w/7)-1,Math.abs(surht3)-1);
            g.fillRect(5*(w/7),(h-50)-ht3-Math.abs(surht3),(w/7)-1,Math.abs(surht3)-1);
        }
    }

    int calculateHeight(int val)
    {
        int height = val/scale;
        return height;
    }
    
}
