/*
 * HttpConnectionHelper.java
 *
 * Created on June 22, 2004, 6:19 PM
 */

package acquireOOP;

import javax.microedition.midlet.*;


import javax.microedition.io.*;
import java.io.*;


/**
 * @author Rekha
 * This is a helper class
 */
class HttpConnectionHelper 
{

	public interface Callback 
	{
		void prepareRequest(String originalURL, HttpConnection conn)
			throws IOException;
	}

	public static HttpConnection connect(String url) throws IOException 
	{
		return connect(url, null);
	}

	public static HttpConnection connect(String url, Callback callback)
		throws IOException 
		{

		String originalURL = url;

		HttpConnection conn = null;
		while (url != null) 
		{
			conn = (HttpConnection) Connector.open(url);

			if (callback != null) 
			{
				callback.prepareRequest(originalURL, conn);
			}

			int rc = conn.getResponseCode();

			switch (rc) 
			{
				case HttpConnection.HTTP_MOVED_PERM :
				case HttpConnection.HTTP_MOVED_TEMP :
				case HttpConnection.HTTP_SEE_OTHER :
				case HttpConnection.HTTP_TEMP_REDIRECT :
					url = conn.getHeaderField("Location");
					if (url != null && url.startsWith("/*")) 
					{
						StringBuffer b = new StringBuffer();
						b.append("http://");
						b.append(conn.getHost());
						b.append(':');
						b.append(conn.getPort());
						b.append(url);
						url = b.toString();
					}
					conn.close();
					break;
				default :
					url = null;
					break;
			}
		}

		return conn;
	}
}
