/*
 * LogOutStatusForm.java
 *
 * Created on August 30, 2004, 4:13 PM
 */

package acquireOOP;

import javax.microedition.midlet.*;
import java.io.*;
import javax.microedition.io.*;
import java.util.*;
import javax.microedition.lcdui.*;


/**
 *
 * @author  Rekha
 * Status of logging out
 */
public class LogOutStatusForm extends Form implements Runnable,
            HttpConnectionHelper.Callback,CommandListener
{
    int gameNumber;
    String login;
    byte[] dataToSend;
    int score;
    int position;
    int loginInGameLen;
    int loginAllGamesLen;
    String[] loginInGame;
    int[] scoreInGame;
    String[] loginAllGames;
    int[] scoreAllGames;
    
    private String getscoreUrl;
    StringItem message;
    Command[] commands;
    Runnable[] callbacks;
    
    LogOutStatusForm(int intGameNumber,String loginApproved)
    {
        super("Log Out Status");
        gameNumber = intGameNumber;
		login = new String(loginApproved);
        
        try 
        {
            ByteArrayOutputStream bout = new ByteArrayOutputStream();
            DataOutputStream dout = new DataOutputStream(bout);
            
	    	dout.writeInt(gameNumber);
            dout.writeUTF(login);
            dataToSend = bout.toByteArray();
            dout.close();
		} 
		catch (IOException e) 
		{
            System.out.println("IOException in RegistrationStatusForm" + e.toString());
		}
    }
    
    // Updates the display.
    void display(String text) 
    {
        if (message == null) 
        {
            message = new StringItem(null, text);
            append(message);
        } 
        else 
        {
            message.setText(text);
        }
    }

    // Done.
    void done(String msg) 
    {
         display(msg != null ? msg : "Done.");
         commands = acquireOOPMIDlet.getInstance().getDisplayCommands();
         for(int iter = 0 ; iter < commands.length ; iter++) 
         {
              addCommand(commands[iter]);
         }
         setCommandListener(this);
        
    }


    
    // Callback for making the HTTP connection.
    public void prepareRequest(String originalURL, HttpConnection conn)
		throws IOException 
	{
	conn.setRequestMethod(HttpConnection.POST);
	conn.setRequestProperty(
			"User-Agent",
			"Profile/MIDP-1.0 Configuration/CLDC-1.0");
	conn.setRequestProperty("Content-Language", "en-US");
	conn.setRequestProperty("Accept", "application/octet-stream");
	conn.setRequestProperty("Connection", "close");
	conn.setRequestProperty(
			"Content-Length",
			Integer.toString(dataToSend.length));

	OutputStream os = conn.openOutputStream();
	os.write(dataToSend);
	os.close();
    }

    
    public void run() 
    {
       HttpConnection conn = null;
       DataInputStream din = null;
       InputStream in = null;
       StringItem siSuccessfullLogOut = null;
       int intLogOutStatus = 0;
       display("Connecting to the server...");
       try 
       {
	       	String sip = acquireOOPMIDlet.getInstance().ServerIpAddress;
    	   	getscoreUrl = new String("http://"+sip+":8088/examples/servlet/AcquireLogOutStatusServlet");
		
            conn = HttpConnectionHelper.connect(getscoreUrl, this);
            int rc = conn.getResponseCode();
            if (rc == HttpConnection.HTTP_OK) 
            {
                 siSuccessfullLogOut = new StringItem("Successfully logged out","");
                 append(siSuccessfullLogOut);
            }
            else
            {
                System.out.println("unexpected return code"+rc);
            }
         } 
         catch (IOException e) 
         {
			System.out.println("Exception " + e + " trying to connect.");
		}
		finally
		{
         try
         {
                if(din!=null) din.close();
                if(in!=null) in.close();
                if(conn!=null) conn.close();
         }
         catch(IOException e)
         {
                
         }
        }
   }

    // Starts the upload in the background...
    void start() 
    {
	
	Thread t = new Thread(this);
	try 
	{
            t.start();
	} 
	catch (Exception e) 
	{
            System.out.println("Exception " + e + " trying to start thread.");
	}
    }
        
  public void commandAction(Command c, Displayable d)
  {
      
  }
}
