/*
 * MakeSelectionForm.java
 *
 * Created on June 24, 2004, 1:38 PM
 */

package acquireOOP;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;
import javax.microedition.io.*;
import java.io.*;
import java.util.Timer;
import java.util.TimerTask;
import javax.microedition.rms.*;
import java.lang.Integer;
import java.util.Vector;


/**
 *
 * @author  Rekha
 * Selection of a plot area
 */
public class MakeSelectionForm extends Form implements CommandListener
{
    PlotItem pt;
    Timer tm;
    SelectionTimerTask stt;
    Gauge gaShowTime;
    int locInpt;
    int [] xylocInpt;
    int xInpt;
    int yInpt;
    int nRows,nCols;
    String plotStr;
    int[][] specPlotMineVal;
    int[][] specPlotFarmVal;
    int[][] specPlotTechVal;
    
    Command CMD_ZOOM = new Command("ZOOM",Command.SCREEN,2);
    Command CMD_SELECT = new Command("SELECT",Command.SCREEN,1);
    ZoomPlotForm ZPFobj;
    ConfirmSelectionForm CSFobj;
    int sCount;
    int[] sX;
    int[] sY;
    String[] sLogin;
    String[] sColor;
    String sLoginStr = null;
    int maxVal;
    Command[] commands;
    Runnable[] callbacks;

    MakeSelectionForm(String plotsMsg,int rows,int cols,int selCount,
                        int[] selX,int[] selY, String[] selLogin,String[] selColor,String loginApproved,int curValue,int maxValue)
    {
    	super("Make a Selection");
        maxVal = maxValue;
        gaShowTime = new Gauge("Selection Time",false,maxValue,curValue);
        System.out.println(curValue);
		append(gaShowTime);         
        
		nRows = rows;
		nCols = cols;
		plotStr = new String(plotsMsg);
        sCount = selCount;

        sLoginStr = new String(loginApproved);
        if(sCount > 0)
        {
            sX =new int[sCount];
            sY =new int[sCount];
            sLogin = new String[sCount];
            sColor = new String[sCount];
            for(int i=0;i<sCount;i++)
            {
                sX[i] = selX[i];
                sY[i] = selY[i];
                sLogin[i] = new String(selLogin[i]);
                sColor[i] = new String(selColor[i]);
            }
        }

		doNextThings();
    }
    
    MakeSelectionForm(String plotsMsg,int rows,int cols,int selCount,
                        int[] selX,int[] selY, String[] selLogin,String[] selColor,String loginApproved,int maxValue)
    {
    	super("Make a Selection");
        gaShowTime = new Gauge("Selection Time", false, maxValue, 1);
        append(gaShowTime);
        maxVal  = maxValue;
   		nRows = rows;
		nCols = cols;
		plotStr = new String(plotsMsg);
        sCount = selCount;
        sLoginStr = new String(loginApproved);
        if(sCount > 0)
        {
            sX =new int[sCount];
            sY =new int[sCount];
            sLogin = new String[sCount];
            sColor = new String[sCount];
            for(int i=0;i<sCount;i++)
            {
                sX[i] = selX[i];
                sY[i] = selY[i];
                sLogin[i] = new String(selLogin[i]);
                sColor[i] = new String(selColor[i]);
            }
        }
        doNextThings();
    }


    void doNextThings()
    {    
        if(sCount == 0)
        {
            pt = new PlotItem("Plot",plotStr,nRows,nCols);
            append(pt);
        }
        else if(sCount > 0)
        {
            pt = new PlotItem("Plot",plotStr,nRows,nCols,sX,sY,sColor,sLogin);
            append(pt);
        }
        addCommand(CMD_ZOOM);  
        addCommand(CMD_SELECT);
        

        setCommandListener(this);
     	tm = new Timer();
        stt = new SelectionTimerTask();
	 	tm.scheduleAtFixedRate(stt, 0, 1000);          

    }
    
    public class SelectionTimerTask extends TimerTask
    {
      public final void run()
      {
      // Is current value of gauge less than the max?
      if (gaShowTime.getValue() < gaShowTime.getMaxValue())
         gaShowTime.setValue(gaShowTime.getValue() + 1);        
      else
	  {
         gaShowTime.setLabel("Time Up!");  
         if(acquireOOPMIDlet.getInstance().boolSelDoneBeforeTime==false){
             acquireOOPMIDlet.getInstance().showSelectionTimeUpForm();
         }
         // Stop the timer
		cancel();      
      }
     }
   }

      public void commandAction(Command c, Displayable s)
      {
          int selCount=0;
          boolean alreadySelected = false;
          String []selectLogins = null;
          String []selectColors = null;
          String []selectx = null;
          String []selecty = null;
          String selectedBy= null;
          
          if(c==CMD_ZOOM)
          {
              locInpt = pt.getLocation() ;
              xylocInpt = pt.getXYLoc(locInpt);
              xInpt = pt.getX(xylocInpt[0]);
              yInpt= pt.getY(xylocInpt[1]);
		
              specPlotMineVal = pt.getSpecPlotMineValues(xInpt,yInpt);
              specPlotFarmVal = pt.getSpecPlotFarmValues(xInpt,yInpt);
              specPlotTechVal = pt.getSpecPlotTechValues(xInpt,yInpt);
              try
              {
                 int curVal = gaShowTime.getValue();                 
                 ZPFobj = new ZoomPlotForm(specPlotMineVal,specPlotFarmVal,specPlotTechVal,curVal,maxVal,1);
                 Display.getDisplay(acquireOOPMIDlet.getInstance()).setCurrent(ZPFobj);
              }
              catch(Exception e)
              {
                 e.printStackTrace();
              }
                
          }
          else if(c==CMD_SELECT)
          {
              locInpt = pt.getLocation() ;
              xylocInpt = pt.getXYLoc(locInpt);
              xInpt = pt.getX(xylocInpt[0]);
              yInpt= pt.getY(xylocInpt[1]);
              try
              {
                 if(acquireOOPMIDlet.getInstance().mSelectedValuesRSLoaded==false)
                 {
                    acquireOOPMIDlet.getInstance().mSelectedValuesRS.load();
                    acquireOOPMIDlet.getInstance().mSelectedValuesRSLoaded=true;
                 }
                 selCount =  acquireOOPMIDlet.getInstance().mSelectedValuesRS.getSize(5);
              }
              catch(RecordStoreException rse)
              {
                 rse.printStackTrace();
              }
              if(selCount > 0)
              {
                 selectLogins = new String[selCount];
                 selectColors = new String[selCount];
                 selectx = new String[selCount];
                 selecty = new String[selCount];
                 
                 for(int i=0;i<selCount;i++)
                 {
                    selectLogins[i] = new String(acquireOOPMIDlet.getInstance().mSelectedValuesRS.get( acquireOOPMIDlet.getInstance().kSelLogin+"?"+i));
                    selectColors[i] = new String( acquireOOPMIDlet.getInstance().mSelectedValuesRS.get( acquireOOPMIDlet.getInstance().kSelColor+"?"+i));
                    selectx[i] = new String( acquireOOPMIDlet.getInstance().mSelectedValuesRS.get( acquireOOPMIDlet.getInstance().kSelX+"?"+i));
                    selecty[i] = new String( acquireOOPMIDlet.getInstance().mSelectedValuesRS.get( acquireOOPMIDlet.getInstance().kSelY+"?"+i));
                    if((Integer.parseInt(selectx[i])==xInpt)&&(Integer.parseInt(selecty[i])==yInpt))
                    {
                        alreadySelected = true;
                    }
                    if(alreadySelected == true)
                    {
                        selectedBy = new String(selectLogins[i]);
                        break;
                    }
                }
            }
            if(alreadySelected == false)
            {
                specPlotMineVal = pt.getSpecPlotMineValues(xInpt,yInpt);
                specPlotFarmVal = pt.getSpecPlotFarmValues(xInpt,yInpt);
                specPlotTechVal = pt.getSpecPlotTechValues(xInpt,yInpt);
                try
                {
                     int curVal = gaShowTime.getValue();
                     CSFobj = new ConfirmSelectionForm(specPlotMineVal,specPlotFarmVal,specPlotTechVal,curVal,maxVal,1);
                     Display.getDisplay(acquireOOPMIDlet.getInstance()).setCurrent(CSFobj);
                }
                catch(Exception e)
                {
                     e.printStackTrace();
                }

            }
            else if(alreadySelected==true)
            {
                 Alert a = new Alert("Conflict in Selection");
                 if(selectedBy.equals(sLoginStr))
                 {
                    a.setString("Plot you have selected is already selected by you");
                 }
                 else
                 {
                     a.setString("Plot you have selected is already selected by "+ selectedBy);
                 }
                 a.setTimeout(Alert.FOREVER);
                 Display.getDisplay(acquireOOPMIDlet.getInstance()).setCurrent(a);
                
            }
        }
   }
}
