/*
 * PlotItem.java
 *
 * Created on June 24, 2004, 1:33 PM
 */

package acquireOOP;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

/**
 *
 * @author  Rekha
 * Custom Item to display the land scape
 */




class PlotItem	extends CustomItem	
{

    private final static int UPPER = 0;
    private final static int IN = 1;
    private final static int LOWER = 2;
    private final static int LEFTOFLEFT = 3;
    private final static int RIGHTOFRIGHT = 4;

    // status tells us where the cursor is on the form, UPPER, IN or LOWER
    private int status = UPPER;
    
    // location tells us where the cursor is inside the item
    private int location = 1;
    int interactionMode;
    boolean horz,vert;
    String recvString;
    int xloc=-1,yloc=-1;
    String usercolor=null;
    int nRows, nCols;
    int OneFourthComponent = 64;
    int[][] plotvalues;
    int locinPT =0;
    boolean refreshflag = false;
    int [] assignedPlotsX = null;
    int [] assignedPlotsY = null;
    String [] assignedColors = null;
    String [] assignedLogins = null;
    int size = 0;

    PlotItem(String title,String recv,int rows,int cols) {
	super(title);
    recvString = new String(recv);
	nRows = rows;
	nCols = cols;
	System.out.println("in plotitem"+recvString);
	interactionMode = getInteractionModes();
	System.out.println("interaction mode"+interactionMode);
	horz = ((interactionMode & CustomItem.TRAVERSE_HORIZONTAL) != 0);
	System.out.println("horizontal interaction mode"+horz);
	vert = ((interactionMode & CustomItem.TRAVERSE_VERTICAL) != 0);
	System.out.println("vertical interaction mode"+vert);
	
	loadplotvalues();
    }

    //For refreshing the plot
    PlotItem(String title,String recv,int rows,int cols,int[] x,int[] y, String[] colors,String[] logins) 
    {
 	super(title);
	refreshflag=true; //new
	recvString = new String(recv);
	nRows = rows;
	nCols = cols;
	size = x.length;
	assignedPlotsX = new int[size];
	assignedPlotsY = new int[size];
	assignedColors = new String[size];
	assignedLogins = new String[size];
		
	for(int i=0;i<size;i++)
	{
            assignedPlotsX[i] = x[i];
            assignedPlotsY[i] = y[i];
            assignedColors[i] = new String(colors[i]);
            assignedLogins[i] = new String(logins[i]);
	}
		
	for(int i=0;i<size;i++)
	{
            System.out.println("assignedPlotsX["+i+"]"+assignedPlotsX[i]);
            System.out.println("assignedPlotsY["+i+"]"+assignedPlotsY[i]);
            System.out.println("assignedColors["+i+"]"+assignedColors[i]);
            System.out.println("assignedLogins["+i+"]"+assignedLogins[i]);
	}
		
	System.out.println("in plotitem"+recvString);
	interactionMode = getInteractionModes();
	System.out.println("interaction mode"+interactionMode);
	horz = ((interactionMode & CustomItem.TRAVERSE_HORIZONTAL) != 0);
	System.out.println("horizontal interaction mode"+horz);
	vert = ((interactionMode & CustomItem.TRAVERSE_VERTICAL) != 0);
	System.out.println("vertical interaction mode"+vert);
	
	loadplotvalues();
    }


    void loadplotvalues()
    {
	int s =nRows*nCols;
	plotvalues = new int[nRows][nCols];
	int startIndex,endIndex;
	for(int i=0;i<nRows;i++)
	{
       for(int j=0;j<nCols;j++)
       {
		String str = new String("x"+String.valueOf(i)+"y"+String.valueOf(j)+":");
		System.out.println(str.length());
        startIndex = recvString.indexOf(str)+str.length();
		endIndex = startIndex+3;
		plotvalues[i][j] = Integer.parseInt(recvString.substring(startIndex,endIndex));
       }
	}
     
	for(int i=0;i<nRows;i++)
	{
     for (int j=0;j<nCols;j++)
     {
		System.out.print("i"+i+"j"+j+plotvalues[i][j]+"  ");     
     }
     System.out.println();
  	}
    	
    }

    protected int getMinContentHeight() 
    {
	return 161;
    }
    
    protected int getMinContentWidth() 
    {
	return 161;
    }

    protected int getPrefContentHeight(int width) 
    {
	return 161;
    }

    protected int getPrefContentWidth(int height) 
    {
	return 161;
    }

    protected void paint(Graphics g, int w, int h) 
    {
    drawPlots(g,plotvalues,w,h);     
	//if refresh plot has been called it goes to the second constructor
	if((refreshflag==true))
	{
      drawAssignedPlots(g);
	}
    drawCursor(g);
    }	    
	 
    void drawAssignedPlots(Graphics g)
    {
        Image im=null;
        for(int i=0;i<assignedPlotsX.length ;i++)
        {
             int x1 = getguiX(assignedPlotsX[i]);
             int y1 = getguiY(assignedPlotsY[i]);

             if (assignedColors[i].equals("red"))
             {
		 	   g.setColor(255,0,0);
                 try
                 {
                   im = Image.createImage("/pengu.png");
                 }
                 catch(Exception e)
                 {
                   System.out.println("Could not get pengu");
                 }
                 if(im!=null)
                    g.drawImage(im, x1+16, y1+16, Graphics.HCENTER|Graphics.VCENTER);
            }
            else if(assignedColors[i].equals("green"))
            {
			  g.setColor(0,255,0);
                try
                {
                  im = Image.createImage("/alien.png");
                }
                catch(Exception e)
                {
                  System.out.println("Could not get alien");
                }
                if(im!=null)
                    g.drawImage(im, x1+16, y1+16, Graphics.HCENTER|Graphics.VCENTER);
                               
	    	}
	    	else if(assignedColors[i].equals("blue"))
	    	{
			  g.setColor(0,0,255);
                try
                {
                     im = Image.createImage("/square.png");
                }
                catch(Exception e)
                {
                     System.out.println("Could not get square");
                }
                if(im!=null)
                     g.drawImage(im, x1+16, y1+16, Graphics.HCENTER|Graphics.VCENTER);
                               
	    	}
	    	else if(assignedColors[i].equals("black"))
	    	{
			  g.setColor(0,0,0);
                try
                {
                   im = Image.createImage("/antty.png");
                }
                catch(Exception e)
                {
                   System.out.println("Could not get antty");    
                }
                if(im!=null)
                     g.drawImage(im, x1+16, y1+16, Graphics.HCENTER|Graphics.VCENTER);
            }
            else if(assignedColors[i].equals("not_valid"))
            {
                try
                {
                    im = Image.createImage("/loggedout.png");
                }
                catch(Exception e)
                {
                    System.out.println("could not get loggedout image");
                }
                if(im!=null)
                    g.drawImage(im,x1+16,y1+16,Graphics.HCENTER|Graphics.VCENTER);
            }
	}
		
    }
	 
    //Drawing the Cursor
    void drawCursor(Graphics g)
    {
	  g.setStrokeStyle(Graphics.SOLID);
	  g.setColor(255,255,255);
     
	  if (location==1) g.drawRect(0, 0, 32, 32);
	  else if (location==2) g.drawRect(0, 32, 32, 32);
	  else if (location==3) g.drawRect(0, 64, 32, 32);
	  else if (location==4) g.drawRect(0, 96, 32, 32);
	  else if (location==5) g.drawRect(0, 128, 32, 32);
	  else if (location==6) g.drawRect(32, 0, 32, 32);
	  else if (location==7) g.drawRect(32, 32, 32, 32);
	  else if (location==8) g.drawRect(32, 64, 32, 32);
	  else if (location==9) g.drawRect(32,96, 32, 32);
	  else if (location==10) g.drawRect(32, 128, 32, 32);
	  else if (location==11) g.drawRect(64, 0, 32, 32);
	  else if (location==12) g.drawRect(64, 32, 32, 32);
	  else if (location==13) g.drawRect(64, 64, 32, 32);
	  else if (location==14) g.drawRect(64,96, 32, 32);
	  else if (location==15) g.drawRect(64, 128, 32, 32);
	  else if (location==16) g.drawRect(96, 0, 32, 32);
	  else if (location==17) g.drawRect(96, 32, 32, 32);
	  else if (location==18) g.drawRect(96, 64, 32, 32);
	  else if (location==19) g.drawRect(96,96, 32, 32);
	  else if (location==20) g.drawRect(96, 128, 32, 32);
	  else if (location==21) g.drawRect(128, 0, 32, 32);
	  else if (location==22) g.drawRect(128, 32, 32, 32);
	  else if (location==23) g.drawRect(128, 64, 32, 32);
	  else if (location==24) g.drawRect(128,96, 32, 32);
	  else if (location==25) g.drawRect(128, 128, 32, 32);
   }


    // Draw the plots
    void drawPlots(Graphics g,int[][] plotvalues,int w,int h)
    {
	//Draw the plots
        g.setStrokeStyle(Graphics.DOTTED);
		for (int x=0; x<h-32; x=x+32)
		{
            for(int y=0; y<w-32; y=y+32)
            {
              g.drawRect(x,y,32,32);
			  int avgmine,avgfarm,avgtech;
		      int k=0,l=0;
		      k = getX(x);
              l = getY(y);				
		      avgmine = getAvgMine(k,l);
		      avgfarm = getAvgFarm (k,l);
		      avgtech = getAvgTech(k,l);
		      g.setColor(avgmine*OneFourthComponent,avgfarm*OneFourthComponent,avgtech*OneFourthComponent);
              System.out.println("x"+x+"y"+y+"*"+avgmine*OneFourthComponent+"*"+avgfarm*OneFourthComponent+"*"+avgtech*OneFourthComponent);
		      g.fillRect(x,y,32,32);
            }
		}
    }
	
    //Average Mine Value of the 3 * 3 rectangle
    public int getAvgMine(int k,int l)
    {
	int totalmine=0;
	int [][] minevalue = new int[3][3];
	minevalue = getSpecPlotMineValues( k, l);
    for(int i=0;i<3;i++)
    {
       for(int j=0;j<3;j++)
       {
		totalmine = totalmine + minevalue[i][j];  
       }
    }
		
	int avgmine = totalmine/9;
	return avgmine;
    }
	
    //THe specific Mine values of the 3*3 rectangle
    public int[][] getSpecPlotMineValues(int k,int l)
    {
	int index =0;
	int[][] minevalue= new int[3][3];
	for(int i=k,m=0;i<k+3;i++,m++)
	{
	   for(int j=l,n=0;j<l+3;j++,n++)
	   {
		 minevalue[m][n] = plotvalues[i][j]/100;
		 
	   }
	}
	return minevalue;
    }
	
    //The Average of speciifc Farm Values of the 3 * 3 rectangle
    public int getAvgFarm(int k,int l)
    {
	int totalfarm = 0;
	int [][] farmvalue = new int[3][3];
	farmvalue = getSpecPlotFarmValues( k, l);

	for(int i=0;i<3;i++)
	{
      for(int j=0;j<3;j++)
      {
		totalfarm = totalfarm + farmvalue[i][j];  
      }
	}
	int avgfarm = totalfarm/9;
    return avgfarm;		
    }	

    //speciifc Farm Values of the 3 * 3 rectangle
    public int[][] getSpecPlotFarmValues(int k,int l)
    {
	int index =0;
	int[][] farmvalue= new int[3][3];
	for(int i=k,m=0;i<k+3;i++,m++)
	{
      for(int j=l,n=0;j<l+3;j++,n++)
      {
		farmvalue[m][n] =(plotvalues[i][j]%100)/10;
      }
	}
	return farmvalue;
    }
		
    //Average of speciifc Farm Values of the 3 * 3 rectangle			
    public int getAvgTech (int k,int l)
    {
    int[][] techvalue= new int[3][3];
	int totaltech=0;
	techvalue = getSpecPlotTechValues( k, l);
	for(int i=0;i<3;i++)
	{
            for(int j=0;j<3;j++)
            {
                totaltech = totaltech + techvalue[i][j];
            }  
	}
	int avgtech = totaltech/9;
    return avgtech;		
    }
    
    //speciifc Farm Values of the 3 * 3 rectangle
    public int[][] getSpecPlotTechValues(int k,int l)
    {
	int index =0;
	int[][] techvalue= new int[3][3];
	for(int i=k,m=0;i<k+3;i++,m++)
	{
      for(int j=l,n=0;j<l+3;j++,n++)
      {
		techvalue[m][n] = (plotvalues[i][j]%100)%10;
      }
	}
	return techvalue;
    }

    public int getguiX (int x)
    {
 	int guiX = 0;
 	int factor = 0;
 	int cellheight = nCols/5;
 	if(x==0) 
            guiX = 0;
 	else
 	{
            factor = x/cellheight;
            guiX = factor * 32;
 	}
 	return guiX;
    }

    public int getguiY (int y)
    {
	int guiY = 0;
	int factor = 0;
	int cellwidth = nRows/5;
	if(y==0) 
            guiY = 0;
	else 
	{
            factor = y/cellwidth;
            guiY = factor * 32;
	}
	return guiY;
   }

   //Get X value corresponding to the GUI and the actual values
   public int getX(int x)
   {
   	int xVal=0;
	int cellheight = nCols/5;
	if(x==0) xVal= 0;
	else if(x==32) xVal = cellheight;
	else if(x==64) xVal = 2*cellheight;
	else if(x==96) xVal=3*cellheight;
	else if(x==128) xVal=4*cellheight;
	return xVal;
   }
   
  // Get y value corresponding to the GUI and the actual values
   public int getY(int y)
   {
  	int yVal=0;
	int cellwidth = nRows/5;
	if(y==0) yVal= 0;
	else if(y==32)yVal = cellwidth;
	else if(y==64)yVal = 2*cellwidth;
	else if(y==96)yVal=3*cellwidth;
	else if(y==128)yVal=4*cellwidth;
	return yVal;
   }

   //Traverse
   protected boolean traverse(int dir, int viewportWidth, int viewportHeight,
								   int[] visRect_inout) 
	{
	if (vert)
	{
            switch (dir)  
            {
        	case Canvas.DOWN:
                   if (status == UPPER) 
                   {
                        status = IN;
                   } 
                   else 
                   {
                        if (location==1) location=6;
                        else if(location==6) location=11;
                        else if(location==11) location=16;
                    	else if(location==16) location=21;
                        else if(location==21) location =22;
                        else if (location==22) location=17;
                        else if(location==17) location=12;
                        else if(location==12) location=7;
                        else if(location==7) location=2;
                        else if(location==2) location=3;
                        else if (location==3) location=8;
                        else if(location==8) location=13;
                        else if(location==13) location=18;
                        else if(location==18) location=23;
                        else if(location==23) location=24;
                        else if (location==24) location=19;
                        else if(location==19) location=14;
                        else if(location==14) location=9;
                        else if(location==9) location=4;
                        else if(location==4) location=5;
                        else if (location==5) location=10;
                        else if(location==10) location=15;
                        else if(location==15) location=20;
                        else if(location==20) location=25;
                        else if(location==25) return false;
                    }
		    repaint();
		    break;
		case Canvas.UP:
                    if (status == LOWER) 
                    {
		        	status = IN;
                    } 
                    else 
                    {
                        if (location==6) location=1;
						else if(location==11) location=6;
						else if(location==16) location=11;
						else if(location==21) location=16;
						else if (location==1) return false;
						else if (location==7) location=12;
						else if(location==12) location=17;
						else if(location==17) location=22;
						else if(location==22) location=21;
						else if(location==2) location=7;
						else if (location==23) location=18;
						else if(location==18) location=13;
						else if(location==13) location=8;
						else if(location==8) location=3;
						else if(location==3) location=2;
						else if (location==9) location=14;
						else if(location==14) location=19;
						else if(location==19) location=24;
						else if(location==24) location=23;
						else if(location==4) location=9;
						else if (location==10) location=5;
						else if(location==15) location=10;
						else if(location==20) location=15;
						else if(location==25) location=20;
						else if(location==5) location=4;
                    }
		    repaint();
		    break;
		  }   
        }
	return true;
    }
		
     public int getLocation()
     {
          return location;     
     }
   
     public int[] getXYLoc(int loc)
     {
             int x=0,y=0;
             int[] xy = new int[2];
             if (loc==1 )
             {
				x=0;y=0; 
             }
             else if (loc==2 )
             {
				x=0;y=32; 
	 		 }
	 		 else if (loc==3 )
	 		 {
				x=0;y=64; 
	 		 }
	 		 else if (loc==4 )
	 		 {
				x=0;y=96; 
             }
             else if (loc==5 )
             {
				x=0;y=128; 
	 		 }
	 		 else if (loc==6 )
	 		 {
				x=32;y=0; 
	 		 }
	 		 else if (loc==7 )
	 		 {
				x=32;y=32; 
	 		 }
	 		 else if (loc==8 )
	 		 {
				x=32;y=64; 
	 		 }
	 		 else if (loc==9 )
	 		 {
				x=32;y=96; 
	 		 }
	 		 else if (loc==10 )
	 		 {
				x=32;y=128; 
	 		 }
	 		 else if (loc==11 )
	 		 {
				x=64;y=0; 
	 		 }
	 		 else if (loc==12 )
	 		 {
				x=64;y=32; 
	 		 }
	 		 else if (loc==13 )
	 		 {
				x=64;y=64; 
	         }
	         else if (loc==14 )
	         {
		        x=64;y=96; 
	 		 }
	 		 else if (loc==15 )
	 		 {
				x=64;y=128; 
	 		 }
	 		 else if (loc==16 )
	 		 {
				x=96;y=0; 
			 }
			 else if (loc==17 )
			 {
				x=96;y=32; 
			 }
			 else if (loc==18 )
			 {
				x=96;y=64; 
			 }
			 else if (loc==19 )
			 {
				x=96;y=96; 
			 }
			 else if (loc==20 )
			 {
				x=96;y=128; 
			 }
			 else if (loc==21 )
			 {
				x=128;y=0; 
			 }
			 else if (loc==22 )
			 {
				x=128;y=32; 
			 }
			 else if (loc==23 )
			 {
				x=128;y=64; 
			 }
			 else if (loc==24 )
			 {
	 			x=128;y=96; 
 			 }
 			 else if (loc==25 )
 			 {
	 		    x=128;y=128; 
 			 }
            xy[0] = x;
            xy[1] = y;
            return xy;
    }
}


