/*
 * RecordStores.java
 *
 * Created on June 24, 2004, 1:13 PM
 */

package acquireOOP;


import javax.microedition.midlet.*;
import java.util.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;


/**
 *
 * @author  Rekha
 * This is the class that acts as a helper class for storing and retreiving 
 * the records in the record store
 */


public class RecordStores 
{
	
	private String mRecordStoreName;
	private Hashtable mHashtable;
	String countStr = null;
    Vector vCount = null;

	public RecordStores(String recordStoreName)
	 		throws RecordStoreException
	{
		mRecordStoreName = recordStoreName;
		mHashtable = new Hashtable();

	}
	
	public void load() throws RecordStoreException
	{
		RecordStore rs = null;
		RecordEnumeration re = null;
                
		try
		{
			rs = RecordStore.openRecordStore( mRecordStoreName,true);
			re = rs.enumerateRecords( null,null,false);
			while(re.hasNextElement())
			{
				byte[] raw = re.nextRecord();
				String pref = new String(raw);
				//parse
				int index = pref.indexOf('|');
				String name = pref.substring(0,index);
                                String value = pref.substring(index+1);
				put(name,value);
                                
			}
		}
		finally
		{
			if(re != null) re.destroy();
			if(rs != null) rs.closeRecordStore();
		}
                
	}
	
	public void put(String key,String value)
	{
            mHashtable.put(key,value);
	}
        
        
    public int getSize(int indicesCount)
    {
          return mHashtable.size()/indicesCount;
    }
        
    public String get(String key)
    {
    	  return (String)mHashtable.get(key);
	}

    public void del(String key) throws RecordStoreException
    {
         mHashtable.remove(key);
    }
        
    public void delete() throws RecordStoreException
    {
            RecordStore rs = null;
            RecordEnumeration re =null;
            
            try
            {
               rs = RecordStore.openRecordStore( mRecordStoreName,true);
               re = rs.enumerateRecords( null,null,false);
               while(re.hasNextElement())
               {
                   int id = re.nextRecordId();
                   rs.deleteRecord(id);
                   System.out.println("deleted record"+id);
               }
               Enumeration keys = mHashtable.keys();
               while(keys.hasMoreElements() )
               {
                    String key = (String)keys.nextElement();
                    mHashtable.remove(key);
                    System.out.println("deleted record"+key);
               }

                
            }
            finally
            {
			if(re != null) re.destroy();
			if(rs != null) rs.closeRecordStore();
		    }

        }
	public void save()throws RecordStoreException
	{
		RecordStore rs= null;
		RecordEnumeration re = null;
		try
		{
                    rs = RecordStore.openRecordStore( mRecordStoreName,true);
                    re = rs.enumerateRecords( null,null,false);
			
                    Enumeration keys = mHashtable.keys();
                    while(keys.hasMoreElements() )
                    {
                    	String key = (String)keys.nextElement();
						String value = get(key);
						String pref = key+"|"+value;
						byte[] raw = pref.getBytes();
						rs.addRecord(raw,0,raw.length);
                    }
                }
				finally
				{
					if(re != null) re.destroy();
					if(rs != null) rs.closeRecordStore();
				}
	}
	
}
	


