/*
 * acquireOOPMIDlet.java
 * 
 */

package acquireOOP;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;
import javax.microedition.io.*;
import java.io.*;
import java.util.Timer;
import java.util.TimerTask;
import javax.microedition.rms.*;
import java.lang.Integer;
import java.util.Vector;


/**
 * This is the MIDlet class that controls the functioning of the 
 * whole application. Most of the commands are handled in this class
 * This MIDlet class contains the functions startApp(), pauseApp(),
 * destroyApp() which are the key function in the MIDlet lifecycle
 * 
 * @author  Sumi
 * @version
 */
public class acquireOOPMIDlet extends MIDlet implements CommandListener
{
    private Display display;    // The display for this MIDlet
    private static acquireOOPMIDlet instance ;
    private Displayable currentForm = null;
    private Form ui_form;
    
    private Command CMD_START= new Command("START",Command.SCREEN,1);
    private Command CMD_EXIT= new Command("EXIT",Command.EXIT,1);
    
    //Declarations of all the Forms in the User Interface 
    ServerIPAddress SIPobj;
    AuthorizationForm AFobj;
    RegistrationForm RFobj;
    LoginForm LFobj;
    RegistrationStatusForm RSFobj;
    LoginCheckGetGamesList LCGGLobj;
    JoinGameStatusForm JGSFobj;
    JoinGameStatusForm WJGSFobj;
    GetLandScapeForm GLSFobj;
    PlayForm PFobj;
    IntroForm IFobj;
    LoginIncorrectForm LIFobj;
    GamesListForm GLFobj;
    RegistrationConfirmForm RCFobj;
    LoginInUseForm LIUFobj;
    MakeSelectionForm MSFobj;
    SelectionTimeUpForm STUFobj;
    SelectionStatusForm SSFobj;
    SelectStepNotOverForm SSNOFobj;
    SelectionResultForm SRFobj;
    SelectionStatusForm ISSFobj;
    ConfigurationForm CFFobj;
    ConfigurationTimeUpForm CTUFobj;
    ConfigureSpecificPlotForm CSPFobj;
    NoConfigAllowedForm SNCAFobj;
    ConfigurationDoneStatusForm CONFDSFobj;
    DeclareBuyerSellerForm DBSFobj;
    SubmitBuyerSellerDeclarationStatusForm SBSDSFobj;
    BuyersSellersListForm BSLFobj;
    SubmitBuyUnitsDoTradeStatusForm SBUDTSFobj; 
    AuctionResultForm ARFobj;
    GetProperties GPobj;
    ConfigureAllForm CAFobj;
    GetScoreStatus GSSobj;
    ConfigurationResultForm CONFRFobj;
    LogOutStatusForm LOSFobj;
    
    String ServerIpAddress = null;
    RecordStores mGameLoginRS;
    protected static String kLogin = "Login";
    protected static String kGameNo = "GameNo";
    boolean mGameLoginRSLoaded = false;
    
    RecordStores mSelectedValuesRS;
    protected static String kSelX = "selX";
    protected static String kSelY = "selY";
    protected static String kSelLogin = "selLogin";
    protected static String kSelColor = "selColor";
    protected static String kSelConfDone = "selConfDone";
    boolean mSelectedValuesRSLoaded= false;
    
    RecordStores mGamePlotRS;
    protected static final String kGame = "game";
    protected static final String kPlot = "plot";
    protected static final String kRows = "rows";
    protected static final String kCols = "cols"; 
    boolean mGamePlotRSLoaded  = false;
    
    RecordStores mConfigurationDetailsRS;
    protected static final String kConfX = "confX";
    protected static final String kConfY = "confY";
    protected static final String kConfTime = "confTime";
    protected static final String kConfIndex = "confIndex"; 
    boolean mConfigurationDetailsRSLoaded = false;
    
   
    int MaxNoOfPlayers;
    int initialValue ;
    int maxValue ;
    int initConfValue;
    int maxConfValue;
    int initDeclareValue;
    int maxDeclareValue;
    
    boolean boolConfDoneBeforeTime= false;
    boolean boolSelDoneBeforeTime= false;
    boolean boolDeclDoneBeforeTime= false;
    int configAllowedOrNot=1;
    int RoundNo= 1;

   
    static final int NONE = 0;
    final static int MAKE_SELECTION_STATE = 1;
    final static int SELECTION_RESULT_STATE = 2;
    final static int START_CONFIGURATION_STATE = 3;
    final static int CONFIGURATION_FINISHED_STATE = 4;
    final static int AUCTION_DECLARATION_STATE = 5;
    final static int AUCTION_DECLARATION_RESULT_STATE = 6;
    final static int AUCTION_RESULT_STATE=7;
    
    int pending_state = NONE;
    int current_state = NONE;
     
    public void startApp() 
    {
        instance = this;
        ui_form = new Form ("Acquire Game");
        ui_form.addCommand(CMD_START);
        ui_form.addCommand(CMD_EXIT);
        Display.getDisplay(this).setCurrent(ui_form);
        ui_form.setCommandListener(this) ;
        deleteRecordsInRecordStores();
    }

    public void deleteRecordsInRecordStores()
    {
        try
        {
          mGameLoginRS = new RecordStores("GameLogin");
          mGameLoginRS.delete();
          mSelectedValuesRS = new RecordStores("SelectedValues");
          mSelectedValuesRS.delete();
          mGamePlotRS = new RecordStores("GamePlot");
          mGamePlotRS.delete();
          mConfigurationDetailsRS = new RecordStores("ConfigurationDetails");
          mConfigurationDetailsRS.delete();
        }
        catch(RecordStoreException e)
        {
            e.printStackTrace();
        }
    }

    private static Class getClassObject(String className) 
    {
         try 
         {
            return(Class.forName(className));
         }catch(Throwable err) 
         {
             System.out.println(err.getClass().getName() + ": " +
                                    err.getMessage());
             err.printStackTrace();
         }
         return(null);
    }

    static acquireOOPMIDlet getInstance()
    {
        if(instance==null)
           instance = new acquireOOPMIDlet();
        return instance;
    }
    
    public acquireOOPMIDlet() 
    {

    }
   
    /**
     * Pause is a no-op since there are no background activities or
     * record stores that need to be closed.
     */
    public void pauseApp() {
    
    }
    
    /**
     * Destroy must cleanup everything not handled by the garbage collector.
     * In this case there is nothing to cleanup.
     */
    public void destroyApp(boolean unconditional) 
    {
    
    }
    
    /*
     * Respond to commands, including exit
     * On the exit command, cleanup and notify that the MIDlet has been destroyed.
     */
    public void commandAction(Command c, Displayable s) 
    {
        if (c == CMD_START) 
        {
            try
            {
        		SIPobj = new ServerIPAddress();
				Display.getDisplay(this).setCurrent(SIPobj);            	
            	
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
        }
        else if(c == CMD_EXIT)
        {
            destroyApp(false);
            notifyDestroyed();
        }
    }
    
      Command[] getServerIPAddressCommands(){
  	     Command[] ServCommands = {
                new Command("SUBMIT",Command.SCREEN,1)
                
        };
        return(ServCommands);
  }
  
  
  Runnable[] getServerIPAddressActions(){
  	     class ServerIPCallback implements Runnable {
               public void run() {
                    gotoGetProperties();
               }
        }
   
        Runnable[] callbacks = {
                new ServerIPCallback()
                
            };
        return(callbacks);
  }
  
  void gotoGetProperties(){
  		
		ServerIpAddress = new String(SIPobj.getServerIPAddress());  	    
  		try{
  			GPobj = new GetProperties();
            Display.getDisplay(this).setCurrent(GPobj);
        }catch(Exception e){
        	e.printStackTrace();
        }
        GPobj.start();
  	
  }
   

    
   Displayable getCurrentForm() 
   {
        return(currentForm);
   }

    
   void showAuthorizationForm()
   {
      try
      {
         setPropertiesOfGame();
         AFobj = new AuthorizationForm();
         System.out.println("came here 1");
         System.out.println("came here 2");
         Display.getDisplay(this).setCurrent(AFobj);
      }
      catch(Exception e)
      {
         Alert a = new Alert("Error");
         a.setString("Failed in handling the Authorization Form");
         a.setTimeout(Alert.FOREVER);
        Display.getDisplay(this).setCurrent(a);
     }
   }
   
   void setPropertiesOfGame()
   {
       int np = GPobj.noofProperties;
       String[]  keys = null;
       String[] values = null;
       if(np > 0) 
       {
           keys = new String[np];
           values = new String[np];
           for(int i=0;i<np;i++)
           {
               keys[i] = new String(GPobj.keys[i]);
               values[i] =new String(GPobj.values[i]);
               if(keys[i].equals("MaxNoOfPlayers"))
               {
                    MaxNoOfPlayers = Integer.parseInt(values[i]);
               }else if(keys[i].equals("DeclareTime"))
               {
                    maxDeclareValue = Integer.parseInt(values[i]);
               }else if(keys[i].equals("SelectionTime"))
               {
                   maxValue = Integer.parseInt(values[i]); 
               }else if(keys[i].equals("ConfigTime")){
                   maxConfValue = Integer.parseInt(values[i]);//140
               }
            }
       }
   }
   
  /**Authorization Form Commands and Actions**/
  Command[] getAuthorizationFormCommands() 
  {
        Command[] AuthCommands = {
                new Command("REGISTER",Command.SCREEN,1),
                new Command("LOGIN",Command.SCREEN ,1),
        };
        return(AuthCommands);
  }

  Runnable[] getAuthorizationFormActions()
  {
       
      class RegisterCallback implements Runnable 
      {
           public void run() 
           {
               gotoRegistration();
           }
      }
   
      class LoginCallback implements Runnable 
      {
           public void run() 
           {
               gotoLogin();
           }
      }

      Runnable[] callbacks = {
            new RegisterCallback(),
            new LoginCallback()
      };
       
      return(callbacks);
    }


   public void gotoRegistration()
   {
        try 
        {
            RFobj = new RegistrationForm();
            Display.getDisplay(this).setCurrent(RFobj);
        }
        catch(Exception err) 
        {
            Alert a = new Alert("Error");
            a.setString("Failed in handling the Authorization Form");
            a.setTimeout(Alert.FOREVER);
            Display.getDisplay(this).setCurrent(a);
        }
    }

    public void gotoLogin()
    {
        try 
        {
            LFobj = new LoginForm();
            Display.getDisplay(this).setCurrent(LFobj);
        }
        catch(Exception err) 
        {
            Alert a = new Alert("Error");
            a.setString("Failed in handling the Authorization Form");
            a.setTimeout(Alert.FOREVER);
            Display.getDisplay(this).setCurrent(a);
        }
    }
    

   /**Registration Form Commands and Actions**/
   Command[] getRegistrationFormCommands() 
   {
       Command[] RegistrationCommands = {
             new Command("SUBMIT",Command.SCREEN,1),
       };
       return(RegistrationCommands);
   }


   Runnable[] getRegistrationFormActions()
   {
        class SubmitRegisterCallback implements Runnable 
        {
            public void run() 
            {
               doRegistration();
            }
        }
        Runnable[] callbacks = {
                new SubmitRegisterCallback()
        };
        return(callbacks);
    }

    public void doRegistration()
    {
        System.out.println("Submit Registration");
        String login = RFobj.getLogin();
        String pwd = RFobj.getPassword();
        String[] infoStrings = new String[2];
        infoStrings[0] = login;
        infoStrings[1] = pwd;
        try
        {
            RSFobj = new RegistrationStatusForm(infoStrings);
            Display.getDisplay(this).setCurrent(RSFobj);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        RSFobj.start();
    }

   /**Registration Confirmed Form Commands and Actions**/
   Command[] getRegistrationConfirmedCommands()
   {
       Command[] RegConfirmedCommands = {
                new Command("LOGIN",Command.SCREEN,1)
       };
       return RegConfirmedCommands;
   }
    
   Runnable[] getRegistrationConfirmedActions()
   {
        class TryRegisterCallback implements Runnable 
        {
            public void run() 
            {
               gotoLogin();
            }
        }
        Runnable[] callbacks = {
                new TryRegisterCallback()
        };
        return(callbacks);
   }
  
   public void doLogin()
   {
       System.out.println("Do login Check");
       String loginStrings[] = new String[2];
        
	   loginStrings[0] = LFobj.getLogin();
	   loginStrings[1] = LFobj.getPassword();
	   for(int i=0;i<1;i++)
	   {
		 System.out.println(loginStrings[i]+"\n");
	   } 
	   System.out.println("doLoginCheck&get the games list ");	
	
       try
       {
            LCGGLobj = new LoginCheckGetGamesList(loginStrings);
            Display.getDisplay(this).setCurrent(LCGGLobj);
       }catch(Exception e){
            e.printStackTrace();
       }
       LCGGLobj.start();
    }


   
   /**Registration Not Confirmed Form Commands and Actions**/
   Command[] getRegistrationNotConfirmedCommands()
   {
       Command[] RegNotCOnfimedCommands = {
                new Command("REGISTER",Command.SCREEN,1)
       };
       return RegNotCOnfimedCommands;
   }

   Runnable[] getRegistrationNotConfirmedActions()
   {
       class LoginAfterRegisterCallback implements Runnable
       {
           public void run()
           {
               gotoRegistration();
           }
       }
       Runnable [] callbacks = {
           new LoginAfterRegisterCallback()
       };
       return(callbacks);
   }


   /**Login Form Commands and Actions**/
   Command[] getLoginFormCommands()
   {
       Command[] SubmitLoginCommands ={
           new Command("SUBMIT LOGIN",Command.SCREEN,1)
       };
       return SubmitLoginCommands;
   }
   
   Runnable[] getLoginFormActions()
   {
       class DoLoginCallback implements Runnable{
           public void run(){
               doLogin();
           }
       }
       Runnable [] callbacks = {
           new DoLoginCallback()
       };
       return(callbacks);
   }


   /**Display Form for use in all the servlets Commands and Actions**/
   Command [] getDisplayCommands()
   {
       Command[] okCommand = {
           new Command("OK",Command.OK,1)
       };
       return okCommand;
   }

   /**Login Check Invalid Form Commands and Actions**/
   Command [] getLoginCheckInvalidCommands()
   {
       	Command[] LoginCheckInvalid ={
             new Command("TRY LOGIN",Command.SCREEN,1),
             new Command("REGISTER",Command.SCREEN,1)
        };			
        return LoginCheckInvalid;
   }
   
   Runnable[] getLoginCheckInvalidActions()
   {
       class TryLoginCallback implements Runnable
       {
           public void run()
           {
               gotoLogin();
           }
       }
       class TryRegisterCallback implements Runnable 
       {
            public void run() 
            {
               gotoRegistration();
            }
        }
        
        Runnable[] callbacks = {
            new TryLoginCallback(),
            new TryRegisterCallback()
        
        };
        return(callbacks);
   }

   
   /**Play Form IntroForm Commands and Actions**/
   Command [] getPlayNowCommands()
   {
       Command[] getplayCommand ={
           new Command("PLAY",Command.SCREEN,1)
       };
       return getplayCommand;
   }
   
   Runnable[] getPlayNowActions()
   {
      class PlayCallback implements Runnable
      {
            public void run()
            {
               playGame();
            }
       }
       Runnable[] callbacks = {
            new PlayCallback()
    
      };
      return(callbacks);
   }
   
   void playGame()
   {
      try
      {
          IFobj = new IntroForm();
          Display.getDisplay(this).setCurrent(IFobj);
      }
      catch(Exception e)
      {
          e.printStackTrace();
      }
   }
 
   /*Start New Game */
   Command [] getStartNewGameCommand()
   {
       Command[] startNewGameCommand = {
           new Command("START NEW GAME",Command.SCREEN,1)
       };
       return startNewGameCommand;
   }

   Runnable[] getStartNewGameActions()
   {
       class StartNewGameCallback implements Runnable
       {
            public void run()
            {
               joinNewGame();
            }
       }
       Runnable[] callbacks = {
            new StartNewGameCallback()
       };
      return(callbacks);
   }
   
   public void joinNewGame()
   {
        System.out.println("Start a new Game");
        String loginApproved = null;
        try
        {
           if(mGameLoginRSLoaded ==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded=true;
           }
           loginApproved = new String(mGameLoginRS.get(kLogin));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
        
       try
       {
           JGSFobj = new JoinGameStatusForm(loginApproved);
           Display.getDisplay(this).setCurrent(JGSFobj);
       }
       catch(Exception e)
       {
            e.printStackTrace();
       }
       JGSFobj.start();
   }

   /* Introduction Form Commands and Actions*/
   Command[] getIntroFormCommands()
   {
       Command[] introFormCommand = {
           new Command("Go to Selection",Command.SCREEN,1)
       };
       return introFormCommand;
   }

  Runnable [] getIntroFormActions() 
  {
       class IntroCallback implements Runnable
       {
           public void run()
           {
               createNewGame();
           }
       }
       Runnable [] callbacks = {
    	       new IntroCallback()
       };
       return callbacks;
   }

   /*go to selection form*/
   void createNewGame()
   {
       String loginApproved=null;
       String strGameNumber=null;
       int intGameNumber=0;
       try
       {
           if(mGameLoginRSLoaded ==false)
           {
              mGameLoginRS.load();
              mGameLoginRSLoaded=true;
           }
           strGameNumber = new String(mGameLoginRS.get(kGameNo));
           intGameNumber = Integer.parseInt(strGameNumber);
           loginApproved = new String(mGameLoginRS.get(kLogin));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }

       try
       {
          GLSFobj = new GetLandScapeForm(intGameNumber,loginApproved);
	  	  Display.getDisplay(this).setCurrent(GLSFobj);
       }
       catch(Exception e)
       {
          e.printStackTrace();
       }
       GLSFobj.start();
   }


    /*Join Game JGSFobj */
   Command getJoinGameCommand(int i,String gameNoStr)
   {
       Command ItemCommand = new Command("Join Game "+gameNoStr,Command.ITEM,1);
       return ItemCommand;
   }
   
   Runnable getJoinGameActions(int i)
   {
       final int i1 = i+1;
       class JoinGameCallback implements Runnable
       {
            public void run()
            {
               joinGame(i1);
            }
       }
       Runnable callbacks = new JoinGameCallback();
        
       return(callbacks);
   }

   public void joinGame(int gameNo)
   {
       System.out.println("Join Already started game"+gameNo);
       String loginApproved =null;
       try
       {
           if(mGameLoginRSLoaded==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded=true;
           }
           loginApproved = mGameLoginRS.get(kLogin);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       
       try
       {
           JGSFobj = new JoinGameStatusForm(gameNo,loginApproved);
           Display.getDisplay(this).setCurrent(JGSFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       JGSFobj.start();
   }
     

  /*Selection Time Up Form */
  Command[] getSelectionTimeUpFormCommands()
  {
      Command[] selectiontimeupcommands = {
                new Command("INFORM SERVER",Command.SCREEN,1)
      };
      return selectiontimeupcommands;
  }
   
  Runnable[] getSelectionTimeUpFormActions()
  {
     class InformServerCallback implements Runnable
     {
         public void run()
         {
             doInformSelectionTimeUp();
         }
  	 }
     Runnable[] callbacks = {
         new InformServerCallback()
     };
     return callbacks;
   }
   
  void doInformSelectionTimeUp()
  {
       int intGameNumber=0;
       String loginApproved=null;
       String strGameNumber = null;
       try
       {
           if(mGameLoginRSLoaded==false)
           {
                mGameLoginRS.load();
                mGameLoginRSLoaded=true;
           }
           strGameNumber = mGameLoginRS.get(kGameNo);
           intGameNumber = Integer.parseInt(strGameNumber);
           loginApproved = mGameLoginRS.get(kLogin);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       try
       {
          ISSFobj = new SelectionStatusForm(100,100,intGameNumber,loginApproved);
          Display.getDisplay(this).setCurrent(ISSFobj);
       }
       catch(Exception e)
       {
          e.printStackTrace();
       } 
       ISSFobj.start();
  }
  
   /* Zoom Plot Form Commands and Actions */
   Command[] getZoomPlotFormCommands()
   {
       Command[] zoomplotcommands = {
           new Command("BACK",Command.SCREEN,1)
           
       };
       return zoomplotcommands;
   }    
   
   Runnable[] getZoomPlotFormActions()
   {
       class GobackToSelectionForm implements Runnable
       {
           public void run()
           {
               showMakeSelectionFormFromZoomPlot();
           }
       }
       Runnable[] callbacks = {
           new GobackToSelectionForm()
           
       };
       return callbacks;
   }
  
  void showMakeSelectionFormFromZoomPlot()
  {
     String loginApproved = null;
     try
     {
         if(mGameLoginRSLoaded==false)
         {
            mGameLoginRS.load();
            mGameLoginRSLoaded=true;
         }
         loginApproved = new String(mGameLoginRS.get(kLogin));
     }
     catch(Exception e)
     {
           e.printStackTrace();
     }
     String plotsMsg=null;
     int rows=0;
     int cols=0;
     try
     {
         if(mGamePlotRSLoaded==false)
         {
            mGamePlotRS.load();
            mGamePlotRSLoaded=true;
         }
         plotsMsg = new String(mGamePlotRS.get(kPlot));
         rows = Integer.parseInt(new String(mGamePlotRS.get(kRows)));
         cols = Integer.parseInt(new String(mGamePlotRS.get(kCols)));
         
     }
     catch(Exception e)
     {
         e.printStackTrace();
     }
     int selCount =0 ;
     int[] selX=null;
     int[] selY=null;
     String[] selLogin=null;
     String[] selColor=null;
     
     try
     {
         if(mSelectedValuesRSLoaded==false)
         {
            mSelectedValuesRS.load();
            mSelectedValuesRSLoaded = true;
         }
         selCount  = mSelectedValuesRS.getSize(5);
         
     }
     catch(Exception e)
     {
         e.printStackTrace();
     }
     if(selCount > 0)
     {
         selX = new int[selCount];
         selY = new int[selCount];
         selLogin = new String[selCount];
         selColor = new String[selCount];
         for(int i=0;i<selCount;i++)
         {
             selX[i] = Integer.parseInt(mSelectedValuesRS.get(kSelX+"?"+i));
             selY[i] = Integer.parseInt(mSelectedValuesRS.get(kSelY)+"?"+i);
             selLogin[i] = mSelectedValuesRS.get(kSelLogin+"?"+i);
             selColor[i] = mSelectedValuesRS.get(kSelColor+"?"+i);
         }
     }
     try
     {
  		int curVal = MSFobj.ZPFobj.g.getValue();
  		MSFobj = new MakeSelectionForm(plotsMsg,rows,cols,selCount,selX,selY,selLogin,selColor,loginApproved,curVal,maxValue);
  		Display.getDisplay(this).setCurrent(MSFobj);
     }
     catch(Exception e)
     {
  		e.printStackTrace();
     }
  }
  
  
  Command [] getGoBackToSelectionReusltFormCommand()
  {
    Command[] commands ={
        //go back to selection result 
        new Command("GO BACK",Command.SCREEN,1)
    };
    
    return commands;
  }
  
  Runnable[] getGoBackToSelectionResultFormAction()
  {
       class GoBackToSRF implements Runnable
       {
           public void run()
           {
               pending_state = current_state;
               showSelectionResultForm();
               
           }
       }
       Runnable[] callbacks = {
           new GoBackToSRF()
       };
       return callbacks;
  }
  
  Command [] getGoBackToSelectionReusltFormNPCommand()
  {
    Command[] commands ={
        //go back to selection result 
        new Command("GO BACK",Command.SCREEN,1)
    };
    
    return commands;
  }
  
  Runnable[] getGoBackToSelectionResultFormNPAction()
  {
       class GoBackToSRF implements Runnable
       {
           public void run()
           {
               showSelectionResultForm();
           }
       }
       Runnable[] callbacks = {
           new GoBackToSRF()
       };
       return callbacks;
  }

  
  Command[] getGoBackToConfigurationFinishFormCommand()
  {
    Command[] commands ={
        new Command("GO BACK",Command.SCREEN,1)
    };
    
    return commands;
  }
  
  Runnable[] getGoBackToConfigurationFinishFormAction()
  {
       class GoBackToCFF implements Runnable
       {
           public void run()
           {
               pending_state = current_state;
               showConfigurationResultForm();
           }
       }
       Runnable[] callbacks = {
           new GoBackToCFF()
       };
       return callbacks;
  }

  Command[] getGoBackToConfigurationFinishFormNPCommand()
  {
    Command[] commands ={
        //go back to configuraiton finish step
        new Command("GO BACK",Command.SCREEN,1)
    };
    
    return commands;
  }
  
  Runnable[] getGoBackToConfigurationFinishFormNPAction()
  {
       class GoBackToCFF implements Runnable
       {
           public void run()
           {
               
               showConfigurationResultForm();
           }
       }
       
       Runnable[] callbacks = {
           new GoBackToCFF()
       };
       return callbacks;
  }
  
  void showConfigurationResultForm()
  {
      int mineProdUnits=CONFDSFobj.mineProdUnits;
      int foodProdUnits=CONFDSFobj.foodProdUnits;
      int energyProdUnits=CONFDSFobj.energyProdUnits;
      int[] surplus=CONFDSFobj.surplus;
      int rokdaSurplus=CONFDSFobj.rokdaSurplus;
      boolean checkLaterValues = CONFDSFobj.checkLaterValues;
      int countOtherGames = CONFDSFobj.countOtherGames;
      int[][] gamemferValues = CONFDSFobj.gamemferValues;
      
      try
      {
        CONFRFobj=new ConfigurationResultForm(mineProdUnits,foodProdUnits,
                                        energyProdUnits,surplus,rokdaSurplus,checkLaterValues,
                                        countOtherGames,gamemferValues);
        Display.getDisplay(this).setCurrent(CONFRFobj);
      }
      catch(Exception e)
      {
          e.printStackTrace();
      }
      
  }
  
   /*Confirm Selection Form */
   Command[] getConfirmSelectionFormCommands()
   {
         Command[] commands ={
             new Command("CONFIRM",Command.SCREEN,1),
             new Command("BACK",Command.SCREEN,1)
         };
         return commands;
   }
   
   Runnable[] getConfirmSelectionFormActions()
   {
       class ConfirmSelect implements Runnable
       {
           public void run()
           {
               confirmSelection();   
           }
       }
       class GoBack implements Runnable
       {
           public void run()
           {
               showMakeSelectionFormFromConfirmSel();
           }
       }
       
       Runnable[] callbacks = {
           new ConfirmSelect(),
           new GoBack()
           
       };
       return callbacks;
   }

 void confirmSelection()
 {
      int curVal = MSFobj.CSFobj.g.getValue();
      if(curVal < maxValue)
      {
            boolSelDoneBeforeTime = true;
            if(MSFobj != null)
            {
       			if(MSFobj.tm != null)
       			{
       				MSFobj.tm.cancel();
       				System.out.println("MSFobj timer cancelled");
       			}
                if(MSFobj.stt!=null)
                {
                    MSFobj.stt.cancel();                    
                    System.out.println("MSFobj timer task cancelled");
                }
            }
            
            if(MSFobj.CSFobj != null)
            {
	       		if(MSFobj.CSFobj.tm != null)
	       		{
    	   		    MSFobj.CSFobj.tm.cancel();
                    System.out.println("CSFobj timer cancelled");
       			}
                if(MSFobj.CSFobj.stt!=null)
                {
                    MSFobj.CSFobj.stt.cancel();                    
                    System.out.println("CSFobj timer timer task cancelled");
                }
       
            }
            if(MSFobj.ZPFobj != null)
            {
       			if(MSFobj.ZPFobj.tm != null)
       			{
                    MSFobj.ZPFobj.tm.cancel();
                    System.out.println("ZPFobj timer cancelled");
       			}
                if(MSFobj.ZPFobj.stt!=null)
                {
                    MSFobj.ZPFobj.stt.cancel();
                    System.out.println("ZPFobj timer task cancelled");
                }
            }
       }
       int intGameNumber = 0;
       String loginApproved = null;
       try
       {
           if(mGameLoginRSLoaded ==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded= true;
           }
           loginApproved = new String(mGameLoginRS.get(kLogin));
           intGameNumber = Integer.parseInt(new String(mGameLoginRS.get(kGameNo)));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
      
       int xInpt = MSFobj.xInpt;
       int yInpt = MSFobj.yInpt;
       
       try
       {
          SSFobj = new SelectionStatusForm(xInpt,yInpt,intGameNumber,loginApproved);
          Display.getDisplay(this).setCurrent(SSFobj);
       }
       catch(Exception e)
       {
          e.printStackTrace();
       } 
       SSFobj.start();
  }
   

  void showMakeSelectionFormFromConfirmSel()
  {
     String loginApproved = null;
     try
     {
         if(mGameLoginRSLoaded==false)
         {
            mGameLoginRS.load();
            mGameLoginRSLoaded=true;
         }
         loginApproved = new String(mGameLoginRS.get(kLogin));
     }
     catch(Exception e)
     {
           e.printStackTrace();
     }
     String plotsMsg=null;
     int rows=0;
     int cols=0;
     try
     {
         if(mGamePlotRSLoaded==false)
         {
            mGamePlotRS.load();
            mGamePlotRSLoaded=true;
         }
         plotsMsg = new String(mGamePlotRS.get(kPlot));
         rows = Integer.parseInt(new String(mGamePlotRS.get(kRows)));
         cols = Integer.parseInt(new String(mGamePlotRS.get(kCols)));
         
     }
     catch(Exception e)
     {
         e.printStackTrace();
     }
     int selCount =0 ;
     int[] selX=null;
     int[] selY=null;
     String[] selLogin=null;
     String[] selColor=null;
     
     try
     {
         if(mSelectedValuesRSLoaded==false)
         {
            mSelectedValuesRS.load();
            mSelectedValuesRSLoaded = true;
         }
         selCount  = mSelectedValuesRS.getSize(5);
         
     }
     catch(Exception e)
     {
         e.printStackTrace();
     }
     if(selCount > 0)
     {
         selX = new int[selCount];
         selY = new int[selCount];
         selLogin = new String[selCount];
         selColor = new String[selCount];
         for(int i=0;i<selCount;i++)
         {
             selX[i] = Integer.parseInt(mSelectedValuesRS.get(kSelX+"?"+i));
             selY[i] = Integer.parseInt(mSelectedValuesRS.get(kSelY)+"?"+i);
             selLogin[i] = mSelectedValuesRS.get(kSelLogin+"?"+i);
             selColor[i] = mSelectedValuesRS.get(kSelColor+"?"+i);
         }
     }
     try
     {
  		int  curVal = MSFobj.CSFobj.g.getValue();                 
  		MSFobj = new MakeSelectionForm(plotsMsg,rows,cols,selCount,selX,selY,selLogin,selColor,loginApproved,curVal,maxValue);
  		Display.getDisplay(this).setCurrent(MSFobj);
     }
     catch(Exception e)
     {
   		e.printStackTrace();
     }
  }

  Command[] getBuyersSellersListFormCheckCommand()
  {
      Command[] commands = {
            new Command("DECLARATION CHECK",Command.SCREEN,1)
      };
      return commands;
  }
  
  Runnable[] getBuyersSellersListFormCheckAction()
  {
       class DoDeclarationCheck implements Runnable
       {
           public void run()
           {
               pending_state = current_state;
               System.out.println("pending state is in Buyers Sellers List Form Check Action"+pending_state);
               doWaitAndPollDeclare();
           }
       }
       Runnable [] callbacks = {
           new DoDeclarationCheck()
       };
       return callbacks;
      
  }
  
  Command[] getFinishAuctionCommand()
  {
      Command[] commands = {
          new Command("FINISH UP AUCTION", Command.SCREEN,1)
      };
      return commands;
  }
  
  Runnable [] getFinishAuctionAction()
  {
       class DoFinishUpAuction implements Runnable
       {
           public void run()
           {
               pending_state=NONE;
               current_state = NONE;
               doFinishUpAuction();
           }
       }
      
      Runnable[] callbacks ={
        new DoFinishUpAuction()
      };
      
      return callbacks;
  }
  
  void doFinishUpAuction()
  {
       int intWaitAndPollStatus = 1;
       int intGameNumber = 0;
       String loginApproved = null;
       try
       {
           if(mGameLoginRSLoaded==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded =true;
           }
           intGameNumber = Integer.parseInt(new String(mGameLoginRS.get(kGameNo)));
           loginApproved = new String(mGameLoginRS.get(kLogin));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       
       int finishAuction = 1;  
       try
       {
           SBUDTSFobj = new SubmitBuyUnitsDoTradeStatusForm(intGameNumber,loginApproved,intWaitAndPollStatus,finishAuction);
           Display.getDisplay(this).setCurrent(SBUDTSFobj);
       }
       catch(Exception e )
       {
           e.printStackTrace();
       }
       SBUDTSFobj.start();
  }
  
  Command[] getAuctionResultFormCheckCommand()
  {
        Command[] commands={
          new Command("AUCTION RESULT CHECK",Command.SCREEN,1)
        };
        
        return commands;
  }
  
  Runnable[] getAuctionResultFormCheckAction()
  {
       class DoAucitonResultCheck implements Runnable
       {
           public void run(){
               pending_state = current_state;
               System.out.println("pending  State is"+pending_state );
               doWaitAndPollAuction();
           }
       }
       
       Runnable [] callbacks = {
           new DoAucitonResultCheck()
       };
       return callbacks;
      
  }
   
  /*SelectionResultForm*/
  Command[] getSelectionResultFormCommands()
  {
        Command[] commands = {
            new Command("GO TO CONFIGURE",Command.SCREEN,1),
            new Command("CHECK GAME SCORE",Command.SCREEN,1)
        };
        return commands;
   }
  
   Runnable[] getSelectionResultFormActions()
   {
       class ConfigureScreen implements Runnable
       {
           int curVal = initConfValue;
           public void run()
           {
               doConfiguration(curVal);
           }
       }
       class CheckGameScore implements Runnable
       {
          public void run()
          {
               doGetScore();             
          }
       }
       Runnable [] callbacks = {
           new ConfigureScreen(),
           new CheckGameScore()
       };
       return callbacks;
   }

 void doConfiguration(int curVal)
 {
      String loginApproved= null;
      try
      {
         if(mGameLoginRSLoaded==false)
         {
             mGameLoginRS.load();
             mGameLoginRSLoaded= true;
         }
         loginApproved = new String(mGameLoginRS.get(kLogin));
      }
      catch(Exception e)
      {
          e.printStackTrace();
      }
      int inRSCount=0;
      String[] inRSX;
      String[] inRSY;
      String[] inRSIndex;
      Vector ConfiguredX = new Vector(0);
      Vector ConfiguredY = new Vector(0);
      Vector ConfiguredType = new Vector(0);
      try
      {
         mConfigurationDetailsRS.load();
         mConfigurationDetailsRSLoaded = true;
         inRSCount = mConfigurationDetailsRS.getSize(4);
         System.out.println(inRSCount);
          
      }
      catch(RecordStoreException rse)
      {
          rse.printStackTrace();
      }
      if(inRSCount > 0)
      {
          inRSX = new String[inRSCount];
          inRSY = new String[inRSCount];
          inRSIndex = new String[inRSCount];
          for(int i=0;i<inRSCount;i++)
          {
             inRSX[i] = new String(mConfigurationDetailsRS.get(kConfX+"?"+i));
             System.out.println("got from Record Store"+inRSX[i]);
             inRSY[i] = new String(mConfigurationDetailsRS.get(kConfY+"?"+i));
             System.out.println("got from Record Store"+inRSY[i]);
             inRSIndex[i] = new String(mConfigurationDetailsRS.get(kConfIndex+"?"+i));
             System.out.println("got from Record Store"+inRSIndex[i]);
             ConfiguredX.addElement(new Integer(Integer.parseInt(inRSX[i])));
             ConfiguredY.addElement(new Integer(Integer.parseInt(inRSY[i])));
             ConfiguredType.addElement(new Integer(Integer.parseInt(inRSIndex[i])));
          }
      }
      try
      {
         CFFobj  = new ConfigurationForm(loginApproved,ConfiguredX,ConfiguredY,curVal,maxConfValue,ConfiguredType);
         Display.getDisplay(this).setCurrent(CFFobj);
      }
      catch(Exception e)
      {
         e.printStackTrace();
      }
  }
   
   Command[] getConfigurationTimeUpFormCommands()
   {
       Command[] commands = {
            new Command("VIEW DETAILS",Command.SCREEN,1)
       };
       return commands;
   }
   
   Runnable[] getConfigurationTimeUpFormActions()
   {
       class ViewDetails implements Runnable
       {
           int curVal = maxConfValue;
           public void run()
           {
               System.out.println("View the Details");
               viewProduction(curVal);
           }
       }
       Runnable[] callbacks = {
           new ViewDetails()
       };
       return callbacks;
   }
   
   /*No config alllowed form commands and actions*/
   Command[] getNoConfigFormCommands()
   {
       Command[] commands ={
           new Command("GO TO AUCTION",Command.SCREEN,1)
           
       };
       return commands;
   }

   Runnable[] getNoConfigFormActions()
   {
       class GotoAuction implements Runnable
       {
           public void run()
           {
               goDirectlyToAuction();
           }
       }
       Runnable [] callbacks = {
           new GotoAuction()
       };
       return callbacks;
   }
   
   void goDirectlyToAuction()
   {
       configAllowedOrNot = 0;
       int intGameNumber = 0;
       String loginApproved = null;
       try
       {
           if(mGameLoginRSLoaded==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded =true;
           }
           intGameNumber = Integer.parseInt(new String(mGameLoginRS.get(kGameNo)));
           loginApproved = new String(mGameLoginRS.get(kLogin));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       
       try
       {
            CONFDSFobj = new ConfigurationDoneStatusForm(intGameNumber,loginApproved);
            Display.getDisplay(this).setCurrent(CONFDSFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       CONFDSFobj.start();
   }
   
   
   /*Configuration Form Commands and Actions*/
   Command[] getConfigurationFormCommands()
   {
        Command[] commands = {
            new Command("Configure",Command.SCREEN,1),
            new Command("Configure All",Command.SCREEN,1)
            
        };
        return commands;
    }
    
   Runnable[] getConfigurationFormActions()
   {
       class ConfigurePlot implements Runnable
       {
           public void run()
           {
		 		doConfigureFormActions();		   	           	
           }
       }
       
       class ConfigureAll implements Runnable
       {
           public void run()
           {
               showConfigureAllScreen();
           }
       }
       Runnable[] callbacks = {
          new ConfigurePlot(),
          new ConfigureAll()
       };
       return callbacks;
   }

   void showConfigureAllScreen()
   {
       int curVal = CFFobj.gaConfigTime.getValue();
       int ptX= CFFobj.intselectX;
       int ptY = CFFobj.intselectY;
       try
       {
        CAFobj = new ConfigureAllForm(curVal,initConfValue,maxConfValue,ptX,ptY);
        Display.getDisplay(this).setCurrent(CAFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
   }
   
   void doConfigureFormActions()
   {
	int curVal = CFFobj.gaConfigTime.getValue();
	int locInzpt = CFFobj.zpt.getLocation();
	int [] xylocInzpt = CFFobj.zpt.getXYLoc(locInzpt);
	int x = CFFobj.zpt.getX(xylocInzpt[0]);
	int y = CFFobj.zpt.getY(xylocInzpt[1]);
	int ptX = CFFobj.intselectX ;
    int ptY = CFFobj.intselectY;
	System.out.println("x"+x);
	System.out.println("y"+x);
    int check = -1;
       
    check = checkIfConfigured(x,y,ptX,ptY);
    if(check!=-1)
       doConfigurePlot(x,y,curVal,check,ptX,ptY);
   }

   int checkIfConfigured(int x,int y,int ptX,int ptY)
   {
      int inRSCount=0;
      String[] inRSX=null;
      String[] inRSY=null;
      String[] inRSIndex=null;
      boolean bAlreadyConfigured = false;
      try
      {
           if(mConfigurationDetailsRSLoaded == false)
           {
               mConfigurationDetailsRS.load();
               mConfigurationDetailsRSLoaded = true;
           }
           inRSCount = mConfigurationDetailsRS.getSize(4);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       Vector ConfiguredX=new Vector(0);
       Vector ConfiguredY=new Vector(0);
       Vector ConfiguredType = new Vector(0);
       
       if(inRSCount> 0)
       {
           inRSX = new String[inRSCount];
           inRSY = new String[inRSCount];
           inRSIndex = new String[inRSCount];
           for(int i=0;i<inRSCount;i++)
           {
             inRSX[i] = new String(mConfigurationDetailsRS.get(kConfX+"?"+i));
             inRSY[i] = new String(mConfigurationDetailsRS.get(kConfY+"?"+i));
             inRSIndex[i] = new String(mConfigurationDetailsRS.get(kConfIndex+"?"+i));
             ConfiguredX.addElement(new Integer(Integer.parseInt(inRSX[i])));
             ConfiguredY.addElement(new Integer(Integer.parseInt(inRSY[i])));
             ConfiguredType.addElement(new Integer(Integer.parseInt(inRSIndex[i])));
          }
       }

       for(int i=0;i<ConfiguredX.size();i++)
       {
        	System.out.println("ConfiguredX["+i+"]"+ConfiguredX.elementAt(i));
        	System.out.println("ConfiguredY["+i+"]"+ConfiguredY.elementAt(i));
       }
       try
       {
          for(int i=0;i<ConfiguredX.size();i++)
          {
              if(Integer.parseInt(ConfiguredX.elementAt(i).toString())== (ptX+x))
              {
                 if(Integer.parseInt(ConfiguredY.elementAt(i).toString())== (ptY+y))
                 {
                         bAlreadyConfigured = true;
                 }
              }
              if(bAlreadyConfigured == true)
                      break;
          }
       }
       catch(NullPointerException npe)
       {
        	System.out.println("Exception accessing Configured X, ConfiguredY");
        	System.out.println("ConfiguredX size"+ConfiguredX.size());
        	System.out.println("ConfiguredY size "+ConfiguredY.size());
        	npe.printStackTrace();
       }
       if(bAlreadyConfigured == true)
       {
            Alert alertAlreadyConfigured = new Alert("Already Configured","The plot you selected is already configured", null, AlertType.INFO);
            alertAlreadyConfigured.setTimeout(Alert.FOREVER);
            Display.getDisplay(this).setCurrent(alertAlreadyConfigured);
       }
       
       if(bAlreadyConfigured==false)
           return inRSCount;
       else 
           return -1;
   }
   
   void doConfigurePlot(int x,int y,int curVal,int inRSCount,int ptX,int ptY)
   {
       try
       {
         CSPFobj = new ConfigureSpecificPlotForm(x,y,ptX,ptY,curVal,initConfValue,maxConfValue,inRSCount);
 	 	 Display.getDisplay(this).setCurrent(CSPFobj);
       }
       catch(Exception e)
       {
         e.printStackTrace();
       }
   }


   /*Configure All At Once Commands and Actions*/
   Command[] getConfigureAllFormCommands()
   {
       Command[] commands ={
           new Command("BACK",Command.SCREEN,1)
       };
       return commands;
   }
 
   Runnable[] getConfigureAllFormActions()
   {
       class BackToConfigureScreen implements Runnable
       {
           public void run()
           {
           	doConfigureAllFormActions();
           }
       }
       Runnable [] callbacks = {
           new BackToConfigureScreen()
       };
       return callbacks;
   }
   
   void doConfigureAllFormActions()
   {
       int curVal = CAFobj.g.getValue();
       doConfiguration(curVal);
   }
   
   Command getScoreItemCommand()
   {
       Command command = new Command("SCORE",Command.ITEM,1);
       return command;
       
   }
   
   Runnable getScoreItemAction()
   {
        class CheckGameScore implements Runnable
        {
           public void run()
           {
               doGetScore();
           }
       }
        
       Runnable callback = new  CheckGameScore();
       return callback;
   }
  
   /* Configure Specifuc Plot Commands and Actions*/
   Command[] getConfigureSpecificPlotFormCommands()
   {
       Command[] commands ={
           new Command("BACK",Command.SCREEN,1)
       };
       return commands;
   }

  Runnable[] getConfigureSpecificPlotFormActions()
  {
       class BackToConfigureScreen implements Runnable
       {
           public void run()
           {
           	doConfigureSpecificPlotFormActions();
           }
       }
       Runnable [] callbacks = {
           new BackToConfigureScreen()
       };
       return callbacks;
   }
   
   void doConfigureSpecificPlotFormActions()
   {
       int curVal = CSPFobj.g.getValue();
       doConfiguration(curVal);
   }
   
   /*Configuration Finished*/
   Command[] getConfigurationFinishedFormCommands()
   {
       Command[] commands ={
           new Command("VIEW PRODUCTION",Command.SCREEN,1)
       };
       return commands;
   }
   
   Runnable[] getConfigurationFinishedFormActions()
   {
       final int curVal = CFFobj.gaConfigTime.getValue();
       
       class ProductionView implements Runnable
       {
           public void run()
           {
                viewProduction(curVal);
           }
       }
       Runnable [] callbacks = {
           new ProductionView()
       };
       return callbacks;
   }
   
   void viewProduction(int curVal)
   {
       boolConfDoneBeforeTime = false;
       if(curVal < maxConfValue)
       {
             boolConfDoneBeforeTime = true;
             if(CFFobj!=null)
             {
                  if(CFFobj.tmConfigTime!=null)
                  {
                     CFFobj.tmConfigTime.cancel();
                     System.out.println("CFFobj timer cancelled");
                  }
            
                  if(CFFobj.ctt!=null)
                  {
                     CFFobj.ctt.cancel();
                     System.out.println("CFFobj timer task cancelled");                        
                  }
           }   
           if(CSPFobj!=null)
           {
                if(CSPFobj.tm!=null)
                {
                    CSPFobj.tm.cancel();
                    System.out.println("CSPFobj timer cancelled");
                }
            }
       }
       else if(curVal == maxConfValue)
       {

             if(CFFobj!=null)
             {
                  if(CFFobj.tmConfigTime!=null)
                  {
                     CFFobj.tmConfigTime.cancel();
                     System.out.println("CFFobj timer cancelled");
                  }
            
                  if(CFFobj.ctt!=null)
                  {
                     CFFobj.ctt.cancel();
                     System.out.println("CFFobj timer task cancelled");                        
                  }
           }   
           if(CSPFobj!=null)
           {
                if(CSPFobj.tm!=null)
                {
                    CSPFobj.tm.cancel();
                    System.out.println("CSPFobj timer cancelled");
                }
            }
           
       }
       
       System.out.println("Inform server about the production made");
       
       int intGameNumber=0;
       String loginApproved = null;
       try
       {
           if(mGameLoginRSLoaded==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded= true;
           }
           intGameNumber = Integer.parseInt(new String(mGameLoginRS.get(kGameNo)));
           loginApproved = new String(mGameLoginRS.get(kLogin));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       
      int inRSCount=0;
      String[] inRSX;
      String[] inRSY;
      String[] inRSIndex;
      String[] inRSTime;
      String[] inRSMine;
      String[] inRSFarm;
      String[] inRSTech;
      Vector ConfiguredX = new Vector(0);
      Vector ConfiguredY = new Vector(0);
      Vector ConfiguredType = new Vector(0);
      Vector ConfiguredTime = new Vector(0);
      try
      {
          if(mConfigurationDetailsRSLoaded==false)
          {
              mConfigurationDetailsRS.load();
              mConfigurationDetailsRSLoaded=true;
          }
          inRSCount = mConfigurationDetailsRS.getSize(4);
          System.out.println(inRSCount);
      } 
      catch(RecordStoreException rse)
      {
          rse.printStackTrace();
      }
      if(inRSCount > 0)
      {
          inRSX = new String[inRSCount];
          inRSY = new String[inRSCount];
          inRSIndex = new String[inRSCount];
          inRSTime = new String[inRSCount];
          for(int i=0;i<inRSCount;i++)
          {
             inRSX[i] = new String(mConfigurationDetailsRS.get(kConfX+"?"+i));
             System.out.println("got"+inRSX[i]);
             inRSY[i] = new String(mConfigurationDetailsRS.get(kConfY+"?"+i));
             System.out.println("got"+inRSY[i]);
             inRSIndex[i] = new String(mConfigurationDetailsRS.get(kConfIndex+"?"+i));
             System.out.println("got"+inRSIndex[i]);
             inRSTime[i] = new String(mConfigurationDetailsRS.get(kConfTime+"?"+i));
             System.out.println("got"+inRSTime[i]);
             ConfiguredX.addElement(new Integer(Integer.parseInt(inRSX[i])));
             ConfiguredY.addElement(new Integer(Integer.parseInt(inRSY[i])));
             ConfiguredType.addElement(new Integer(Integer.parseInt(inRSIndex[i])));
             ConfiguredTime.addElement(new Integer(Integer.parseInt(inRSTime[i])));
          }
      }
      int selCount =0;
      try
      {
          if(mSelectedValuesRSLoaded==false)
          {
            mSelectedValuesRS.load();
          }
          selCount = mSelectedValuesRS.getSize(5);
      }
      catch(Exception e)
      {
          e.printStackTrace();
      }
      String sX =null;
      String sY = null;
      String sLogin = null;
      boolean tobreak = false;
      try
      {
        for(int i=0;i<selCount;i++)
        {
            sX = new String(mSelectedValuesRS.get(kSelX+"?"+i));
            sY = new String(mSelectedValuesRS.get(kSelY+"?"+i));
            sLogin = new String(mSelectedValuesRS.get(kSelLogin+"?"+i));
            if(sLogin.equals(loginApproved))
            {
                mSelectedValuesRS.del(kSelConfDone+"?"+i);
                mSelectedValuesRS.put(kSelConfDone+"?"+i,"yes");
                tobreak = true;
            }
            if(tobreak == true)
            {
                break;
            }
        }
      }
      catch(RecordStoreException e)
      {
          e.printStackTrace();
      }

      try
      {
         CONFDSFobj = new ConfigurationDoneStatusForm(intGameNumber,loginApproved,
                            ConfiguredX,ConfiguredY,ConfiguredTime,ConfiguredType);
                            //ConfiguredMine,ConfiguredFarm,ConfiguredTech);
	     Display.getDisplay(this).setCurrent(CONFDSFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
	   CONFDSFobj.start();		
   }
   
   /*Configuration Finished Form Commands and actions*/
   Command[] getConfigurationDoneStatusFormCommands()
   {
       Command[] commands ={
           new Command("GO TO AUCTION",Command.SCREEN,1),
           new Command("SELECT MORE PLOTS",Command.SCREEN,1),
           new Command("INFO OF OTHER GAMES", Command.SCREEN,1)
       };
       return commands;
        
    }
    
    Command[] getNoSelectionOptionCommands()
    {
        Command[] commands = {
            new Command("GO TO AUCTION",Command.SCREEN,1),
            new Command("INFO OF OTHER GAMES", Command.SCREEN,1)
        };
        return commands;
        
    }
    
    Runnable[] getNoSelectionOptionActions()
    {
        class GotoDeclareForm implements Runnable
        {
            public void run()
            {
                showDeclareBuyerSellerForm();
            }
        }
        
        class InfoOtherGames implements Runnable
        {
            public void run()
            {
                showInfoOfOtherGames();
            }
            
        }
       Runnable [] callbacks = {
           new GotoDeclareForm(),
           new InfoOtherGames()
       };
       return callbacks;
    }
    
     Runnable[] getConfigurationDoneStatusFormActions()
     {
       class GotoDeclareForm implements Runnable{
           public void run()
           {
               showDeclareBuyerSellerForm();
           }
       }
       
       class GoToSelection implements Runnable
       {
           public void run()
           {
               goToSelection();
           }
       }
       
        class InfoOtherGames implements Runnable
        {
            public void run()
            {
                showInfoOfOtherGames();
            }
            
        }
       

       Runnable [] callbacks = {
           new GotoDeclareForm(),
           new GoToSelection(),
           new InfoOtherGames()
       };
       return callbacks;
     }
    
     
    void showInfoOfOtherGames()
    {
           Alert a = new Alert("Info of Other Games U are logged in");
           if(CONFRFobj.cLaterValues==true)
           {
               int cOG = CONFRFobj.cOtherGames;
               a.setString("You have logged into "+cOG+" other games");
               a.setString("\n");
               if(cOG > 0)
               {
                  int[][] gmfer = CONFRFobj.gmferValues;
                  if(gmfer!=null)
                  {
                     for(int i=0;i<cOG;i++)
                     {
                        a.setString("Game"+gmfer[i][0]);
                        a.setString("Mine Units"+gmfer[i][1]);
                        a.setString("Food Units"+gmfer[i][2]);
                        a.setString("Energy Units"+gmfer[i][3]);
                        a.setString("Rokda Units"+gmfer[i][4]);
                        a.setString("\n");
                     }
                   }
                   a.setString("You can transfer the Units from other games. To do that go to auction");
                }
           }
           a.setTimeout(Alert.FOREVER);
           Display.getDisplay(this).setCurrent(a);
    }
    
    
    void goToSelection()
    {
       int intGameNumber=0;
       String loginApproved = null;
       try
       {
           if(mGameLoginRSLoaded==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded= true;
           }
           intGameNumber = Integer.parseInt(mGameLoginRS.get(kGameNo));
           loginApproved = mGameLoginRS.get(kLogin);
       }
       catch(Exception e)
       {
          e.printStackTrace();
       }
       RoundNo++;
       try
       {
             mConfigurationDetailsRS.delete();
             mConfigurationDetailsRSLoaded=false;
       }
       catch(RecordStoreException rse)
       {
           rse.printStackTrace();
       }
       //get the present selections and show the selection form
       try
       {
          GLSFobj = new GetLandScapeForm(intGameNumber,loginApproved);
	      Display.getDisplay(this).setCurrent(GLSFobj);
       }
       catch(Exception e)
       {
          e.printStackTrace();
       }
       GLSFobj.start();
   }
     
   Command [] getConfirmDeclareBuyerSellerFormCommands()
   {
       Command[] commands ={
           new Command("CONFIRM",Command.SCREEN,1),
           new Command("BACK",Command.SCREEN,1)
       };
       return commands;
   }
   
   Runnable[] getConfirmDeclareBuyerSellerFormActions()
   {
       class SubmitDeclaration implements Runnable
       {
           public void run()
           {
               submitBuyerSellerDeclaration();
           }
       }
       class BackToDeclareForm implements Runnable
       {
           public void run()
           {
               backToDeclareForm();
           }
       }
       Runnable [] callbacks = {
           
           new SubmitDeclaration(),
           new BackToDeclareForm()
           
       };
       return callbacks;
   }
   
   void submitBuyerSellerDeclaration()
   {
       int mi = DBSFobj.mIndex;
       int fi = DBSFobj.fIndex;
       int ei = DBSFobj.eIndex;
       String sMSU = DBSFobj.strMineSellUnits;
       String sFSU = DBSFobj.strFoodSellUnits;
       String sESU = DBSFobj.strEnergySellUnits;
       String sMSP = DBSFobj.strMineSellingPrice;       
       String sFSP = DBSFobj.strFoodSellingPrice;       
       String sESP = DBSFobj.strEnergySellingPrice;              
       int curVal = DBSFobj.CDBSFobj.gDeclareGauge.getValue();

       if(curVal < maxDeclareValue)
       {
            boolDeclDoneBeforeTime = true;
            if(DBSFobj != null)
            {
       			if(DBSFobj.tm != null)
       			{
                    DBSFobj.tm.cancel();
                    System.out.println("DBSFobj timer cancelled");
       			}
                if(DBSFobj.dtt!=null)
                {
                    DBSFobj.dtt.cancel();                
                    System.out.println("DBSFobj timer task cancelled");
                }
            }
            if(DBSFobj.CDBSFobj != null)
            {
       			if(DBSFobj.CDBSFobj.tm != null)
       			{
       				DBSFobj.CDBSFobj.tm.cancel();
                	System.out.println("DBSFobj.CDBSFobj timer cancelled");
       			}
                if(DBSFobj.CDBSFobj.dtt!=null)
                {
                    DBSFobj.CDBSFobj.dtt.cancel();
                    System.out.println("DBSFobj.CDBSFobj timer task cancelled");
                }
       
            }
       }
       
      int intGameNumber = 0;
      String loginApproved = null;
      try
      {
           if(mGameLoginRSLoaded==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded =true;
           }
           intGameNumber = Integer.parseInt(new String(mGameLoginRS.get(kGameNo)));
           loginApproved = new String(mGameLoginRS.get(kLogin));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
        
       int[] TransferFromGame=DBSFobj.CDBSFobj.TFromGame;
       int[] TMU = DBSFobj.CDBSFobj.TMU;
       int[] TFU = DBSFobj.CDBSFobj.TFU;
       int[] TEU = DBSFobj.CDBSFobj.TEU;
       int[] TRU =  DBSFobj.CDBSFobj.TRU;
       
       int waitAndPollStatus = 0;
       try
       {
           SBSDSFobj = new SubmitBuyerSellerDeclarationStatusForm(intGameNumber,
                        loginApproved,waitAndPollStatus,mi,fi,ei,
                        sMSU,sMSP,sFSU,sFSP,sESU,sESP,TransferFromGame,TMU,TFU,TEU,TRU);
                        
           Display.getDisplay(this).setCurrent(SBSDSFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       SBSDSFobj.start();
   }
   
   void backToDeclareForm()
   {
     int curTime = DBSFobj.CDBSFobj.gDeclareGauge.getValue();
     int[] surplus = new int[3];
     if(configAllowedOrNot == 1)
     {
         for(int i=0;i<CONFDSFobj.surplus.length;i++)
         {
            surplus[i] = CONFDSFobj.surplus[i];
         }
     }
     else if(configAllowedOrNot == 0)
     {
         surplus = null;
     }
     int rokdaLeft = CONFDSFobj.rokdaSurplus;
     int StoreMineBuyUnits=CONFDSFobj.StoreMineBuyUnits;
     int StoreMineBuyPrice=CONFDSFobj.StoreMineBuyPrice;
     int StoreFoodBuyUnits = CONFDSFobj.StoreFoodBuyUnits;
     int StoreFoodBuyPrice=CONFDSFobj.StoreFoodBuyPrice;
     int StoreEnergyBuyUnits=CONFDSFobj.StoreEnergyBuyUnits;
     int StoreEnergyBuyPrice= CONFDSFobj.StoreEnergyBuyPrice;
     boolean checkLaterValues = CONFRFobj.cLaterValues;
     int countOtherGames = CONFRFobj.cOtherGames;
     int[][] gmfer = CONFRFobj.gmferValues;

     try
     {
       DBSFobj = new DeclareBuyerSellerForm(surplus,curTime,maxDeclareValue,rokdaLeft,
                            StoreMineBuyUnits,StoreMineBuyPrice,StoreFoodBuyUnits,StoreFoodBuyPrice,
                            StoreEnergyBuyUnits,StoreEnergyBuyPrice,checkLaterValues,countOtherGames,gmfer);
       Display.getDisplay(this).setCurrent(DBSFobj);
     }
     catch(Exception e)
     {
         e.printStackTrace();
     }
       
   }
   
   
   Command[] getBuyersUnitsFormCommands()
   {
       Command[] commands ={
           new Command("CHECK AUCTION RESULT",Command.SCREEN,1)
       };
       return commands;
       
   }
   
   Runnable[] getBuyersUnitsFormActions()
   {
       class WaitAndPollBuyUnits implements Runnable
       {
           public void run()
           {
               doWaitAndPollBuyerUnits();
           }
       }
       Runnable [] callbacks = {
           
           new WaitAndPollBuyUnits()
       };
       return callbacks;
       
   }
   
   void doWaitAndPollBuyerUnits()
   {
       int intWaitAndPollStatus = 1;
       int intGameNumber = 0;
       String loginApproved = null;
       try
       {
           if(mGameLoginRSLoaded==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded =true;
           }
           intGameNumber = Integer.parseInt(new String(mGameLoginRS.get(kGameNo)));
           loginApproved = new String(mGameLoginRS.get(kLogin));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       
   }
   
   Command[] getDeclareWaitAndPollCommand()
   {
       Command[] commands = {
           new Command("DECLARATION CHECK",Command.SCREEN,1)
       };
       return commands;
   }
   
   Runnable[] getDeclareWaitAndPollAction()
   {
       class WaitAndPollDeclare implements Runnable
       {
           public void run()
           {
               doWaitAndPollDeclare();
           }
       }
       
       Runnable [] callbacks = {
           new WaitAndPollDeclare()
       
       };
       return callbacks;
   }
   
  Command[] getAuctionResultFormCommands()
  {
      Command[] commands = {
            new Command("SELECT MORE PLOTS",Command.SCREEN,1), //CHANGED    
            new Command("GET SCORE",Command.SCREEN,1)
      };
      return commands;
  }

 Runnable[] getAuctionResultFormActions()
 {
       class SelectionFromAuctionResultForm implements Runnable
       {
            public void run()
            {
                pending_state = current_state;
                goToSelection();  
            }
       }
       class CheckGameScore implements Runnable
       {
           public void run()
           {
               doGetScore();
           }
       }
       Runnable [] callbacks = {
           new SelectionFromAuctionResultForm(),
           new CheckGameScore()
       };
       return callbacks;

 }
 
 Command[] getAuctionResultFormNPCommands()
 {
      Command[] commands = {
            new Command("SELECT MORE PLOTS",Command.SCREEN,1), //CHANGED    
            new Command("GET SCORE",Command.SCREEN,1)
      };
      return commands;
  }

 Runnable[] getAuctionResultFormNPActions()
 {
       class SelectionFromAuctionResultForm implements Runnable
       {
            public void run()
            {
                    goToSelection();  
            }
       }
       class CheckGameScore implements Runnable
       {
           public void run()
           {
               doGetScore();
           }
       }
       
       Runnable [] callbacks = {
           new SelectionFromAuctionResultForm(),
           new CheckGameScore()
       };
       return callbacks;
   }

   /*Buyer and Seller List Form Commands And Actions*/
   Command [] getBuyersSellersListFormCommands()
   {
       Command[] commands ={
           new Command("SELECTION",Command.SCREEN,1) 
       };
       return commands;
   }

   Runnable[] getBuyersSellersListFormActions()
   {
       class SelectionFromBuyersSellersListForm implements Runnable
       {
            public void run()
            {
                pending_state = current_state;
                goToSelection();  
            }
       }
       
       Runnable [] callbacks = {
           new SelectionFromBuyersSellersListForm()
       };
       return callbacks;
   }

   void doWaitAndPollDeclare()
   {
       int intWaitAndPollStatus = 1;
       int intGameNumber = 0;
       String loginApproved = null;
       try
       {
           if(mGameLoginRSLoaded==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded =true;
           }
           intGameNumber = Integer.parseInt(new String(mGameLoginRS.get(kGameNo)));
           loginApproved = new String(mGameLoginRS.get(kLogin));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       
       try
       {
           SBSDSFobj = new SubmitBuyerSellerDeclarationStatusForm(intGameNumber,loginApproved,intWaitAndPollStatus);
           Display.getDisplay(this).setCurrent(SBSDSFobj);
       }
       catch(Exception e )
       {
           e.printStackTrace();
       }
       SBSDSFobj.start();
   }
   
   /*Confirm Buy Units Form Commands and Actions*/
   Command[] getConfirmBuyUnitsFormCommands()
   {
       Command[] commands ={
           new Command("SUBMIT",Command.SCREEN,1),
           new Command("BACK",Command.SCREEN,1)
       };
       return commands;
   }
   
   Runnable[] getConfirmBuyUnitsFormActions()
   {
       class ContinueAuction implements Runnable
       {
           public void run()
           {
               continueAuction();
           }
       }
       class BackToBuyUnitsForm implements Runnable
       {
           public void run()
           {
               backtoBuySellUnitsForm();
           }
       }

       Runnable [] callbacks = {
           
           new ContinueAuction(),
           new BackToBuyUnitsForm()
       };
       return callbacks;
       
   }
   
   void continueAuction()
   {
       
       System.out.println("Continue Auction");
       int intGameNumber = 0;
       String loginApproved = null;
       try
       {
           if(mGameLoginRSLoaded==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded =true;
           }
           intGameNumber = Integer.parseInt(new String(mGameLoginRS.get(kGameNo)));
           loginApproved = new String(mGameLoginRS.get(kLogin));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
        
       int[] bmu=null;
       int[] bfu=null;
       int[] beu=null;
       String[] bml=null;
       String[] bfl=null;
       String[] bel=null;
       if(BSLFobj.buyMinesUnits!=null)
       {
           bmu = new int[BSLFobj.buyMinesUnits.length];
           bml = new String[BSLFobj.buyMinesFromLogin.length];
           for(int i=0;i<bmu.length;i++)
           {
               bmu[i] = BSLFobj.buyMinesUnits[i];
               System.out.println("bmu"+bmu[i]);
               bml[i] = new String(BSLFobj.buyMinesFromLogin[i]);
               System.out.println("bml"+bml[i]);
           }
       }
       if(BSLFobj.buyFoodUnits!=null)
       {
           bfu = new int[BSLFobj.buyFoodUnits.length];
           bfl = new String[BSLFobj.buyFoodFromLogin.length];
           for(int i=0;i<bfu.length;i++)
           {
               bfu[i] = BSLFobj.buyFoodUnits[i];
               System.out.println("bfu"+bfu[i]);
               bfl[i] = new String(BSLFobj.buyFoodFromLogin[i]);
               System.out.println("bfl"+bfl[i]);
           }
       }
       if(BSLFobj.buyEnergyUnits!=null)
       {
           beu = new int[BSLFobj.buyEnergyUnits.length];
           bel = new String[BSLFobj.buyEnergyFromLogin.length];
           for(int i=0;i<beu.length;i++)
           {
               beu[i] = BSLFobj.buyEnergyUnits[i];
               System.out.println("beu"+beu[i]);
               bel[i] = new String(BSLFobj.buyEnergyFromLogin[i]);
               System.out.println("beu"+beu[i]);
           }
       }
       int waitandpoll = 0;
       int mSellToStoreIndex= -100;
       int fSellToStoreIndex = -100;
       int eSellToStoreIndex = -100;
       

       mSellToStoreIndex = BSLFobj.mSellToStore;   
       System.out.println(mSellToStoreIndex);
       fSellToStoreIndex = BSLFobj.fSellToStore;
       System.out.println(fSellToStoreIndex);
       eSellToStoreIndex = BSLFobj.eSellToStore;
       System.out.println(eSellToStoreIndex);
       
       try
       {
           SBUDTSFobj = new SubmitBuyUnitsDoTradeStatusForm(waitandpoll,intGameNumber,loginApproved,
                              bmu,bml,bfu,bfl,beu,bel,mSellToStoreIndex,fSellToStoreIndex,eSellToStoreIndex);
	       Display.getDisplay(this).setCurrent(SBUDTSFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       SBUDTSFobj.start();		
   }
   
   void backtoBuySellUnitsForm()
   {
       try
       {
           Display.getDisplay(this).setCurrent(BSLFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       
   }

   void showCanPlayScreen(int intNoOfPlayers,String[] playerLogins,String[] playerColors)
   {
       try
       {
         PFobj = new PlayForm(intNoOfPlayers,playerLogins,playerColors);
	     Display.getDisplay(this).setCurrent(PFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
   }
   
  void showLoginIncorrectForm(int intLoginCheck)
  {
       try
       {
         LIFobj = new LoginIncorrectForm(intLoginCheck);
	     Display.getDisplay(this).setCurrent(LIFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
  }
  
  void showGamesList(int intNoOfGames,int [] intNoOfPlayers,String[][] strplayerLogins,int intLoginCheck,String LoginApproved)
  {
      System.out.println("intNoOfGames"+intNoOfGames);
      for(int i = 0;i<intNoOfGames;i++)
      {
          System.out.println("intNoOfPlayers"+intNoOfPlayers[i]);
          for(int j=0;j<intNoOfPlayers[i];j++)
          {
              System.out.println("strplayerlogins"+strplayerLogins[i][j]);
          }
      }
      try
      {
           GLFobj = new GamesListForm(MaxNoOfPlayers,intNoOfGames,intNoOfPlayers,strplayerLogins,intLoginCheck,LoginApproved);
           Display.getDisplay(this).setCurrent(GLFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
  }
  
 void showRegistrationConfirmForm(String urLogin)
 {
       try
       {
          RCFobj = new RegistrationConfirmForm(urLogin);
	      Display.getDisplay(this).setCurrent(RCFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
  }
  
 void showLoginInUseForm(String urLogin)
 {
       try
       {
         LIUFobj = new LoginInUseForm(urLogin);
	     Display.getDisplay(this).setCurrent(LIUFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
  }
  
  
 void showMakeSelectionForm()
 {
     String loginApproved=null;
     try
     {
         if(mGameLoginRSLoaded==false)
         {
             mGameLoginRS.load();
             mGameLoginRSLoaded= true;
         }
         loginApproved = new String(mGameLoginRS.get(kLogin));
     }
     catch(Exception e)
     {
         e.printStackTrace();
     }
     String plotsMsg = null;
     int rows=0;
     int cols=0;
     try
     {
         if(mGamePlotRSLoaded==false)
         {
            mGamePlotRS.load();
            mGamePlotRSLoaded=true;
         }
         plotsMsg = new String(mGamePlotRS.get(kPlot));
         rows = Integer.parseInt(new String(mGamePlotRS.get(kRows)));
         cols = Integer.parseInt(new String(mGamePlotRS.get(kCols)));
     }
     catch(Exception e)
     {
        e.printStackTrace();
     }
     int selCount=0;
     int[] selX=null;
     int[] selY=null;
     String[] selLogin=null;
     String[] selColor=null;
     
     try
     {
         mSelectedValuesRS.load();
         mSelectedValuesRSLoaded= true;
         selCount = mSelectedValuesRS.getSize(5);
         if(selCount>0)
         {
            selX = new int[selCount];
            selY = new int[selCount];
            selLogin = new String[selCount];
            selColor = new String[selCount];
            for(int i=0;i<selCount;i++)
            {
                selX[i] = Integer.parseInt(new String(mSelectedValuesRS.get(kSelX+"?"+i)));
                selY[i] = Integer.parseInt(new String(mSelectedValuesRS.get(kSelY+"?"+i)));
                selLogin[i] = new String(mSelectedValuesRS.get(kSelLogin+"?"+i));
                selColor[i] = new String(mSelectedValuesRS.get(kSelColor+"?"+i));
                
            }
         }
         
     }
     catch(Exception e)
     {
         e.printStackTrace();
     }
     
     try
     {
         MSFobj = new MakeSelectionForm(plotsMsg,rows,cols,selCount,selX,selY,selLogin,selColor,loginApproved,maxValue);
         Display.getDisplay(this).setCurrent(MSFobj);
     }
     catch(Exception e)
     {
         e.printStackTrace();
     }
  }
  
 void showSelectionTimeUpForm()
 {
     try
     {
         STUFobj = new SelectionTimeUpForm();
	     Display.getDisplay(this).setCurrent(STUFobj);
     }
     catch(Exception e)
     {
         e.printStackTrace();
     }
  }
  
 void showConfigurationTimeUpForm()
 {
     try
     {
         CTUFobj = new ConfigurationTimeUpForm();
	     Display.getDisplay(this).setCurrent(CTUFobj);
     }
     catch(Exception e)
     {
          e.printStackTrace();
     }
  }
  
  
  
 void showSelectStepNotOverForm()
 {
       try
       {
         SSNOFobj = new SelectStepNotOverForm();
	     Display.getDisplay(this).setCurrent(SSNOFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
  }

 void showSelectionResultForm()
 {
       int xRecv = SSFobj.xRecv;
       int yRecv = SSFobj.yRecv;
       int selLen = SSFobj.selLen;
       boolean alreadyThereValid = SSFobj.alreadyThereValid;
       boolean alreadyThere = false;
       if(alreadyThereValid == true)
       {
          alreadyThere = SSFobj.alreadyThere;
       }
       int [] selX =null;
       int[] selY =null;
       String[] selLogin = null;
       String[] selColor =null;
       try
       {
           mSelectedValuesRS.load();
           mSelectedValuesRSLoaded = true;
           selLen  = mSelectedValuesRS.getSize(5);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       
       if(selLen > 0)
       {
           selX = new int[selLen];
           selY = new int[selLen];
           selLogin = new String[selLen];
           selColor = new String[selLen];
           for(int i=0;i<selLen;i++)
           {
               selX[i] = Integer.parseInt(new String(mSelectedValuesRS.get(kSelX+"?"+i)));
               selY[i] = Integer.parseInt(new String(mSelectedValuesRS.get(kSelY+"?"+i)));
               selLogin[i] = new String(mSelectedValuesRS.get(kSelLogin+"?"+i));
               selColor[i] = new String(mSelectedValuesRS.get(kSelColor+"?"+i));
           }
       }
       try
       {
         SRFobj = new SelectionResultForm(xRecv,yRecv,selX,selY,selLogin,selColor,alreadyThereValid,alreadyThere);
	     Display.getDisplay(this).setCurrent(SRFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
  }
  
  
 void showNoConfigAllowedForm()
 {
        int selLen=0;
        try
        {
            mSelectedValuesRS.load();
            mSelectedValuesRSLoaded = true;
            selLen = mSelectedValuesRS.getSize(5);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        int[] selX = null;
        int[] selY = null;
        String[] selLogin =null;
        String[] selColor = null;
        
        if(selLen > 0)
        {
            selX = new int[selLen];
            selY = new int[selLen];
            selLogin = new String[selLen];
            selColor = new String[selLen];
            for(int i=0;i<selLen;i++)
            {
                selX[i] = Integer.parseInt(new String(mSelectedValuesRS.get(kSelX+"?"+i)));
                selY[i] = Integer.parseInt(new String(mSelectedValuesRS.get(kSelY+"?"+i)));
                selLogin[i] = new String(mSelectedValuesRS.get(kSelLogin+"?"+i));
                selColor[i] = new String(mSelectedValuesRS.get(kSelColor+"?"+i));
            }
        }
       
       try
       {
         SNCAFobj = new NoConfigAllowedForm(selX,selY,selLogin,selColor);
	     Display.getDisplay(this).setCurrent(SNCAFobj);
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
  }
 
 void showDeclareBuyerSellerForm()
 {
      int[] surplus = new int[3];
      if(configAllowedOrNot == 1)
      {
         surplus = CONFDSFobj.surplus;
      }
      else if(configAllowedOrNot == 0)
      {
         surplus = null;
      }
      int rokda = CONFDSFobj.rokdaSurplus; 
      int StoreMineBuyUnits = CONFDSFobj.StoreMineBuyUnits;
      int StoreMineBuyPrice = CONFDSFobj.StoreMineBuyPrice;
      int StoreFoodBuyUnits = CONFDSFobj.StoreFoodBuyUnits;
      int StoreFoodBuyPrice = CONFDSFobj.StoreFoodBuyPrice;
      int StoreEnergyBuyUnits = CONFDSFobj.StoreEnergyBuyUnits;
      int StoreEnergyBuyPrice = CONFDSFobj.StoreEnergyBuyPrice;
    
      boolean checkLaterValues = CONFRFobj.cLaterValues;
      System.out.println(checkLaterValues);
      int countOtherGames = CONFRFobj.cOtherGames;
      System.out.println(countOtherGames);
      int[][] gmfer = new int[countOtherGames][5];
      gmfer = CONFRFobj.gmferValues;
      for(int i=0;i<countOtherGames;i++)
      {
        System.out.println(gmfer[i][0]);
        System.out.println(gmfer[i][1]);
        System.out.println(gmfer[i][2]);
        System.out.println(gmfer[i][3]);
        System.out.println(gmfer[i][4]);
     }
     try
     {
         DBSFobj = new DeclareBuyerSellerForm(surplus,initDeclareValue,maxDeclareValue,rokda,StoreMineBuyUnits,StoreMineBuyPrice,
                            StoreFoodBuyUnits,StoreFoodBuyPrice,StoreEnergyBuyUnits,StoreEnergyBuyPrice,
                            checkLaterValues,countOtherGames,gmfer);
         Display.getDisplay(this).setCurrent(DBSFobj);
     }catch(Exception e){
         e.printStackTrace();
     }
 }
 
 void showDeclarationTimeUpForm()
 {
     int mi = -1;
     int fi  = -1;
     int ei = -1;
     System.out.println();
     int intGameNumber = 0;
     String loginApproved = null;
     try
     {
         if(mGameLoginRSLoaded==false)
         {
              mGameLoginRS.load();
              mGameLoginRSLoaded =true;
         }
         intGameNumber = Integer.parseInt(new String(mGameLoginRS.get(kGameNo)));
         loginApproved = new String(mGameLoginRS.get(kLogin));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
      
       String sMSU=null;
       String sFSU=null;
       String sESU=null;
       String sMSP=null;
       String sFSP=null;
       String sESP=null;
       int waitAndPollStatus = 0;
     
       try
       {
         SBSDSFobj = new SubmitBuyerSellerDeclarationStatusForm(intGameNumber,
            loginApproved,waitAndPollStatus,mi,fi,ei,sMSU,sMSP,sFSU,sFSP,sESU,sFSP,
            null,null,null,null,null);
         Display.getDisplay(this).setCurrent(SBSDSFobj);
       }
       catch(Exception e )
       {
         e.printStackTrace();
       }
       SBSDSFobj.start();
     
 }
 
 void showBuyersSellersList()
 {

        int mi = SBSDSFobj.recvMIndex;
        int fi = SBSDSFobj.recvFIndex;
        int ei = SBSDSFobj.recvEIndex;
        
        System.out.println("mi"+mi);
        System.out.println("fi"+fi);
        System.out.println("ei"+ei);
        
        boolean  doWaitAndPoll = SBSDSFobj.doWaitAndPoll;

        int tcmb=0;
        int tcfb=0;
        int tceb=0;//total count of buyers
        int [] totalbuyerCounts=null;

        int cms=0,cfs=0,ces=0; // count of sellers
        int[] sellerCounts=null;
        
        String[] loginmb=null;
        String[] loginfb=null;
        String[] logineb=null; //logins of buyers
        String[] loginms=null,loginfs=null,logines=null; // logins og sellers
        
        int[] noofunitsms=null,noofunitsfs=null,noofunitses=null; // no of units sellers sell
        
        int[] spms=null,spfs=null,spes=null; //selling prices
        
        boolean recvbMSellToStoreIndex=false,recvbFSellToStoreIndex=false,recvbESellToStoreIndex=false;
        int checkMineTradeDone=0, checkFoodTradeDone=0,checkEnergyTradeDone=0;
        String[] tradedWithMineBuyer= null;
        String[] tradedWithFoodBuyer= null;
        String[] tradedWithEnergyBuyer= null;
        int[] tradedMineUnits= null;
        int[] tradedFoodUnits= null;
        int[] tradedEnergyUnits= null;
        int mineUnitsLeftToSell = 0;
        int foodUnitsLeftToSell = 0;
        int energyUnitsLeftToSell = 0;
        

        if(mi==1)
        {   
           cms = SBSDSFobj.MineSellerCount;
           System.out.println(cms);
           if(cms > 0)
           {
                 loginms = new String[cms];
                 for(int i=0;i<loginms.length;i++)
                 {
                    loginms[i] = new String(SBSDSFobj.MineSellerLogins[i]);
                    System.out.println(loginms[i]);
                 }
                 noofunitsms = new int[cms];
                 for(int i=0;i<noofunitsms.length;i++)
                 {
                     noofunitsms[i] = SBSDSFobj.MineSellNoOfUnits[i];
                     System.out.println(noofunitsms[i]);
                 }
                 spms = new int[cms];
                 for(int i=0;i<spms.length;i++)
                 {
                     spms[i] = SBSDSFobj.MineSellersSP[i];
                     System.out.println(spms[i]);
                }
           }
        }
        else if(mi==2)
        { //seller
           recvbMSellToStoreIndex = SBSDSFobj.recvbMSellToStoreIndex;
           if(recvbMSellToStoreIndex==false)
           {
               tcmb = SBSDSFobj.TotalMineBuyerCount;
               System.out.println(tcmb);
               if(tcmb > 0)
               {
                  loginmb = new String[tcmb];
                  for(int i=0;i<tcmb;i++)
                  {
                      loginmb[i] = new String(SBSDSFobj.TotalMineBuyerLogins[i]);
                      System.out.println(loginmb[i]);
                  }
              }
           }
           else if(recvbMSellToStoreIndex==true)
           {
               checkMineTradeDone = SBSDSFobj.checkMineTradeDone;
               if(checkMineTradeDone > 0)
               {
                   tradedWithMineBuyer = new String[checkMineTradeDone];
                   tradedMineUnits = new int[checkMineTradeDone];
                   for(int j=0;j<checkMineTradeDone;j++)
                   {
                        tradedWithMineBuyer[j] = SBSDSFobj.tradedWithMineBuyer[j];
                        tradedMineUnits[j] = SBSDSFobj.tradedMineUnits[j];
                   }
               }
               mineUnitsLeftToSell = SBSDSFobj.checkMineUnitsLeftToSell;
           }
        }

        if(fi==1)
        {
             cfs = SBSDSFobj.FoodSellerCount;
             System.out.println(cfs);
             if(cfs > 0)
             {
                  loginfs = new String[cfs];
                  for(int i=0;i<loginfs.length;i++)
                  {
                       loginfs[i] = new String(SBSDSFobj.FoodSellerLogins[i]);
                       System.out.println(loginfs[i]);
                  }
                  noofunitsfs = new int[cfs];
                  for(int i=0;i<noofunitsfs.length;i++)
                  {                    
                        noofunitsfs[i] = SBSDSFobj.FoodSellNoOfUnits[i];
                        System.out.println(noofunitsfs[i]);
                  }
                  spfs = new int[cfs];
                  for(int i=0;i<spfs.length;i++)
                  {                    
                        spfs[i] = SBSDSFobj.FoodSellersSP[i];
                        System.out.println(spfs[i]);
                  }
             }
        }
        else if(fi==2)
        {
            if(recvbFSellToStoreIndex==false)
            {
              tcfb = SBSDSFobj.TotalFoodBuyerCount;
              System.out.println(tcfb);
              if(tcfb > 0)
              {
                   loginfb = new String[tcfb];
                   for(int i=0;i<loginfb.length;i++)
                   {                                            
                       loginfb[i] = new String(SBSDSFobj.TotalFoodBuyerLogins[i]);
                       System.out.println(loginfb[i]);
                   }
              }
            }
            else if(recvbFSellToStoreIndex==true)
            {
               checkFoodTradeDone = SBSDSFobj.checkFoodTradeDone;
               if(checkFoodTradeDone > 0)
               {
                   tradedWithFoodBuyer = new String[checkFoodTradeDone];
                   tradedFoodUnits = new int[checkFoodTradeDone];
                   for(int j=0;j<checkFoodTradeDone;j++)
                   {
                        tradedWithFoodBuyer[j] = SBSDSFobj.tradedWithFoodBuyer[j];
                        tradedFoodUnits[j] = SBSDSFobj.tradedFoodUnits[j];
                   }
               }
               foodUnitsLeftToSell = SBSDSFobj.checkFoodUnitsLeftToSell;
           }
        }

        if(ei==1)
        {
              ces = SBSDSFobj.EnergySellerCount;
              System.out.println(ces);
              if(ces > 0)
              {
                  logines = new String[ces];
                  for(int i=0;i<logines.length;i++)
                  {
                      logines[i] = new String(SBSDSFobj.EnergySellerLogins[i]);
                      System.out.println(logines[i]);
                  }
                  noofunitses = new int[ces];
                  for(int i=0;i<noofunitses.length;i++)
                  {                   
                      noofunitses[i] = SBSDSFobj.EnergySellNoOfUnits[i];
                      System.out.println(noofunitses[i]);
                  }
                  spes = new int[ces];
                  for(int i=0;i<spes.length;i++)
                  {                    
                      spes[i] = SBSDSFobj.EnergySellersSP[i];
                      System.out.println(spes[i]);
                  }   
              }
        }
        else if(ei==2)
        {
            if(recvbESellToStoreIndex == false)
            {
               tceb = SBSDSFobj.TotalEnergyBuyerCount;
               System.out.println(tceb);
               if(tceb > 0)
               {
                   logineb = new String[tceb];                                           
                   for(int i=0;i<logineb.length;i++)
                   {                                            
                       logineb[i] = new String(SBSDSFobj.TotalEnergyBuyerLogins[i]);
                       System.out.println(logineb[i]);
                  }
              }
            }  
            else if(recvbESellToStoreIndex==true)
            {
               checkEnergyTradeDone = SBSDSFobj.checkEnergyTradeDone;
               if(checkEnergyTradeDone > 0)
               {
                   tradedWithEnergyBuyer = new String[checkEnergyTradeDone];
                   tradedEnergyUnits = new int[checkEnergyTradeDone];
                   for(int j=0;j<checkEnergyTradeDone;j++)
                   {
                        tradedWithEnergyBuyer[j] = SBSDSFobj.tradedWithEnergyBuyer[j];
                        tradedEnergyUnits[j] = SBSDSFobj.tradedEnergyUnits[j];
                   }
               }
               energyUnitsLeftToSell = SBSDSFobj.checkEnergyUnitsLeftToSell;
           }
        }
                    
        int mineScore = SBSDSFobj.mineScore;
        System.out.println("came here 1");
        int foodScore = SBSDSFobj.foodScore;
        System.out.println("came here 2");
        int energyScore = SBSDSFobj.energyScore;
        System.out.println("came here 3");
        int rokdaScore = SBSDSFobj.rokdaScore;
        System.out.println("came here 4");
        
        
        totalbuyerCounts = new int[3];
        totalbuyerCounts[0] = tcmb;
        totalbuyerCounts[1] = tcfb;
        totalbuyerCounts[2] = tceb;        
        
        sellerCounts = new int[3];
        sellerCounts[0] = cms;
        sellerCounts[1] = cfs;
        sellerCounts[2] = ces;
        
        int[] surplus = new int[3];
        int rokdaSurplus=0;
        
      int mineCritical = CONFDSFobj.mineCritical;
      int foodCritical = CONFDSFobj.foodCritical;
      int energyCritical = CONFDSFobj.energyCritical;
      int rokdaCritical = CONFDSFobj.rokdaCritical;
        
      for(int i=0;i<3;i++)
      {
          if(i==0)
          {
              surplus[i] = mineScore - mineCritical;
          }
          else if(i==1)
          {
              surplus[i] = foodScore - foodCritical;
          }
          else if(i==2)
          {
              surplus[i] = energyScore - energyCritical;
          }
      }
      rokdaSurplus = rokdaScore - rokdaCritical;
    try
    {
        BSLFobj  = new BuyersSellersListForm(doWaitAndPoll,totalbuyerCounts,sellerCounts,
                                                   loginmb,loginfb,logineb,loginms,loginfs,logines,
                                                   noofunitsms,noofunitsfs,noofunitses,
                                                   spms,spfs,spes,mi,fi,ei,surplus,rokdaSurplus,
                                                   recvbMSellToStoreIndex,recvbFSellToStoreIndex,recvbESellToStoreIndex,
                                                   checkMineTradeDone,checkFoodTradeDone,checkEnergyTradeDone,
                                                   tradedWithMineBuyer,tradedWithFoodBuyer,tradedWithEnergyBuyer,
                                                   tradedMineUnits,tradedFoodUnits,tradedEnergyUnits,
                                                   mineUnitsLeftToSell,foodUnitsLeftToSell,energyUnitsLeftToSell);
        Display.getDisplay(this).setCurrent(BSLFobj);        
    }
    catch(Exception e)
    {
        System.out.println("Problem in initialising the Buyerseleer");
        e.printStackTrace();
    }
 }
 
 
 void showAuctionResultForm()
 {
     String[] sbocode = new String[3];
     for(int i=0;i<3;i++)
     {
        sbocode[i] = SBUDTSFobj.sbocode[i];
     }
     int finishAuction = SBUDTSFobj.finishAuctionStatus;
     //buyer stuff
     boolean BuyerMineUnitsTradedValid=SBUDTSFobj.BuyerMineUnitsTradedValid;
     int BuyerMineUnitsTradedLen=0;
     int[] BuyerMineUnitsTraded =null;
     String[] MineUnitsTradedWithSeller =null;
     if(BuyerMineUnitsTradedValid==true)
     {
        BuyerMineUnitsTradedLen = SBUDTSFobj.BuyerMineUnitsTradedLen;
        if(BuyerMineUnitsTradedLen > 0)
        {
            BuyerMineUnitsTraded = new int[BuyerMineUnitsTradedLen];
            MineUnitsTradedWithSeller = new String[BuyerMineUnitsTradedLen];
            for(int i=0;i<BuyerMineUnitsTradedLen;i++)
            {
                BuyerMineUnitsTraded[i] = SBUDTSFobj.BuyerMineUnitsTraded[i];
                MineUnitsTradedWithSeller[i] = new String(SBUDTSFobj.MineUnitsTradedWithSeller[i]);
            }
        }
    }
    
    boolean MineUnitsStillNeededValid=SBUDTSFobj.MineUnitsStillNeededValid;
    int MineUnitsStillNeededLen = 0;
    int[]  MineUnitsStillNeeded = null;
    if(MineUnitsStillNeededValid == true)
    {
        MineUnitsStillNeededLen = SBUDTSFobj.MineUnitsStillNeededLen;
        if(MineUnitsStillNeededLen > 0)
        {
            MineUnitsStillNeeded = new int[MineUnitsStillNeededLen];
            for(int i=0;i<MineUnitsStillNeededLen;i++)
            {
                MineUnitsStillNeeded[i] = SBUDTSFobj.MineUnitsStillNeeded[i];
            }
        }
    }
    
    //seller stuff
    int SellerMineUnitsTradedLen=SBUDTSFobj.SellerMineUnitsTradedLen;
    int[] SellerMineUnitsTraded =null;
    String[] MineUnitsTradedWithBuyer =null;
    if(SellerMineUnitsTradedLen > 0)
    {
        SellerMineUnitsTraded = new int[SellerMineUnitsTradedLen];
        MineUnitsTradedWithBuyer = new String[SellerMineUnitsTradedLen];
        for(int i=0;i<SellerMineUnitsTradedLen;i++)
        {
            SellerMineUnitsTraded[i] = SBUDTSFobj.SellerMineUnitsTraded[i];
            MineUnitsTradedWithBuyer[i] = new String(SBUDTSFobj.MineUnitsTradedWithBuyer[i]);
        }
    }
    
    int countIfAnyMBuyersUnfulfilled = SBUDTSFobj.countIfAnyMBuyersUnfulfilled;
    String[] MBuyerLoginsNotFulfilled=null;
    int[] MBuyerUnitsNeededFromYou = null;
    if(countIfAnyMBuyersUnfulfilled > 0)
    {
        MBuyerLoginsNotFulfilled = new String[countIfAnyMBuyersUnfulfilled];
        MBuyerUnitsNeededFromYou = new int[countIfAnyMBuyersUnfulfilled];
        for(int i=0;i<countIfAnyMBuyersUnfulfilled;i++)
        {
            MBuyerLoginsNotFulfilled[i] = new String(SBUDTSFobj.MBuyerLoginsNotFulfilled[i]);
            MBuyerUnitsNeededFromYou[i] = SBUDTSFobj.MBuyerUnitsNeededFromYou[i];
        }
    }
    
    //buyer stuff
    boolean BuyerFoodUnitsTradedValid=SBUDTSFobj.BuyerFoodUnitsTradedValid;
    int BuyerFoodUnitsTradedLen  =0; 
    int[] BuyerFoodUnitsTraded =null;
    String[] FoodUnitsTradedWithSeller =null;
    if(BuyerFoodUnitsTradedValid==true)
    {
        BuyerFoodUnitsTradedLen = SBUDTSFobj.BuyerFoodUnitsTradedLen;
        if(BuyerFoodUnitsTradedLen > 0)
        {
            BuyerFoodUnitsTraded = new int[BuyerFoodUnitsTradedLen];
            FoodUnitsTradedWithSeller = new String[BuyerFoodUnitsTradedLen];
            for(int i=0;i<BuyerFoodUnitsTradedLen;i++)
            {
                BuyerFoodUnitsTraded[i] = SBUDTSFobj.BuyerFoodUnitsTraded[i];
                FoodUnitsTradedWithSeller[i] = new String(SBUDTSFobj.FoodUnitsTradedWithSeller[i]);
            }
        }
    }
    
    boolean FoodUnitsStillNeededValid=SBUDTSFobj.FoodUnitsStillNeededValid;
    int FoodUnitsStillNeededLen = 0;
    int[]  FoodUnitsStillNeeded = null;
    if(FoodUnitsStillNeededValid == true)
    {
        FoodUnitsStillNeededLen = SBUDTSFobj.FoodUnitsStillNeededLen;
        if(FoodUnitsStillNeededLen > 0)
        {
            FoodUnitsStillNeeded = new int[FoodUnitsStillNeededLen];
            for(int i=0;i<FoodUnitsStillNeededLen;i++)
            {
                FoodUnitsStillNeeded[i] = SBUDTSFobj.FoodUnitsStillNeeded[i];
            }
        }
    }
    
    //seller stuff
    int SellerFoodUnitsTradedLen =SBUDTSFobj.SellerFoodUnitsTradedLen;
    int[] SellerFoodUnitsTraded =null;
    String[] FoodUnitsTradedWithBuyer =null;
    if(SellerFoodUnitsTradedLen > 0)
    {
        SellerFoodUnitsTraded =new int[SellerFoodUnitsTradedLen];
        FoodUnitsTradedWithBuyer =new String[SellerFoodUnitsTradedLen];
        for(int i=0;i<SellerFoodUnitsTradedLen;i++)
        {
            SellerFoodUnitsTraded[i] = SBUDTSFobj.SellerFoodUnitsTraded[i];
            FoodUnitsTradedWithBuyer[i] =new String(SBUDTSFobj.FoodUnitsTradedWithBuyer[i]);
        }
    }
    
    int countIfAnyFBuyersUnfulfilled = SBUDTSFobj.countIfAnyFBuyersUnfulfilled;
    String[] FBuyerLoginsNotFulfilled=null;
    int[] FBuyerUnitsNeededFromYou = null;
    if(countIfAnyFBuyersUnfulfilled > 0)
    {
        FBuyerLoginsNotFulfilled = new String[countIfAnyFBuyersUnfulfilled];
        FBuyerUnitsNeededFromYou = new int[countIfAnyFBuyersUnfulfilled];
        for(int i=0;i<countIfAnyFBuyersUnfulfilled;i++)
        {
            FBuyerLoginsNotFulfilled[i] = new String(SBUDTSFobj.FBuyerLoginsNotFulfilled[i]);
            FBuyerUnitsNeededFromYou[i] = SBUDTSFobj.FBuyerUnitsNeededFromYou[i];
        }
    }
    
    //buyer stuff
    boolean BuyerEnergyUnitsTradedValid=SBUDTSFobj.BuyerEnergyUnitsTradedValid;
    int BuyerEnergyUnitsTradedLen =0;
    int[] BuyerEnergyUnitsTraded =null;
    String[] EnergyUnitsTradedWithSeller =null;
    if(BuyerEnergyUnitsTradedValid==true)
    {
        BuyerEnergyUnitsTradedLen = SBUDTSFobj.BuyerEnergyUnitsTradedLen;
        if(BuyerEnergyUnitsTradedLen > 0)
        {
            BuyerEnergyUnitsTraded = new int[BuyerEnergyUnitsTradedLen];
            EnergyUnitsTradedWithSeller = new String[BuyerEnergyUnitsTradedLen];
            for(int i=0;i<BuyerEnergyUnitsTradedLen;i++)
            {
                BuyerEnergyUnitsTraded[i] = SBUDTSFobj.BuyerEnergyUnitsTraded[i];
                EnergyUnitsTradedWithSeller[i] = new String(SBUDTSFobj.EnergyUnitsTradedWithSeller[i]);
            }
        }
    }
    boolean EnergyUnitsStillNeededValid=SBUDTSFobj.EnergyUnitsStillNeededValid;
    int EnergyUnitsStillNeededLen = 0;
    int[]  EnergyUnitsStillNeeded = null;
    if(EnergyUnitsStillNeededValid == true)
    {
        EnergyUnitsStillNeededLen = SBUDTSFobj.EnergyUnitsStillNeededLen;
        if(EnergyUnitsStillNeededLen > 0)
        {
            EnergyUnitsStillNeeded = new int[EnergyUnitsStillNeededLen];
            for(int i=0;i<EnergyUnitsStillNeededLen;i++)
            {
                EnergyUnitsStillNeeded[i] = SBUDTSFobj.EnergyUnitsStillNeeded[i];
            }
        }
    }
    
    //seller stuff
    int SellerEnergyUnitsTradedLen =SBUDTSFobj.SellerEnergyUnitsTradedLen;
    int[] SellerEnergyUnitsTraded =null;
    String[] EnergyUnitsTradedWithBuyer =null;
    if(SellerEnergyUnitsTradedLen > 0)
    {
        SellerEnergyUnitsTraded =new int[SellerEnergyUnitsTradedLen];
        EnergyUnitsTradedWithBuyer =new String[SellerEnergyUnitsTradedLen];
        for(int i=0;i<SellerEnergyUnitsTradedLen;i++)
        {
            SellerEnergyUnitsTraded[i] = SBUDTSFobj.SellerEnergyUnitsTraded[i];
            EnergyUnitsTradedWithBuyer[i] =new String(SBUDTSFobj.EnergyUnitsTradedWithBuyer[i]);
        }
    }
    
    int countIfAnyEBuyersUnfulfilled = SBUDTSFobj.countIfAnyEBuyersUnfulfilled;
    String[] EBuyerLoginsNotFulfilled=null;
    int[] EBuyerUnitsNeededFromYou = null;
    if(countIfAnyEBuyersUnfulfilled > 0)
    {
        EBuyerLoginsNotFulfilled = new String[countIfAnyEBuyersUnfulfilled];
        EBuyerUnitsNeededFromYou = new int[countIfAnyEBuyersUnfulfilled];
        for(int i=0;i<countIfAnyEBuyersUnfulfilled;i++)
        {
            EBuyerLoginsNotFulfilled[i] = new String(SBUDTSFobj.EBuyerLoginsNotFulfilled[i]);
            EBuyerUnitsNeededFromYou[i] = SBUDTSFobj.EBuyerUnitsNeededFromYou[i];
        }
    }
    
	
    int  distinctMSellerLoginsLen=SBUDTSFobj.distinctMSellerLoginsLen;
    boolean[] MSellerinST=null;
    boolean[] FSellerinST=null;
    boolean[] ESellerinST=null;
    boolean[] MisRokdaEnough=null;
    boolean[] FisRokdaEnough=null;
    boolean[] EisRokdaEnough=null;
    
    String[] distinctMSellerLogins=null;
    if(distinctMSellerLoginsLen > 0)
    {
        distinctMSellerLogins = new String[distinctMSellerLoginsLen];
        MSellerinST = new boolean[distinctMSellerLoginsLen];
        MisRokdaEnough = new boolean[distinctMSellerLoginsLen];
        for(int i=0;i<distinctMSellerLoginsLen;i++)
        {
            distinctMSellerLogins[i]=SBUDTSFobj.distinctMSellerLogins[i];
            MSellerinST[i] = SBUDTSFobj.MSellerinST[i];
            MisRokdaEnough[i] = SBUDTSFobj.MisRokdaEnough[i];
        }
    }
    int  distinctFSellerLoginsLen=SBUDTSFobj.distinctFSellerLoginsLen;
    String[] distinctFSellerLogins=null;
    if(distinctFSellerLoginsLen > 0){
        distinctFSellerLogins = new String[distinctFSellerLoginsLen];
        FSellerinST = new boolean[distinctFSellerLoginsLen];
        FisRokdaEnough = new boolean[distinctFSellerLoginsLen];
        
        for(int i=0;i<distinctFSellerLoginsLen;i++)
        {
            distinctFSellerLogins[i]=SBUDTSFobj.distinctFSellerLogins[i];
            FSellerinST[i] = SBUDTSFobj.FSellerinST[i];
            FisRokdaEnough[i] = SBUDTSFobj.FisRokdaEnough[i];
            
        }
    }
    
    int  distinctESellerLoginsLen=SBUDTSFobj.distinctESellerLoginsLen;
    String[] distinctESellerLogins=null;
    if(distinctESellerLoginsLen > 0)
    {
        distinctESellerLogins = new String[distinctESellerLoginsLen];
        ESellerinST = new boolean[distinctESellerLoginsLen];
        EisRokdaEnough = new boolean[distinctESellerLoginsLen];
        
        for(int i=0;i<distinctESellerLoginsLen;i++)
        {
            distinctESellerLogins[i]=SBUDTSFobj.distinctESellerLogins[i];
            ESellerinST[i] = SBUDTSFobj.ESellerinST[i];
            EisRokdaEnough[i] = SBUDTSFobj.EisRokdaEnough[i];
            
        }
    }
    int totalMBuyerCount = SBUDTSFobj.totalMBuyerCount;
    int totalFBuyerCount = SBUDTSFobj.totalFBuyerCount;
    int totalEBuyerCount = SBUDTSFobj.totalEBuyerCount;
    
    int MSellerCount = SBUDTSFobj.MSellerCount;
    int FSellerCount = SBUDTSFobj.FSellerCount;
    int ESellerCount = SBUDTSFobj.ESellerCount;
    
    int[] totalBuyerCounts = new int[3];
    totalBuyerCounts[0] = totalMBuyerCount;
    totalBuyerCounts[1] = totalFBuyerCount;
    totalBuyerCounts[2] = totalEBuyerCount;
    
    int[] SellerCounts = new int[3];
    SellerCounts[0] = MSellerCount;
    SellerCounts[1] = FSellerCount;
    SellerCounts[2] = ESellerCount;

    int countIsMSellerForAnyBuyer=SBUDTSFobj.countIsMSellerForAnyBuyer; //is a seller
    int countIsFSellerForAnyBuyer=SBUDTSFobj.countIsFSellerForAnyBuyer; //is a seller
    int countIsESellerForAnyBuyer=SBUDTSFobj.countIsESellerForAnyBuyer; //is a seller
    
    boolean boolMTDCheck=SBUDTSFobj.boolMTDCheck;//if trade done
    boolean boolFTDCheck=SBUDTSFobj.boolFTDCheck;//if trade done
    boolean boolETDCheck=SBUDTSFobj.boolETDCheck;//if trade done
    
    
    boolean [] boolSTDCheck = new boolean[3];
    boolSTDCheck[0]= boolMTDCheck;
    boolSTDCheck[1]= boolFTDCheck;
    boolSTDCheck[2]= boolETDCheck;
    
    int [] countIsSellerForAnyBuyer= new int[3];
    countIsSellerForAnyBuyer[0]= countIsMSellerForAnyBuyer;
    countIsSellerForAnyBuyer[1]= countIsFSellerForAnyBuyer;
    countIsSellerForAnyBuyer[2]= countIsESellerForAnyBuyer;
    
    boolean[] BuyerUnitsTradedValid = new boolean[3];
    BuyerUnitsTradedValid[0] = BuyerMineUnitsTradedValid;
    BuyerUnitsTradedValid[1] = BuyerFoodUnitsTradedValid;
    BuyerUnitsTradedValid[2] = BuyerEnergyUnitsTradedValid;
    
    int[] BuyerUnitsTradedLen = new int[3];
    BuyerUnitsTradedLen[0] = BuyerMineUnitsTradedLen;
    BuyerUnitsTradedLen[1] = BuyerFoodUnitsTradedLen;
    BuyerUnitsTradedLen[2] = BuyerEnergyUnitsTradedLen;
    
    int[] SellerUnitsTradedLen = new int[3];
    SellerUnitsTradedLen[0] = SellerMineUnitsTradedLen;
    SellerUnitsTradedLen[1] = SellerFoodUnitsTradedLen;
    SellerUnitsTradedLen[2] = SellerEnergyUnitsTradedLen;
    int waitandpoll = SBUDTSFobj.waitandpollstatus;
    
    int recvMSellToStore = SBUDTSFobj.recvMSellToStore;
    int recvFSellToStore = SBUDTSFobj.recvFSellToStore;
    int recvESellToStore = SBUDTSFobj.recvESellToStore;
    
    try{
        ARFobj  = new AuctionResultForm(sbocode,waitandpoll, countIsSellerForAnyBuyer,
                        boolSTDCheck,BuyerUnitsTradedValid,BuyerUnitsTradedLen,
                        BuyerMineUnitsTraded,MineUnitsTradedWithSeller,
                        BuyerFoodUnitsTraded,FoodUnitsTradedWithSeller,
                        BuyerEnergyUnitsTraded,EnergyUnitsTradedWithSeller,
                        SellerUnitsTradedLen,SellerMineUnitsTraded,MineUnitsTradedWithBuyer,
                        SellerFoodUnitsTraded,FoodUnitsTradedWithBuyer,
                        SellerEnergyUnitsTraded,EnergyUnitsTradedWithBuyer,
                        totalBuyerCounts,SellerCounts,
                        distinctMSellerLoginsLen,distinctFSellerLoginsLen,distinctESellerLoginsLen,
                        distinctMSellerLogins,distinctFSellerLogins,distinctESellerLogins,
                        MSellerinST,FSellerinST,ESellerinST ,
                        MisRokdaEnough,FisRokdaEnough,EisRokdaEnough,
                        countIfAnyMBuyersUnfulfilled,countIfAnyFBuyersUnfulfilled,countIfAnyEBuyersUnfulfilled,
                        MBuyerLoginsNotFulfilled,FBuyerLoginsNotFulfilled,EBuyerLoginsNotFulfilled,
                        MBuyerUnitsNeededFromYou,FBuyerUnitsNeededFromYou,EBuyerUnitsNeededFromYou,
                        MineUnitsStillNeededValid,FoodUnitsStillNeededValid,EnergyUnitsStillNeededValid,
                        MineUnitsStillNeededLen,FoodUnitsStillNeededLen,EnergyUnitsStillNeededLen,
                        MineUnitsStillNeeded,FoodUnitsStillNeeded,EnergyUnitsStillNeeded,finishAuction,
                        recvMSellToStore,recvFSellToStore,recvESellToStore
                      );
        Display.getDisplay(this).setCurrent(ARFobj);        
    }
    catch(Exception e)
    {
        System.out.println("Problem in initialising the Buyerseleer");
        e.printStackTrace();
    }
 }
 
 Command[] getAuctionWaitAndPollCommands()
 {
       Command[] commands ={
           new Command("WAIT AND POLL",Command.SCREEN,1)
       };
       return commands;
     
 }
 Runnable[] getAuctionWaitAndPollActions()
 {
       class WaitAndPollAuction implements Runnable
       {
           public void run()
           {
               doWaitAndPollAuction();
           }
       }
       Runnable [] callbacks = {
           
           new WaitAndPollAuction()
       };
       return callbacks;

 }
 
 void doWaitAndPollAuction()
 {
       int intWaitAndPollStatus = 1;
       int intGameNumber = 0;
       String loginApproved = null;
       try
       {
           if(mGameLoginRSLoaded==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded =true;
           }
           intGameNumber = Integer.parseInt(new String(mGameLoginRS.get(kGameNo)));
           loginApproved = new String(mGameLoginRS.get(kLogin));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
       int finishAuction = 0;  
       try
       {
           SBUDTSFobj = new SubmitBuyUnitsDoTradeStatusForm(intGameNumber,loginApproved,intWaitAndPollStatus,finishAuction);
           Display.getDisplay(this).setCurrent(SBUDTSFobj);
       }
       catch(Exception e )
       {
           e.printStackTrace();
       }
       SBUDTSFobj.start();
 }

 
 Command getLogOutCommand()
 {
     Command command = new Command("Log Out",Command.SCREEN,1);
     return command;
     
 }
 
 Runnable[] getLogOutAction()
 {
     class LogOut implements Runnable{
         public void run()
         {
             doLogOut();
         }
     }
     Runnable[] callback = {
         new LogOut()
     };
     return callback;
 }
 
 void doLogOut()
 {
      int intGameNumber = 0;
       String loginApproved = null;
       try
       {
           if(mGameLoginRSLoaded==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded =true;
           }
           intGameNumber = Integer.parseInt(new String(mGameLoginRS.get(kGameNo)));
           loginApproved = new String(mGameLoginRS.get(kLogin));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
    
    try
    {
         LOSFobj = new LogOutStatusForm(intGameNumber,loginApproved);
         Display.getDisplay(this).setCurrent(LOSFobj);
    }
    catch(Exception e)
    {
         e.printStackTrace();
    }
    LOSFobj.start();
 }
 
 Command[] getAuctionGetScoreCommands()
 {
       Command[] commands ={
           new Command("GET SCORE",Command.SCREEN,1)
       };
       return commands;
     
 }
 
 Runnable[] getAuctionGetScoreActions()
 {
       class GetScore implements Runnable
       {
           public void run()
           {
               doGetScore();
           }
       }
       Runnable [] callbacks = {
           
           new GetScore()
       };
       return callbacks;
 }
 
 void doGetScore()
 {
     System.out.println("Get the score ");
     int intGameNumber = 0;
     String loginApproved = null;
     try
     {
           if(mGameLoginRSLoaded==false)
           {
               mGameLoginRS.load();
               mGameLoginRSLoaded =true;
           }
           intGameNumber = Integer.parseInt(new String(mGameLoginRS.get(kGameNo)));
           loginApproved = new String(mGameLoginRS.get(kLogin));
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
    
       try
       {
          GSSobj = new GetScoreStatus(intGameNumber,loginApproved);
       }
       catch(Exception e)
       {
         e.printStackTrace();
       }
       GSSobj.start();
   }
}