
package edu.sjsu.cs298.mymule.core;

import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.lang.StringBuffer;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

	
/**
 * @author Rekha
 * Get the games being played in the system and send to the player
 */
//hi
public class AcquireGetGamesListServlet extends HttpServlet{
	
	GamesList gl = null;
	
	public void doPost(HttpServletRequest request,HttpServletResponse response) throws IOException{

		ServletInputStream in = request.getInputStream(); 
    	DataInputStream    din = new DataInputStream( in );

    	String loginFromClient = din.readUTF();
    	String pwd = din.readUTF();
    	din.close();

    	int NoOfGames=0;
    	int [] NoOfPlayers=null;
    	String[][] login =null;
    	int loginStatus = 0;
		
		gl = new GamesList(loginFromClient,pwd);
        
        ByteArrayOutputStream bout = new ByteArrayOutputStream();
    	DataOutputStream dout = new DataOutputStream(bout);
	 
		loginStatus = gl.getLoginStatus();
		if((loginStatus == 1)||(loginStatus == 3)||(loginStatus == 2)){
			NoOfGames = gl.getNoOfGames();
			NoOfPlayers = new int[NoOfGames];
			login = new String[NoOfGames][];
			System.out.println("in DO POSt");		
	
			for(int i =0;i<NoOfGames ; i++){
				NoOfPlayers[i] = gl.getNoOfPlayers(i);
				login[i] = new String[NoOfPlayers[i]];
				for(int j=0;j<login[i].length;j++){
					login[i][j] = new String(gl.getLogin(i,j));
				}
			}
			
			System.out.println(loginStatus);
			System.out.println(NoOfGames);
			for(int i = 0;i<NoOfGames;i++){
				System.out.println("NoOfPlayers["+i+"]"+NoOfPlayers[i]);
					for(int j =0;j<NoOfPlayers[i];j++){
						System.out.println("Login["+i+"]["+j+"]"+login[i][j]);
					}
	
			}
			dout.writeInt(loginStatus);		
			// send login status
			dout.writeInt(NoOfGames);
			//send noofgames
			for(int i=0;i<NoOfGames;i++){
				dout.writeInt(NoOfPlayers[i]);
					for(int j=0;j<login[i].length;j++){
						dout.writeUTF(login[i][j]);
						//send login
					}
			}

		} else {
				System.out.println(loginStatus);	
				dout.writeInt(loginStatus);
		}

		response.setContentType("application/octet-stream");
		
		
		byte[] data = bout.toByteArray();
                       
    	response.setContentLength( data.length );
    	response.setStatus( response.SC_OK );
		
		
		OutputStream out = response.getOutputStream();
    	out.write (data );
    	out.close();                       

	 	   	
	}
	
	public void doGet(HttpServletRequest request, HttpServletResponse response)
   	throws ServletException,IOException{
   		doPost(request,response);
   	}


}


class GamesList {
	

	private Connection connection=null;
	private int NoOfGames = 0;
	private int[] NoOfPlayers= null;
	private String[][] login= null;
	
	String players_table = "PLAYERS_TABLE";
	
	int intNoOfGames=0;
	int[] intNoOfPlayers;
	String[][] strLoginPlayers;
	
	String loginStr;
	String pwdStr;
	int loginStatus=0;
	
	
	public GamesList(String login,String pwd) {
	
		loginStr = new String(login);
		pwdStr = new String(pwd);
		init();
	}

	private void init() {

		getConnection();
		checkLoginPwd();
		if((loginStatus == 1)||(loginStatus == 3)||(loginStatus == 2)){//Only if the loginStatus needs the game list get it
		    System.out.println("came here 1");
			queryPlayersTable();
		}
		
		
	}
	
		private void getConnection(){
		try {
			Class.forName  ("com.mysql.jdbc.Driver");

		} catch(ClassNotFoundException ej){
			System.out.println("Problem 1");
			ej.printStackTrace();
		}
		String dbURL   = "jdbc:mysql://localhost/muledb";
		String username="root", password="";
		try{
			connection=DriverManager.getConnection(dbURL,username,password);
		} catch (Exception ex){
			System.out.println("Problem 3");
			ex.printStackTrace();
		}
	}

	void checkLoginPwd(){
	    
		Statement SelectStatement1 = null;
		String sql1 = null;
		ResultSet rs1 = null;
		String regLogin=null,regPassword=null,regColor=null;
		int regGame=0;
		int count=0;
		
		try {
			SelectStatement1 = connection.createStatement();
			sql1 = new String("select * from "+players_table+
							 " where login='"+loginStr+"' AND password='"+
							  pwdStr+"'");//no of rows in the players table
			System.out.println(sql1);
			rs1 = SelectStatement1.executeQuery(sql1);
			System.out.println("came here "+sql1);
			count =0;
			while (rs1.next()){
				count++;
				regLogin = rs1.getString(1);
				regPassword = rs1.getString(2);
				regColor = rs1.getString(3);
				regGame = rs1.getInt(4);
			}	
			SelectStatement1.close();
			if(count>0){
				if((regGame == 0) &&(regColor.equals("not_valid"))){
					loginStatus = 1; // this means the user is registered so can have the games list
				}else if((regGame!=0)&&((regColor.equals("not_valid"))==false)){
					loginStatus = 2;//this means that the registered user is already playing
				}else if((regGame!=0)&&(regColor.equals("not_valid")) ){
					loginStatus = 3; //the player had logged in before but he logged out.
				}
				
			}
			if (count==0){
				loginStatus = 0; // this means that the user has to register or try logging again
			}
			
		}catch(SQLException ioe){
			ioe.printStackTrace();
		}	
	
	
	}
	
	


	private void queryPlayersTable() {
		
		Statement DeleteStatement = null;
		Statement SelectStatement = null;
		Statement SelectStatement2 = null;
		Statement SelectStatement3 = null;
		Statement SelectStatement4 = null;

		String sql = null;
		String sql2 = null;
		String sql3 = null;
		String sql4 = null;
		
		ResultSet rs = null,rs1 = null,rs2=null,rs3 = null;
		int game[] = null;
		int res =0;
		
		try {
			//count of the rows whose color is set and game is set
			SelectStatement = connection.createStatement();
			sql = new String("select count(*) from "+players_table+
							" where color != 'not_valid' and game != 0");//no of rows in the players table
			System.out.println(sql);
			rs = SelectStatement.executeQuery(sql);
			while (rs.next()){
				res = rs.getInt(1);
				System.out.println(res);
			}	
			SelectStatement.close();
		//	connection.commit();
			
			//get the games list with game Numbers
			
			if(res!=0){ //there are users already
				SelectStatement2 = connection.createStatement();
				sql2 = new String("select distinct(game) from "+players_table+
								   " where game != 0 order by game");
				System.out.println(sql2);
				rs1 = SelectStatement2.executeQuery(sql2);
				int i =0;
				game = new int[res];//initialized to no of games in the system
		
				while(rs1.next()){
						game[i]= rs1.getInt(1);
						System.out.println("Game["+i+"]::"+game[i]);	
						i++;
				}
				SelectStatement2.close();
		//		connection.commit();
			
				//get the no of players in each game
						
				String tempStr = null;
				int l;
				NoOfPlayers = new int[i];
				System.out.println("NoOfPlayers"+NoOfPlayers.length);
				l=0;
				for(int k=0;k<i;k++){//i is taken because only the number of games can be less than 5
					SelectStatement3 = connection.createStatement();
					sql3= new String("select count(*) from "+players_table+" where game = "+game[k]);
					System.out.println(sql3);
					rs2 = SelectStatement3.executeQuery(sql3);
					
					while(rs2.next()){
						NoOfPlayers[l] = rs2.getInt(1);
						System.out.println("Count["+l+"]::"+NoOfPlayers[l]);
					}
					l++;
					SelectStatement3.close();
		//			connection.commit();
				}
				for(int count=0;count<i;count++){
					System.out.println("NoOfPlayers["+count+"]"+NoOfPlayers[count]);
				}
				
				//get the logins from the players table in each game
				login = new String[i][];
				int noOfPlayers =0;
				for(int k=0;k<login.length;k++){	
					SelectStatement4 = connection.createStatement();
					sql4 = new String("select login from players_table where game="+game[k]);
					System.out.println(sql4);
					rs3 = SelectStatement4.executeQuery(sql4);
					noOfPlayers = NoOfPlayers[k];
					System.out.println("NoOfPlayers["+k+"]"+NoOfPlayers[k]);
					login[k] = new String[noOfPlayers];
					int p=0;
					while(rs3.next()){
						login[k][p] = new String(rs3.getString(1));
						System.out.println("login["+k+"]["+p+"]:"+login[k][p]);
						p++;
					}
					System.out.println("p"+p);		
					SelectStatement4.close();		
		//			connection.commit();
				}

				intNoOfGames = i;
				System.out.println("intNoOfGames"+intNoOfGames);
				intNoOfPlayers = new int[intNoOfGames];
				strLoginPlayers = new String[intNoOfGames][];
				for(int j = 0 ; j < intNoOfGames ; j++){
					intNoOfPlayers[j] = NoOfPlayers[j];
					strLoginPlayers[j] = new String[intNoOfPlayers[j]]; 
					for(int k =0;k<strLoginPlayers[j].length;k++){
						strLoginPlayers[j][k] = login[j][k];
					}
				}
				
				System.out.println("intNoOfGames"+intNoOfGames);
				for(int j = 0 ; j < intNoOfGames ; j++){
					System.out.println("intNoOfPlayers["+j+"]"+intNoOfPlayers[j]);
					for(int k = 0; k<strLoginPlayers[j].length;k++){
						System.out.println("strLoginPlayers["+j+"]["+k+"]"+strLoginPlayers[j][k]);
					}
				}
				
			}else{
				NoOfGames = 0;			
			}
	   
		} catch (SQLException se){
				System.out.println("Problem 5");
				se.printStackTrace();
		}
		
   }

	
	/**
	 * @return
	 */
	public int getNoOfGames() {
		
		return intNoOfGames;
	}
	
	public int getNoOfPlayers(int gameNo){
		return intNoOfPlayers[gameNo];
		
	}
	
	public String getLogin(int gameNo,int PlayerNo){

		return strLoginPlayers[gameNo][PlayerNo];
		
	}
	
	public int getLoginStatus(){
		return loginStatus;
	}
	
	
}

