
package edu.sjsu.cs298.mymule.core;


import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.lang.StringBuffer;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

	
/**
 * @author Rekha
 * To get the landscape of the game world
 */
 //hi

public class AcquireGetPlotServlet extends HttpServlet{
	
	LandscapeCopy ls = null;
	
	public void doPost(HttpServletRequest request,HttpServletResponse response) throws IOException{

    	// Get the input stream and read the data...
		ServletInputStream in = request.getInputStream(); 
    	DataInputStream    din = new DataInputStream( in );
		
		//get the game Number
    	int gameNo = din.readInt();
    	din.close();
		
		ls = new LandscapeCopy(gameNo,15,15);
		String res = new String(ls.getAr());
		response.setContentType( 
                          "application/octet-stream" );
        System.out.println(res); 
        ByteArrayOutputStream bout = 
                           new ByteArrayOutputStream();
    	DataOutputStream dout = 
                          new DataOutputStream( bout );
		
		//write the rows, cols, the whole game_land_Table
		dout.writeInt(ls.rows);
		System.out.println(ls.rows);
		dout.writeInt(ls.cols);
		System.out.println(ls.cols);
        dout.writeUTF(res);
        System.out.println(res);
        dout.writeInt(ls.countSel); // the count of the selected plots already
        System.out.println(ls.countSel);
        if(ls.countSel>0){
        	for(int i=0;i<ls.countSel;i++){
        		dout.writeInt(ls.selX[i]);
        		System.out.println(ls.selX[i]);
        		dout.writeInt(ls.selY[i]);
        		System.out.println(ls.selY[i]);
        		dout.writeUTF(ls.selLogin[i]);
        		System.out.println(ls.selLogin[i]);
        		dout.writeUTF(ls.selColor[i]);
        		System.out.println(ls.selColor[i]);
        	}
        }
        byte[] data = bout.toByteArray();
                       
    	response.setContentLength( data.length );
    	response.setStatus( response.SC_OK );
		

		OutputStream out = response.getOutputStream();
    	out.write (data );
    	out.close();                       

	 	   	
	}
	
	public void doGet(HttpServletRequest request, HttpServletResponse response)
   	throws ServletException,IOException{
   		doPost(request,response);
   	}


}


class LandscapeCopy {
	public int cols = 0;
	public int rows = 0;
	private int ar[][];
	private Connection connection=null;
	
	int gameNumber = 0;
	
	String gameLandTable = "GAME_LAND_TABLE";
	String gameLandAverageTable = "GAME_LAND_AVERAGE_TABLE";
	

	String games_status_table = "GAME_STATUS_TABLE";
	String plot_selection_table = "plot_selection_table";	
	String players_table="players_table";
	String arStr = new String("");
	int countSel=0;

	int[] selX=null;
	int[] selY=null;
	String[] selLogin=null;
	String[] selColor=null;
	
	public LandscapeCopy(int gameNo,int c, int r) {
		cols = c;
		rows = r;
		gameNumber = gameNo;
			
		ar = new int[c][r];
		getConnection();
		
		String game_status = checkGamesStatusTable();
		if(game_status.equals("started")){
			selectDatabase();
			countSel = getSelectionsIfAny();		
		}else if(game_status.equals("not_yet_started") || (game_status.equals(""))){
			updateGamesStatusTable(game_status);
			init();
			updateDatabase1();
			updateDatabase2();
			
		}
		

	}

	private void init() {

		java.util.Random r = new java.util.Random();
		for (int i = 0; i < rows; i++) {
			for (int j = 0; j < cols; j++) {
				ar[i][j] = Math.abs(r.nextInt(4)+1)*100 + Math.abs(r.nextInt(4)+1)*10+Math.abs(r.nextInt(4)+1);				
			}
		}
	}
	
		private void getConnection(){
		try {
			Class.forName  ("com.mysql.jdbc.Driver");

		} catch(ClassNotFoundException ej){
			System.out.println("Problem 1");
			ej.printStackTrace();
		}
		String dbURL   = "jdbc:mysql://localhost/muledb";
		String username="root", password="";
		try{
			connection=DriverManager.getConnection(dbURL,username,password);
		} catch (Exception ex){
			System.out.println("Problem 3");
			ex.printStackTrace();
		}
	}

	private void updateDatabase1() {
		Statement UpdateStatement = null; 
		
		int farmValue,mineValue,techValue = 0;
		Integer intxObj,intyObj,intfarmObj,intmineObj,inttechObj;
		String xStrVal,yStrVal,farmStr,mineStr,techStr;
	
		try{
		for(int x = 0; x < rows ; x=x+1){
			for(int y = 0; y < cols; y=y+1 ){
				    String sql1 = null;
					UpdateStatement = connection.createStatement();
					farmValue = ar[x][y]/100;
					mineValue = (ar[x][y]%100)/10;
					techValue = (ar[x][y]%100)%10;
					sql1 = new String("insert into "+gameLandTable+"(game,x,y,farm,mine,tech,status)"+
								" values("+gameNumber+","+x+","+y+","+farmValue+","+mineValue+
								","+techValue+",'not_taken'"+")");
					
					System.out.println(sql1);
					intxObj = new Integer(x);
					intfarmObj = new Integer(farmValue);
					farmStr = intfarmObj.toString();
					intmineObj = new Integer(mineValue);
					mineStr = intmineObj.toString();
					inttechObj = new Integer(techValue);
					techStr = inttechObj.toString();
					arStr = arStr.concat( "x"+x+"y"+y+":"+mineStr+farmStr+techStr);
					System.out.println(arStr);

					UpdateStatement.executeUpdate(sql1);
					System.out.println("doing update"+sql1);
					UpdateStatement.close();
					//connection.commit();
							    		
			}
		}
		}catch(Exception exx){
			System.out.println("Problem 6");
			System.err.println("SQLException: " + exx.getMessage());
			exx.printStackTrace();
		}
		    
		
	}
	
	public void updateDatabase2(){
		Statement UpdateStatement = null; 
		
		int avgfarmValue,avgmineValue,avgtechValue = 0;
		Integer intxObj,intyObj,intfarmObj,intmineObj,inttechObj;
		String xStrVal,yStrVal,farmStr,mineStr,techStr;
	
		try{
		for(int x = 0; x < rows ; x=x+3){
			for(int y = 0; y < cols; y=y+3 ){
				    String sql1 = null;
					UpdateStatement = connection.createStatement();
					avgfarmValue = getAvgFarm(x,y);
					avgmineValue = getAvgMine(x,y);
					avgtechValue = getAvgTech(x,y);
					sql1 = new String("insert into "+gameLandAverageTable+"(game,x,y,avgfarm,avgmine,avgtech,status)"+
								" values("+gameNumber+","+x+","+y+","+avgfarmValue+","+avgmineValue+
								","+avgtechValue+",'not_taken'"+")");
					
					System.out.println(sql1);
					UpdateStatement.executeUpdate(sql1);
					System.out.println("doing update"+sql1);
					UpdateStatement.close();
					//connection.commit();
							    		
			}
		}
		}catch(Exception exx){
			System.out.println("Problem 6");
			System.err.println("SQLException: " + exx.getMessage());
			exx.printStackTrace();
		}
	}


	//Average Mine Value of the 3 * 3 rectangle
	public int getAvgMine(int k,int l){
		int totalmine=0;
		int [][] minevalue = new int[3][3];
		minevalue = getSpecPlotMineValues( k, l);

	    for(int i=0;i<3;i++){
			for(int j=0;j<3;j++){
						totalmine = totalmine + minevalue[i][j];  
					}
	    }
		
		int avgmine = totalmine/9;
		return avgmine;
		
	}
	
	//THe specific Mine values of the 3*3 rectangle
	public int[][] getSpecPlotMineValues(int k,int l){
		int index =0;
		int[][] minevalue= new int[3][3];
		for(int i=k,m=0;i<k+3;i++,m++){
		   for(int j=l,n=0;j<l+3;j++,n++){
			 //minevalue[m][n] = ar[i][j]/100;
			 minevalue[m][n] = (ar[i][j]%100)/10;
			 
		   }
		}
		return minevalue;
	}
	
	//The Average of speciifc Farm Values of the 3 * 3 rectangle
	public int getAvgFarm(int k,int l){
		int totalfarm = 0;
		int [][] farmvalue = new int[3][3];
		farmvalue = getSpecPlotFarmValues( k, l);

		for(int i=0;i<3;i++){
				for(int j=0;j<3;j++){
				totalfarm = totalfarm + farmvalue[i][j];  
			}
		}
		int avgfarm = totalfarm/9;
		return avgfarm;		
	}	

	//speciifc Farm Values of the 3 * 3 rectangle
	public int[][] getSpecPlotFarmValues(int k,int l){
		int index =0;
		int[][] farmvalue= new int[3][3];
		for(int i=k,m=0;i<k+3;i++,m++){
			for(int j=l,n=0;j<l+3;j++,n++){
				//farmvalue[m][n] =(ar[i][j]%100)/10;
				farmvalue[m][n] = ar[i][j]/100;
				
			}
		}
		return farmvalue;
	}
		
	//Average of speciifc Farm Values of the 3 * 3 rectangle			
	public int getAvgTech (int k,int l){
		int[][] techvalue= new int[3][3];
		int totaltech=0;
		techvalue = getSpecPlotTechValues( k, l);

		for(int i=0;i<3;i++){
			for(int j=0;j<3;j++){
			totaltech = totaltech + techvalue[i][j];
			}  
		}
		int avgtech = totaltech/9;
		return avgtech;		
		
	}
	//speciifc Farm Values of the 3 * 3 rectangle
	public int[][] getSpecPlotTechValues(int k,int l){
		int index =0;
		int[][] techvalue= new int[3][3];
		for(int i=k,m=0;i<k+3;i++,m++){
			for(int j=l,n=0;j<l+3;j++,n++){
				techvalue[m][n] = (ar[i][j]%100)%10;
				
				
			}
		}
		return techvalue;
	}







	
	public void selectDatabase(){
		Statement SelectStatement1 = null;
		String sql1 ;
		ResultSet rs1 = null;
		int xres =0;
		int yres =0;
		int farmres =0;
		int mineres =0;
		int techres =0;
		String statusres = null;
		arStr = new String("");		
		try {
			SelectStatement1 = connection.createStatement();
			sql1=new String("select x,y,farm,mine,tech,status from "+gameLandTable+
						" where game = "+gameNumber);
			System.out.println(sql1);
			rs1 = SelectStatement1.executeQuery(sql1);
		}catch(SQLException e){
			System.out.println("Problem 31");
			e.printStackTrace();
		}
		try{
			while (rs1.next()){
				xres = rs1.getInt(1);
				yres = rs1.getInt(2);
				farmres = rs1.getInt(3);
				mineres = rs1.getInt(4);
				techres = rs1.getInt(5);
				statusres = new String(rs1.getString(6));
				
				arStr = arStr.concat("x"+xres+"y"+yres+":"+mineres+farmres+techres);
				
			}	
			System.out.println(arStr);
			SelectStatement1.close();
//			connection.commit();
			   
		} catch (SQLException se){
			System.out.println("Problem 5");
			se.printStackTrace();
		}
		
			
	}
	
	public int getSelectionsIfAny(){
		Statement SelectStatement1=null;
		String sql1=null;
		ResultSet rs1=null;
		Statement SelectStatement2=null;
		String sql2=null;
		ResultSet rs2=null;
		
		Statement SelectStatement3=null;
		String sql3=null;
		ResultSet rs3=null;
		
		int count=0;
		int i=0;
		try {
			SelectStatement1 = connection.createStatement();
			sql1=new String("select count(*) from "+plot_selection_table+
						" where game = "+gameNumber);
			System.out.println(sql1);
			rs1 = SelectStatement1.executeQuery(sql1);
			
			while(rs1.next()){
				count = rs1.getInt(1);
			}
			SelectStatement1.close();
//			connection.commit();
			
		}catch(SQLException e){
			System.out.println("Problem 31");
			e.printStackTrace();
		}
		
		
		if(count>0){
			selX =  new int[count];
			selY =  new int[count];
			selLogin =  new String[count];

			selColor = new String[count];
			try{
				SelectStatement2 = connection.createStatement();
				sql2 =new String("select x,y,login from "+plot_selection_table+
								 " where game= "+gameNumber);
				System.out.println(sql2);
				rs2 = SelectStatement2.executeQuery(sql2);
				i=0;
				while(rs2.next()){
					selX[i] = rs2.getInt(1);
					selY[i] = rs2.getInt(2);
					selLogin[i] = new String(rs2.getString(3));
					SelectStatement3 = connection.createStatement();
					sql3 = new String("select color from "+players_table+
									  " where game="+gameNumber+" and login ='"+selLogin[i]+"'");
					rs3 = SelectStatement3.executeQuery(sql3);
					System.out.println(sql3);
					while(rs3.next()){
						selColor[i] = new String(rs3.getString(1));
					}
					SelectStatement3.close();
//					connection.commit();
					i++;
				}
				SelectStatement2.close();
//				connection.commit();
			}catch(SQLException e){
				e.printStackTrace();
			}
			
		}		
		return count;
	}
	
	
	public String checkGamesStatusTable(){
	
		Statement SelectStatement1 = null;
		String sql=null;
		Statement SelectStatement2 = null;
		String sql2=null;
		
		ResultSet rs = null;
		ResultSet rs2 = null;
		String res=null;
		int count=0;
		
		try {
			SelectStatement2 = connection.createStatement();
			sql2= new String("select count(*) from "+games_status_table+
							" where game="+gameNumber);
			System.out.println(sql2);
			rs2 = SelectStatement2.executeQuery(sql2);
		
			while (rs2.next()){
				count = rs2.getInt(1);
				System.out.println(count);
			}	
			SelectStatement2.close();
//			connection.commit();
			}catch(SQLException e){
			e.printStackTrace();
			
		}	
		
		
		if(count>0){
		
			try {
				SelectStatement1 = connection.createStatement();
				sql= new String("select status from "+games_status_table+
							" where game="+gameNumber);
				System.out.println(sql);
				rs = SelectStatement1.executeQuery(sql);
			}catch(Exception e){
				System.out.println("Problem 31");
			}
			try{
				while (rs.next()){
					res = rs.getString(1);
					System.out.println(res);
				}	
			SelectStatement1.close();
//			connection.commit();
					   
			} catch (SQLException se){
				System.out.println("Problem 5");
				se.printStackTrace();
			}
		}else{
			res= new String("");
			
		}
		System.out.println("res is "+res);
		return res;
	
	
	
	}

	private void updateGamesStatusTable(String game_status) {
		Statement UpdateStatement = null; 
		String sql2 = null;
		
		
		
			
		if(game_status.equals("not_yet_started")){
		try{
			UpdateStatement = connection.createStatement();
			sql2 = new String("update "+games_status_table+"  set status ='started'"+
							" where game="+gameNumber);
			System.out.println(sql2);
			UpdateStatement.executeUpdate(sql2);
			System.out.println("doing update"+sql2);
			UpdateStatement.close();
//			connection.commit();
		  }catch(Exception exx){
			System.out.println("Problem 6");
			System.err.println("SQLException: " + exx.getMessage());
			exx.printStackTrace();
		}
		}else if(game_status.equals("")){
		try{
			UpdateStatement = connection.createStatement();
			sql2 = new String("insert into "+games_status_table+" (game,status) values ("+
							   gameNumber+","+"'started')");
			System.out.println(sql2);
			UpdateStatement.executeUpdate(sql2);
			System.out.println(sql2);
			UpdateStatement.close();
//			connection.commit();
		  }catch(Exception exx){
			System.out.println("Problem 6");
			System.err.println("SQLException: " + exx.getMessage());
			exx.printStackTrace();
		}
			
		}
		    
		
	}
	

	
	/**
	 * @return
	 */
	public String getAr() {
		
		return arStr;
	}
	
	
}


