
package edu.sjsu.cs298.mymule.core;

import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.lang.StringBuffer;
import java.io.*;
import java.util.*;
import java.io.IOException;
import java.util.*;
import org.nfunk.jep.*;
import org.nfunk.jep.type.*;
import java.util.Arrays;

/*
 * @author Rekha
 * The Servlet that gets the current score 
 *
 */
 public class AcquireGetScoreServlet extends HttpServlet{

 	Properties props = null;
	String CalculateScoreString1; 
	String CalculateScoreString2; 
	String StoreMinePrice;
	String StoreFoodPrice;
	String StoreEnergyPrice;
	String caseNumber;
   
    AcquireGetScore gs = null;
    
    public void init() throws ServletException{
		try{
		    String path = "";
		    path = "/WEB-INF/"+getServletContext().getInitParameter("gamepropertyfile");
		    String realPath;
		    realPath = getServletContext().getRealPath(path);
		
		    if (realPath != null){
			    InputStream fis = new FileInputStream(realPath);
			    props = new Properties();
			    props.load(fis);
			    Enumeration keys = props.keys();
			    while (keys.hasMoreElements()){
				    String key = (String)keys.nextElement();
				    String value = (String)props.getProperty(key);
				    if(key.equals("Score1")){
					    CalculateScoreString1 = new String(value);
					    System.out.println("CalculateScoreString1"+CalculateScoreString1);
				    }else if(key.equals("Score2")){
					    CalculateScoreString2 = new String(value);
					    System.out.println("CalculateScoreString2"+CalculateScoreString2);
				    	
				    }else if(key.equals("StoreMinePrice")){
				    	StoreMinePrice = new String(value);
					    System.out.println("StoreMinePrice"+StoreMinePrice);
				    }else if(key.equals("StoreFoodPrice")){
				    	StoreFoodPrice = new String(value);
					    System.out.println("StoreFoodPrice"+StoreFoodPrice);
				    }else if(key.equals("StoreEnergyPrice")){
				    	StoreEnergyPrice = new String(value);
					    System.out.println("StoreEnergyPrice"+StoreEnergyPrice);
				    }else if(key.equals("caseNumber")){
				    	caseNumber = new String(value);
				    	System.out.println("Case Number "+caseNumber);
				    }
				}
				fis.close();
			}else{
			      System.out.println("Unable to get realpath of chatproperty file " + path + ".\nCheck that application war file is expanded and file can be read.\nChat application won't work.");
		    }
		}catch(FileNotFoundException fnfe){
			System.err.println("Properites file not found:" + fnfe.getMessage());
		} catch(IOException ioe){
		 	System.out.print("Unable to load Properties File: " + ioe.getMessage());
		}
	}
	   
    public void doPost(HttpServletRequest request,HttpServletResponse response) throws IOException{

		ServletInputStream in = request.getInputStream();
    	DataInputStream    din = new DataInputStream( in );

    	int gameNumber = din.readInt();
    	String loginStr = din.readUTF();
    	din.close();
	
		gs = new AcquireGetScore(gameNumber,loginStr,CalculateScoreString1,CalculateScoreString2,
							StoreMinePrice,StoreFoodPrice,StoreEnergyPrice,caseNumber);

		
		response.setContentType( 
                          "application/octet-stream" );
        
        ByteArrayOutputStream bout = 
                           new ByteArrayOutputStream();
    	DataOutputStream dout = 
                          new DataOutputStream( bout );

		dout.writeInt(gs.loginInGame.length);
		System.out.println(gs.loginInGame.length);
		for(int i=0;i<gs.loginInGame.length;i++){
			dout.writeUTF(gs.loginInGame[i]);
			System.out.println(gs.loginInGame[i]);
			dout.writeInt(gs.scoreInGame[i]);
			System.out.println(gs.scoreInGame[i]);
		}
		dout.writeInt(gs.loginAllGames.length);
		System.out.println(gs.loginAllGames.length);
		for(int i=0;i<gs.loginAllGames.length;i++){
			dout.writeInt(gs.AllgameNumbers[i]);
			System.out.println(gs.AllgameNumbers[i]);
			dout.writeUTF(gs.loginAllGames[i]);
			System.out.println(gs.loginAllGames[i]);
			dout.writeInt(gs.scoreAllGames[i]);
			System.out.println(gs.scoreAllGames[i]);
		}
		
        byte[] data = bout.toByteArray();
    	response.setContentLength( data.length );
    	response.setStatus( response.SC_OK );
		OutputStream out = response.getOutputStream();
    	out.write (data );
    	out.close();                       

	 	   	
	}
	
	public void doGet(HttpServletRequest request, HttpServletResponse response)
   	throws ServletException,IOException{
   		doPost(request,response);
   	}


}


class AcquireGetScore {
	
	private Connection connection=null;
	String game_score_table = "GAME_SCORE_TABLE";
	String game_positions_table = "GAME_POSITIONS_TABLE";
	
	String game_trade_table = "GAME_TRADE_TABLE";
	String game_config_table = "GAME_CONFIG_TABLE";	

	private String loginStr;
	private int intGameNumber;
	
    int[] score;	
	String scoreFormula1;
	String scoreFormula2;
	int intMinePrice;
	int intFoodPrice;
	int intEnergyPrice;
	private org.nfunk.jep.JEP myParser;
	
	String[] loginInGame;
	int[] scoreInGame;
	
	String[] loginAllGames;
	int[] scoreAllGames;
	int[] AllgameNumbers;

	int[][] mftr;
	String[] loginInScoreTable;
	int[] how_many_times;
	String[] loginInConfigTable;	
	int[][] mftConfigTimes;
	int intcaseNumber;
		
	public AcquireGetScore(int game,String login,String ScoreFormula1,String ScoreFormula2,
							String StoreMinePrice,String StoreFoodPrice,
								String StoreEnergyPrice,String caseNumber) {
		intGameNumber = game;
		loginStr = new String(login);
		if(ScoreFormula1!=null){
			scoreFormula1 = new String(ScoreFormula1);	
		}
		if(ScoreFormula2!=null){
			scoreFormula2 = new String(ScoreFormula2);
		}
		
		if(StoreMinePrice!=null){
			intMinePrice = Integer.parseInt(StoreMinePrice);
		}
		if(StoreFoodPrice!=null){
			intFoodPrice = Integer.parseInt(StoreFoodPrice);
		}
		if(StoreEnergyPrice!=null){
			intEnergyPrice = Integer.parseInt(StoreEnergyPrice);
		}
		
		if(caseNumber!=null){
			intcaseNumber = Integer.parseInt(caseNumber);
		}
		init();
	
	}

	private void init() {
		myParser = new org.nfunk.jep.JEP();
		System.out.println("myparser initialized");
		myParser.initFunTab(); // clear the contents of the function table
		System.out.println("cleared the contents of function table");
		myParser.addStandardFunctions();
		System.out.println("added standard functions");
		myParser.setTraverse(true);
		System.out.println("set traverse true");

		
		getConnection();
		int count=0;
		int count2=0;
		
		if(intcaseNumber == 1){
		
			count = getcount_game_score_table();
			if(count>0){
				score = new int[count];
				select_game_score_table(count);//get all the mine,farm, tech
				int[] sp = select_game_trade_table();
				how_many_times = new int[count];
				for(int i=0;i<count;i++){
					how_many_times[i] = calculate_nooftimes(loginInScoreTable[i]);
					score[i] = calculate_score_case1(mftr[i],sp,how_many_times[i]);
					update_game_positions_table(score[i],loginInScoreTable[i]);
				}
			}
			
		
		}else if(intcaseNumber ==2){
		
			count= getcount_game_config_table();
			if(count>0){
				score = new int[count];
				for(int i=0;i<count;i++){
					select_game_config_table(count);
					score[i] = calculate_score_case2(mftConfigTimes[i]);
					update_game_positions_table(score[i],loginInConfigTable[i]);
				}
			}
		}
		getPositionsWithinGame();
		getPositionsAllGames();
	}
	
	int calculate_score_case2(int[] mftConfigSpecTime){
		boolean b = false;
		if(scoreFormula2 != null){
			try{
				myParser.initSymTab(); // clear the contents of the symbol table
				myParser.addVariableAsObject("mine_times", new Integer(mftConfigSpecTime[0]));
				myParser.addVariableAsObject("farm_times", new Integer(mftConfigSpecTime[1]));
				myParser.addVariableAsObject("energy_times", new Integer(mftConfigSpecTime[2]));
				
				b = myParser.hasError();
				System.out.println("after adding variables"+b);
				myParser.parseExpression(scoreFormula2);
				System.out.println("after parseExpression"+myParser.hasError());
				
			}catch(Exception e){
				e.printStackTrace();
			}
		}else{
			System.out.println("prod formula string is null");
		}

		Object result=null;
		double dResult=0;
		int iResult = 0;
		String errorInfo;
		// Get the value
		try{
			result = myParser.getValueAsObject();
			System.out.println("after getValue"+myParser.hasError());
		}catch(Exception e){
			e.printStackTrace();
		}	
		
		// Is the result ok?
		if (result!=null) {
			dResult = Double.parseDouble(result.toString());
			System.out.println(dResult);
			iResult = new Double(dResult).intValue();
			System.out.println(iResult);
		} 
		
		
		// Get the error information
		if ((errorInfo = myParser.getErrorInfo()) != null) {
			System.out.println(errorInfo);
		} 

		return iResult;
		
	}
	
	
	void select_game_config_table(int count){
		loginInConfigTable= new String[count];
		mftConfigTimes = new int[count][3];
		Statement SelectStatement1=null;
		ResultSet rs1=null;
		String sql1 =null;
		int i=0;
		try{
			SelectStatement1 = connection.createStatement();
			sql1 = new String("select login,mine_num,farm_num,energy_num from "+game_config_table+
							  " where game="+intGameNumber);
							  
			rs1 = SelectStatement1.executeQuery(sql1);
			System.out.println(sql1);
			while(rs1.next()){
				loginInConfigTable[i] = rs1.getString(1);
				mftConfigTimes[i][0] = rs1.getInt(2);
				mftConfigTimes[i][1] = rs1.getInt(3);
				mftConfigTimes[i][2] = rs1.getInt(4);
				i++;
			}
			SelectStatement1.close();
			
		}catch(Exception e){
			e.printStackTrace();
		}
		
		
	}


	int getcount_game_config_table(){
		int c=0;
		Statement SelectStatement1 = null;
		String sql1= null;
		ResultSet rs1 = null;
		try{
			SelectStatement1 = connection.createStatement();
			sql1 = new String("select count(*) from "+game_config_table+
							  " where game="+intGameNumber);
							  
			rs1 = SelectStatement1.executeQuery(sql1);
			System.out.println(sql1);
			while(rs1.next()){
				c = rs1.getInt(1);
			}
			SelectStatement1.close();
		}catch(Exception e){
			e.printStackTrace();
		}
		return c;
	}
	
	
	int calculate_nooftimes(String login){
		Statement SelectStatement1= null;
		ResultSet rs1 = null;
		String sql1=null;
		int count=0;
		try{
			SelectStatement1 = connection.createStatement();
			sql1 = new String("select count(*) from "+game_trade_table+
							  " where game="+intGameNumber+" and (sellerlogin='"+
							  login+"' or buyerlogin='"+login+"' and noofunits>0)");
			rs1 = SelectStatement1.executeQuery(sql1);
			while(rs1.next()){
				count = rs1.getInt(1);
			}
			SelectStatement1.close();
		}catch(Exception e){
			e.printStackTrace();
		}
		return count;
	}
	
	int[] select_game_trade_table(){
		
		int[] retPrices = new int[3];
		
		
		Statement SelectStatement1 = null;
		ResultSet rs1 = null;
		String sql1 = null;
		Statement SelectStatement2 = null;
		ResultSet rs2 = null;
		String sql2 = null;
		int[] sp=null;
		int i=0;		
		int c=0;
		String [] gt =null;
		int totSpMine = intMinePrice;
		int totSpFood = intFoodPrice;
		int totSpEnergy = intEnergyPrice;
		int m=0;
		int f=0;
		int e=0;
		try{
			SelectStatement2 = connection.createStatement();
			sql2 = new String("select count(*) from "+game_trade_table+
							  " where game="+intGameNumber);
			System.out.println(sql2);
			rs2 = SelectStatement2.executeQuery(sql2);
			while(rs2.next()){
				c  = rs2.getInt(1);
			}
//			connection.commit();
			SelectStatement2.close();
			if(c>0){
				sp = new int[c];
				gt = new String[c];
				SelectStatement1 = connection.createStatement();
				sql1 = new String("select sp,goodstype from "+game_trade_table+
							  " where game="+intGameNumber+" and noofunits > 0");
				System.out.println(sql1);
				rs1 = SelectStatement1.executeQuery(sql1);
				while(rs1.next()){
					sp[i] = rs1.getInt(1);
					gt[i] = rs1.getString(2);
					i++;
				}
//				connection.commit();
				SelectStatement1.close();
				
				for(int j=0;j<c;j++){
					if(gt[j].equals("mine")){
						totSpMine += sp[j]; 
						m++;
					}else if(gt[j].equals("food")){
						totSpFood += sp[j]; 
						f++;
					}else if(gt[j].equals("energy")){
						totSpEnergy += sp[j]; 
						e++;
					}
					
				}
				if(totSpMine>0){
					retPrices[0] = totSpMine/m;
				}else{
					retPrices[0] = intMinePrice;
				}
				if(totSpFood>0){
					retPrices[1] = totSpFood/f;
				}else {
					retPrices[1] = intFoodPrice;
				}
				if(totSpEnergy>0){
					retPrices[2] = totSpEnergy/e;
				}else{
					retPrices[2] = intEnergyPrice;
				}
			}else if(c==0){
				retPrices[0] = intMinePrice;
				retPrices[1] = intFoodPrice;
				retPrices[2] = intEnergyPrice;
						
			}
			
		}catch(Exception ex){
			ex.printStackTrace();
		}
		
		return retPrices;
	}
	
	void getPositionsAllGames(){
		Statement SelectStatement1 = null;
		String sql1 =null;
		ResultSet rs1= null;
		Statement SelectStatement2 = null;
		String sql2 = null;
		ResultSet rs2= null;
		Statement SelectStatement3 = null;
		String sql3 = null;
		ResultSet rs3= null;

		Statement SelectStatement4 = null;
		String sql4 = null;
		ResultSet rs4= null;
		
		int count = 0;
		int i=0;
		int c=0;
		
		int[] scoreArray=null;
		
		int[] scoreTemp = null;
		String[] loginTemp = null;
		
		try{
			
			
			SelectStatement2 = connection.createStatement();
			sql2 = new String("select count(*) from game_positions_table");
			System.out.println(sql2);
			rs2 = SelectStatement2.executeQuery(sql2);
			while(rs2.next()){
				count = rs2.getInt(1);
			}
			SelectStatement2.close();
			
			AllgameNumbers = new int[count];
			loginAllGames = new String[count];
			scoreAllGames = new int[count];
			
			SelectStatement1 =connection.createStatement();
			sql1 = new String("select game,login,score from game_positions_table order by score desc");
			System.out.println(sql1);
			rs1 = SelectStatement1.executeQuery(sql1);
			
			while(rs1.next()){
				
				AllgameNumbers[i] = rs1.getInt(1);
				loginAllGames[i] = new String(rs1.getString(2));
				scoreAllGames[i] = rs1.getInt(3);
				i++;
			}
			
			SelectStatement1.close();
			
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	void getPositionsWithinGame(){
		Statement SelectStatement1= null;
		Statement SelectStatement2 = null;
		String sql1,sql2= null;
		ResultSet rs1, rs2= null;
		
		int count=0;
		int i=0;
		try{
			SelectStatement1 = connection.createStatement();
			sql1 = new String("select count(*) from "+game_positions_table+
							" where game="+intGameNumber);
			rs1 = SelectStatement1.executeQuery(sql1);
			System.out.println(sql1);
			while(rs1.next()){
				count = rs1.getInt(1);
			}
			SelectStatement1.close();
			
			if(count>0){
				loginInGame = new String[count];
				scoreInGame = new int[count];
				SelectStatement2 = connection.createStatement();
				sql2 = new String("select login,score from "+game_positions_table+
									  " where game="+intGameNumber+" order by score desc");
				rs2 = SelectStatement2.executeQuery(sql2);
				System.out.println(sql2);					  
				i=0;
				while(rs2.next()){
					loginInGame[i] = new String(rs2.getString(1));
					scoreInGame[i] = rs2.getInt(2);
					i++;
				}
				SelectStatement2.close();
			}
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	
	
	int getPosition(){
		int pos=-1;
		
		Statement SelectStatement1 = null;
		String sql1 = null;
		ResultSet rs1 = null;
		
		Statement SelectStatement2 = null;
		String sql2 = null;
		ResultSet rs2 = null;
		
		
		int count =0;
		String[] loginArr = null;
		int i=0;
	    boolean posSet =false;
		try{
			SelectStatement1 = connection.createStatement();
			sql1 = new String("select count(*) from "+game_positions_table+
							  " where game="+intGameNumber);
			rs1 = SelectStatement1.executeQuery(sql1);
			System.out.println(sql1);
			while(rs1.next()){
				count = rs1.getInt(1);
			}
			SelectStatement1.close();
//			connection.commit();
			if(count > 0){
				if(count == 1){
					pos=1;
				}else {
					loginArr = new String[count];
					SelectStatement2 = connection.createStatement();
					sql2 = new String("select login from "+game_positions_table+
									  " where game="+intGameNumber+
									  " order by score desc");
					System.out.println(sql2);
					rs2 = SelectStatement2.executeQuery(sql2);
					i=0;
					while(rs2.next()){
						loginArr[i] = new String(rs2.getString(1));
						
						
						i++;
					}
					SelectStatement2.close();
//					connection.commit();
					for(int j=0;j<count;j++){
						if(loginArr[j].equals(loginStr)){
							pos = j+1;
							posSet = true;
						}
						if(posSet == true){
							break;
						}
						
					}
					
				}
				
			}			
			
		}catch(Exception e){
			e.printStackTrace();
			
		}
		
		return pos;
	}
	
	void  select_game_score_table(int count){
		Statement SelectStatement1 = null;
		ResultSet rs1 =null;
		String sql1 = null;
		mftr = new int[count][4];
		loginInScoreTable = new String[count];
		int i=0;
		try{
			SelectStatement1 = connection.createStatement();
			sql1 = new String("select login,mine_units,food_units,energy_units,rokda_units from "+game_score_table+ 
							  " where game="+intGameNumber);
			rs1 = SelectStatement1.executeQuery(sql1);
			System.out.println(sql1);
			i=0;
			while(rs1.next()){
				loginInScoreTable[i] = rs1.getString(1);
				mftr[i][0] = rs1.getInt(2);
				mftr[i][1] = rs1.getInt(3);
				mftr[i][2] = rs1.getInt(4);
				mftr[i][3] = rs1.getInt(5);
				i++;
			}
			SelectStatement1.close();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	int getcount_game_score_table(){
		Statement SelectStatement1 = null;
		ResultSet rs1 =null;
		String sql1 = null;
		int count=0;
		try{
			SelectStatement1 = connection.createStatement();
			sql1 = new String("select count(*) from "+game_score_table+ 
							  " where game="+intGameNumber);
			rs1 = SelectStatement1.executeQuery(sql1);
			System.out.println(sql1);
			while(rs1.next()){
				count = rs1.getInt(1);
			}
			SelectStatement1.close();
//			connection.commit();
		}catch(Exception e){
			e.printStackTrace();
		}
		return count;
	}


	
	void insert_game_score_table(){
		Statement InsertStatement1 = null;
		String sql1 = null;
		try{
			InsertStatement1 = connection.createStatement();
			sql1 = new String("insert into "+game_score_table+
							   "(game,login,mine_units,food_units,energy_units,rokda_units) values ("+
							   intGameNumber+",'"+loginStr+"',"+0+","+0+","+0+","+0+")");
			InsertStatement1.executeUpdate(sql1);
			System.out.println(sql1);
//			connection.commit();
			InsertStatement1.close();
		}catch(Exception e){
			e.printStackTrace();
		}	
	}
	

	
	void update_game_positions_table(int scoreSpecific, String loginSpecific){
		Statement SelectStatement1 = null;
		String sql2 =null;
		ResultSet rs1 =null;
		int c=0;
		Statement UpdateStatement1 = null;
		String sql1 = null;
		Statement InsertStatement1=null;
		String sql3 =null;
		
		try{
			SelectStatement1 = connection.createStatement();
			sql2 = new String("select count(*) from "+game_positions_table+
							  " where game="+intGameNumber+" and login='"+loginSpecific+"'");
			System.out.println(sql2);
			rs1 = SelectStatement1.executeQuery(sql2);
			while(rs1.next()){
				c = rs1.getInt(1);
			}
			SelectStatement1.close();
			if(c > 0){
				UpdateStatement1 = connection.createStatement();
				sql1 = new String("update "+game_positions_table+
							   " set score="+scoreSpecific+
							   //" ,timestamp=current_timestamp"+
							   " where game="+intGameNumber+
							   " and login='"+loginSpecific+"'");
			
				UpdateStatement1.executeUpdate(sql1);
				System.out.println(sql1);
	//			connection.commit();
				UpdateStatement1.close();
				
			}else if(c==0){
				InsertStatement1 = connection.createStatement();
				sql3 = new String("insert into "+game_positions_table+
								  "(game,login,score) values("+
								  intGameNumber+",'"+loginSpecific+"',"+scoreSpecific+")");
				System.out.println(sql3);
				InsertStatement1.executeUpdate(sql3);
				InsertStatement1.close();
				
			}
		}catch(Exception e){
			e.printStackTrace();
		}	
		
	
		
	}
	
	int calculate_score_case1(int[] mftrSpecific,int[] sprice,int nooftimes){
		boolean b = false;
		if(scoreFormula1 != null){
			try{
				myParser.initSymTab(); // clear the contents of the symbol table
				myParser.addVariableAsObject("mu", new Integer(mftrSpecific[0]));
				myParser.addVariableAsObject("msp", new Integer(sprice[0]));
				myParser.addVariableAsObject("fu", new Integer(mftrSpecific[1]));
				myParser.addVariableAsObject("fsp", new Integer(sprice[1]));
				myParser.addVariableAsObject("eu", new Integer(mftrSpecific[2]));
				myParser.addVariableAsObject("esp", new Integer(sprice[2]));
				myParser.addVariableAsObject("ru", new Integer(mftrSpecific[3]));
				myParser.addVariableAsObject("nooftimestraded",new Integer(nooftimes));
				b = myParser.hasError();
				System.out.println("after adding variables"+b);
				myParser.parseExpression(scoreFormula1);
				System.out.println("after parseExpression"+myParser.hasError());
				
			}catch(Exception e){
				e.printStackTrace();
			}
		}else{
			System.out.println("prod formula string is null");
		}

		Object result=null;
		double dResult=0;
		int iResult = 0;
		String errorInfo;
		// Get the value
		try{
			result = myParser.getValueAsObject();
			System.out.println("after getValue"+myParser.hasError());
		}catch(Exception e){
			e.printStackTrace();
		}	
		
		// Is the result ok?
		if (result!=null) {
			dResult = Double.parseDouble(result.toString());
			System.out.println(dResult);
			iResult = new Double(dResult).intValue();
			System.out.println(iResult);
		} 
		
		
		// Get the error information
		if ((errorInfo = myParser.getErrorInfo()) != null) {
			System.out.println(errorInfo);
		} 

		return iResult;
	}
	
		private void getConnection(){
		try {
			Class.forName  ("com.mysql.jdbc.Driver");

		} catch(ClassNotFoundException ej){
			System.out.println("Problem 1");
			ej.printStackTrace();
		}
		String dbURL   = "jdbc:mysql://localhost/muledb";
		String username="root", password="";
		try{
			connection=DriverManager.getConnection(dbURL,username,password);
		} catch (Exception ex){
			System.out.println("Problem 3");
			ex.printStackTrace();
		}
	}

	
	
}


