package edu.sjsu.cs298.mymule.core;

import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.lang.StringBuffer;
import java.io.*;
import java.util.*;
import java.io.IOException;

/**
 * @author Rekha
 * The servlet that registers the player with the Server
 */
//hi
public class AcquireRegistrationServlet extends HttpServlet{
	   
       AcquireRegisterInfo rg = null;
	   
	   public void doPost(HttpServletRequest request,HttpServletResponse response) throws IOException{

    	// Get the input stream and read the data...
		ServletInputStream in = request.getInputStream();
    	DataInputStream    din = new DataInputStream( in );

    	String login = din.readUTF();
    	String pwd = din.readUTF();
    	din.close();
	
		String userLogin;			
		rg = new AcquireRegisterInfo(login,pwd);


		userLogin= new String(rg.getLogin());
		
		response.setContentType( 
                          "application/octet-stream" );
        System.out.println(userLogin);
        
        ByteArrayOutputStream bout = 
                           new ByteArrayOutputStream();
    	DataOutputStream dout = 
                          new DataOutputStream( bout );
		
		dout.writeUTF(userLogin);
        byte[] data = bout.toByteArray();
                 
    	response.setContentLength( data.length );
    	response.setStatus( response.SC_OK );
		

		OutputStream out = response.getOutputStream();
    	out.write (data );
    	out.close();                       

	 	   	
	}
	
	public void doGet(HttpServletRequest request, HttpServletResponse response)
   	throws ServletException,IOException{
   		doPost(request,response);
   	}


}


class AcquireRegisterInfo {
	
	private Connection connection=null;
	String players_table = "PLAYERS_TABLE";
	
	private String loginStr;
	private String pwdStr; 
	private String approvedLogin = null;

	public AcquireRegisterInfo(String login, String pwd) {
		loginStr = new String(login);
		pwdStr = new String(pwd);
		approvedLogin = new String(loginStr);
		init();
	
	}

	private void init() {
		getConnection();
		
		update_players_table(loginStr,pwdStr);
	}
	
		private void getConnection(){
		try {
			Class.forName("com.mysql.jdbc.Driver").newInstance();

		} catch(Exception ej){
			System.out.println("Problem 1");
			ej.printStackTrace();
		}
		String dbURL   = "jdbc:mysql://localhost/muledb";
		String username="root", password="";
		try{
			connection=DriverManager.getConnection(dbURL,username,password);
		} catch (Exception ex){
			System.out.println("Problem 3");
			ex.printStackTrace();
		}
	}

	private void update_players_table(String login, String pwd) {
		
		Statement InsertOnPlayersTable = null;
		Statement SelectOnPlayersTable1 = null;
		Statement SelectOnPlayersTable2 = null;
		
		String sql1,sql2,sql3;
		ResultSet rs1,rs2;
		
		int count = 0;
		String [] loginArray;
		String [] pwdArray;
		boolean changed = false;
		
		try{
			SelectOnPlayersTable1=connection.createStatement();
		    sql1= new String("select count(*) from "+players_table);
		    System.out.println(sql1);
    		rs1 = SelectOnPlayersTable1.executeQuery(sql1);
	   		while(rs1.next()){
    			count = rs1.getInt(1);
    			System.out.println("COUNT"+count);
    		}
			SelectOnPlayersTable1.close();
			
			if(count>0){
				//now check for the login conflict
				SelectOnPlayersTable2 = connection.createStatement();
				sql2 = new String("select * from "+players_table);
			    System.out.println(sql2);
    			rs2 = SelectOnPlayersTable2.executeQuery(sql2);
    			int i=0;
    			loginArray = new String[count];
    			pwdArray = new String[count];
    			
    			while(rs2.next()){
    				loginArray[i] = rs2.getString(1);
    				pwdArray[i] = rs2.getString(2);
    				System.out.println("loginArray["+i+"]"+loginArray[i]);
    				System.out.println("pwdArray["+i+"]"+pwdArray[i]);
    				i++;
    			}
				SelectOnPlayersTable1.close();
				System.out.println("i"+i);

				for(int j = 0 ; j < i ; j++){
					if(loginArray[j].equals(loginStr)){
						System.out.println("Conflict");
						approvedLogin = new String("change"+loginStr);
						System.out.println("approvedLogin changed"+approvedLogin);
						changed = true;
					}else{
						approvedLogin = new String(loginStr);
						System.out.println("approvedLogin not changed"+approvedLogin);
					}
					
					if(changed)
					break;
				}
				
				
			}
			if(!changed){
			InsertOnPlayersTable = connection.createStatement();
			sql3 = new String("INSERT INTO "+players_table+" (login,password,game,color)" 
							+"values ('"+approvedLogin+"','"+pwdStr+"',"+0+",'not_valid')"); 
    		System.out.println(sql3);
			InsertOnPlayersTable.executeUpdate(sql3);
			InsertOnPlayersTable.close();
			}
			
		} catch(Exception ex) 	{
			System.out.println("Problem problem problem");
			System.err.println("SQLException: " + ex.getMessage());
			ex.printStackTrace();
		}
   }

	
	
	/**
	 * @return
	 */
	public String getLogin() {
		
		return approvedLogin;
	}
	
	
	
}


